unit JConfig;
(* Jane2ch ̃RtBO[V *)
(* Copyright (c) 2001,2002 Twiddle <hetareprog@hotmail.com> *)

interface

uses
  SysUtils, Forms, Classes, IniFiles, Windows, Graphics,
  UDoLib,
  UCryptAuto,
  USynchro,
  {$IFNDEF IE}
  HogeTextView,
  {$ENDIF}
  StrSub,
  UBase64;

type
  TGestureOprType = (gotNOP=0, gotLOCAL=1, gotGRACEFUL=2, gotCHECK=3);
  TGestureType = (gtClick, gtDblClk, gtMenu, gtOther);
  TTabAddPos = (tapFirst, tapLeft, tapRight, tapEnd);
  TTabClosePos = (tcpLeft, tcpRight);

  TFontInfo = record
    face: string;
    charset: integer;
    height: integer;
    size: integer;
    style: integer;
    color: integer; //Fǉ
  end;

  TJaneConfig = class(TObject)
  private
    function GetFullPath(path: string): string;
  protected
    AccPath: string;
  public
    BasePath: string; (* \  *)
    IniPath: string;
    LogBasePath: string; (* \  *)
    LogConfPath: string;
    SkinPath: string; (* \  *)
    SkinConfPath: string;

    proxyCrt: THogeCriticalSection;

    netUseProxy: boolean;
    netProxyServer: string;
    netProxyPort: integer;
    netProxyServerForWriting: string;
    netProxyPortForWriting  : integer;
    netProxyServerForSSL: string;
    netProxyPortForSSL: integer;
    netReadTimeout: integer;
    netOnline: boolean;
    netUseReadCGI: boolean;
    netRecvBufferSize: integer;
    netNoCache: boolean;

    extBrowserSpecified: boolean;
    extBrowserPath: string;

    bbsMenuURL: string;
    bbs2chServers: TStringList;
    bbsMachiServers: TStringList;
    bbsJBBSServers: TStringList;
    (*
    bbsMenuFetchOnStart: boolean;
    *)

    hintEnabled: boolean;
    hintHoverTime: Cardinal;
    hintHintHoverTime: Cardinal;
    hintForOtherThread: boolean;
    hintNestingPopUp: boolean;       (* d|bvAbv *)
    hintAutoEnableNesting: boolean;
    hintHintAutoEnableNesting: boolean;
    hintForURL: boolean;             (* URL|CgɂтƎ擾 *)
    hintForURLMaxLine: integer;      (* ̂Ƃ̍s *)
    hintForURLMaxSize: integer;
    hintForURLWidth:  integer;
    hintForURLHeight: integer;
    hintForURLUseHead: boolean;
    hintForURLWaitTime: integer;
    hintCancelGetExt: TStringList;

    oprCatBySingleClick: boolean;
    oprShowSubjectCache: boolean;  (* Xꗗ̃LbV\ *)
    oprSelPreviousThread: boolean; (* XꗗňȑÕXI *)
    oprScrollToPreviousRes: boolean;    (* Ō㌩ɃWv *)
    oprScrollToNewRes: boolean;    (* VXɃWv *)
    oprScrollTop: boolean;         (* true:ɕ\^false:iɕ\ *)
    oprToggleRView: boolean;
    //oprAlwaysCheck: boolean;       (* obsoleted by oprGesture.* *)
    //oprTabStopOnTracePane: boolean;
    oprDisableTabKeyInView: boolean;     (* uEUTABL[ *)
    oprBoardTreeExpandOneCategory: boolean;
    oprCheckNewWRedraw: boolean;

    //oprAlwaysCreateNewView: boolean; (* renamed. 0.2.0.2 *)
    oprOpenThreWNewView: boolean; (* V^uŃXJ 0.2.0.2 *)
    oprOpenFavWNewView: boolean;  (* V^ułCɓXJ0.2.0.2 *)
    oprOpenBoardWNewTab: boolean;
    oprDrawLines: integer;

    oprGestureBrdClick:  TGestureOprType;
    oprGestureBrdDblClk: TGestureOprType;
    oprGestureBrdMenu:   TGestureOprType;
    oprGestureBrdOther:  TGestureOprType;
    oprGestureThrClick:  TGestureOprType;
    oprGestureThrDblClk: TGestureOprType;
    oprGestureThrMenu:   TGestureOprType;
    oprGestureThrOther:  TGestureOprType;

    oprThreBgOpen  : boolean;
    oprFavBgOpen   : boolean;
    oprClosedBgOpen: boolean;
    oprAddrBgOpen  : boolean;
    oprUrlBgOpen   : boolean;

    oprAddPosNormal: TTabAddPos;
    oprAddPosRelative: TTabAddPos;
    oprClosetPos: TTabClosePos;

    optEnableBoardMenu: boolean;
    optEnableFavMenu: boolean;
    optDateTimeFormat: string;
    optMonthNames: string;
    optDayOfWeek: string;

    optCharsInTab: integer;
    //optShowCacheOnBoot: boolean;
    optSaveLastItems: boolean;
    optAutoSort: boolean;
    optAllowFavoriteDuplicate: boolean;
    optLogListLimitCount: integer;
    optHomeIfSubjectIsEmpty: Boolean;

    tstCommHeaders: boolean;
    tstCloseAfterWriting: boolean;
    tstWrtCookie: string;

    brdRecyclableCount: Integer;

    compressRatio: double;
    compressRatioSamples: cardinal;

    datDeleteOutOfTime: boolean;

    tstAuthorizedAccess: boolean; (* *)
    tstEnableHTTPTrace: boolean;
    tstDebugEnabled: boolean;
    tmpPassphrase: string;

    viewZoomSize: integer;

    viewTreeFontInfo: TFontInfo;
    viewTraceFontInfo: TFontInfo;
    viewDefFontInfo: TFontInfo;
    viewListFontInfo: TFontInfo; //Xʂɐݒ
    viewThreadTitleFontInfo: TFontInfo; //[457]
    viewWriteFontInfo: TFontInfo;
    viewHintFontInfo: TFontInfo;
    viewHintFontLinkColor: TColor;
    viewNGMsgMarker: string;
    viewTransparencyAbone: boolean;
    viewListMarkerNone: string;
    viewListMarkerRead: string;
    viewListMarkerReadWNewMsg: string;
    viewListMarkerReadWMsg: string;
    viewListMarkerReadNoUpdate: string;
    viewListMarkerMarked: string;
    viewListMarkerMarkedWNewMsg: string;
    viewListMarkerMarkedWMsg: string;
    viewListMarkerMarkedNoUpdate: string;

    {$IFNDEF IE}
    viewVerticalCaretMargin: integer;
    viewScrollLines: integer;
    viewPageScroll: boolean;
    viewTextAttrib: array[THogeAttribute] of THogeTextAttrib;
    viewCaretVisible : boolean;
    {$ENDIF}
    viewZoomPointArray: array[0..5] of integer;

    stlVerticalDivision: boolean;
    stlToolBarVisible: boolean;
    stlLinkBarVisible: boolean;
    stlAddressBarVisible: boolean;
    stlTreeVisible: boolean;
    stlThreadToolBarVisible: boolean;
    stlThreadTitleLabelVisible: boolean;
    stlClmnArray: array[0..9] of Integer;

    stlTabStyle: integer;
    stlListTabStyle: integer;
    stlTreeTabStyle: integer;
    stlTabMultiline: boolean;
    stlTabWidth: integer;
    stlTabHeight: integer;
    stlListTabWidth: integer;
    stlListTabHeight: integer;

    stlMenuIcons: boolean;
    stlLinkBarIcons: boolean;
    stlTabIcons: boolean;
    stlTreeIcons: boolean;
    stlListMarkIcons: boolean;
    stlListTitleIcons: boolean;
    stlListViewUseExtraBackColor: boolean;
    stlShowTreeMarks: boolean;

    wrtFormTop:Integer;
    wrtFormLeft:Integer;
    wrtFormHeight:Integer;
    wrtFormWidth:Integer;

    wrtRecordWriting: boolean;
    wrtRecordNameMail: boolean; //521
    wrtFormStayOnTop: boolean; //521
    wrtDefaultSageCheck: boolean;
    wrtReplyMark: string;
    wrtShowThreadTitle: boolean;
    wrtNameList: TStringList;
    wrtMailList: TStringList;
    wrtFmUseTaskBar: boolean;
    wrtUseDefaultName: boolean;
    wrtDiscrepancyWarning: Boolean;
    wrtDisableStatusBar: Boolean;
    wrtAutoAgreement: Boolean;
    wrtAdditionalAgreementField: String;

    grepPopup: boolean;
    grepPopMaxSeq: integer;
    grepPopEachThreMax: integer;

    mseUseWheelTabChange: boolean;
    mseGestureMargin: integer;
    mseGestureList: TStringList;

    {$IFNDEF IE}
    clViewColor: TColor;
    {$ENDIF}
    clListViewOddBackColor: TColor;
    clListViewEvenBackColor: TColor;
    clHintOnFix: TColor;

    cmdExecuteList: TStringList;
    cmdConfigList:  TStringList;

    accUserID: string;
    accPasswd: string;
    accAutoAuth: boolean;
    tmpChanged: boolean;
    accPassphrasedPasswd: string;

    ColorChanged: boolean;
    FontChanged: boolean;
    StyleChanged: boolean;

    Modified: boolean;
    constructor Create;
    destructor Destroy; override;
    procedure Initialize;
    procedure Load;
    procedure Save;
    procedure SaveWriteFormPos(Rect: TRect); //beginner

    procedure AddSample(compressed, uncompressed: cardinal);
    procedure SetDateTimeFormat;
    procedure SetFontInfo(var info: TFontInfo; font: TFont);
    procedure SetFont(var font: TFont; info: TFontInfo);
  end;

const
  INI_WIN_SECT: string = 'WINDOW';
  INI_PATH_SECT: string = 'PATH';
  INI_NET_SECT: string = 'NET';
  INI_LOG_SECT: string = 'LOGS';
  INI_BBS_SECT: string = 'BBSMENU';
  INI_EXT_SECT: string = 'EXTERNAL';
  INI_OPT_SECT: string = 'OPTIONS';
  INI_OPR_SECT: string = 'OPERATION';
  INI_VIEW_SECT:string = 'VIEW';
  INI_TEST_SECT: string = 'TEST';
  INI_DAT_SECT: string = 'DAT';
  INI_USER_SECT: string = 'USER2CH';
  INI_STL_SECT: string = 'STYLE';
  INI_WRT_SECT: string = 'WRITE';
  INI_GREP_SECT: string = 'GREP';
  INI_CL_SECT: string = 'COLOR';
  INI_MSE_SECT: string = 'MOUSE';

  MOUSE_FILE: string = 'mouse.dat';
  COMMAND_FILE: string = 'command.dat';
  ATTRIBUTE_FILE: string = 'attrib.ini';
  INI_ATTRIB_SECT: string = 'ATTRIBUTE';
  AALIST_FILE: string = 'AAlist.txt';

(*=======================================================*)
implementation
(*=======================================================*)
uses
  Main;

function BitToFontStyles(bit: integer): TFontStyles;
begin
  result := [];
  if (bit and $1) <> 0 then
    Include(result, fsBold);
  if (bit and $2) <> 0 then
    Include(result, fsItalic);
  if (bit and $4) <> 0 then
    Include(result, fsUnderline);
  if (bit and $8) <> 0 then
    Include(result, fsStrikeOut);
end;

function StylesToBit(Style: TFontStyles): Integer;
begin
  result := 0;
  if fsBold in Style then
    Inc(result, $1);
  if fsItalic in Style then
    Inc(result, $2);
  if fsUnderline in Style then
    Inc(result, $4);
  if fsStrikeOut in Style then
    Inc(result, $8);
end;


(*  *)
constructor TJaneConfig.Create;
begin
  inherited;
  proxyCrt :=THogeCriticalSection.Create;
  Initialize;
end;

destructor TJaneConfig.Destroy;
begin
  proxyCrt.Free;
  bbs2chServers.Free;
  bbsMachiServers.Free;
  bbsJBBSServers.Free;
  hintCancelGetExt.Free;
  wrtNameList.Free;
  wrtMailList.Free;
  cmdExecuteList.Free;
  cmdConfigList.Free;
  mseGestureList.Free;
  inherited;
end;

(*  *)
procedure TJaneConfig.Initialize;
var
  i: integer;
  {$IFNDEF IE}
  procedure InitTextAttrib;
  var
    i: integer;
  begin
    for i := 0 to SizeOf(viewTextAttrib) div SizeOf(THogeTextAttrib) -1 do
    begin
      with viewTextAttrib[i] do
      begin
        color := clWindowText;
        style := [];
      end;
    end;
    viewTextAttrib[1].style := [fsBold];
    viewTextAttrib[2].color := clBlue;
    viewTextAttrib[2].style := [fsUnderline];
    viewTextAttrib[3].color := clBlue;
    viewTextAttrib[3].style := [fsBold, fsUnderline];
    viewTextAttrib[4].color := RGB($22,$8B,$22);
    viewTextAttrib[5].color := RGB($22,$8B,$22);
    viewTextAttrib[5].style := [fsBold];
  end;
  {$ENDIF}
begin
  BasePath := ExtractFilePath(Application.ExeName);
  IniPath := ChangeFileExt(Application.ExeName, '.ini');
  LogBasePath := BasePath;
  LogConfPath := '';
  SkinPath := BasePath;
  SkinConfPath := '';
  AccPath := BasePath + 'account.cfg';

  netUseProxy := false;
  netProxyPort   := 0;
  netProxyPortForWriting := 0;
  netProxyPortForSSL := 0;
  netReadTimeout := 30000;
  netRecvBufferSize := 32; (* GRecvBufferSizeDefault==1024*32 *)
  netOnline := true;
  netUseReadCGI := False;
  netNoCache := false;

  extBrowserSpecified:= false;
  extBrowserPath:='';

//  bbsMenuURL := 'http://www.dd.iij4u.or.jp/~cap/bbsmenu.html';
//  bbsMenuURL := 'http://www.2ch.net/newbbsmenu.html';
//  bbsMenuURL := 'http://www6.ocn.ne.jp/~mirv/2chmenu.html';
//  bbsMenuURL := 'http://www.ff.iij4u.or.jp/~ch2/bbsmenu.html';
  bbsMenuURL := 'http://menu.2ch.net/bbsmenu.html';
  bbs2chServers := TStringList.Create;
  bbsMachiServers := TStringList.Create;
  bbsJBBSServers := TStringList.Create;
  (*
  bbsMenuFetchOnStart := true;
  *)

  hintEnabled := true;
  hintHoverTime := 300;
  hintHintHoverTime := 300;
  hintForOtherThread := true;
  hintNestingPopUp := true;
  hintAutoEnableNesting := false;
  hintHintAutoEnableNesting := false;
  hintForURL := false;
  hintForURLMaxLine := 30;
  hintForURLMaxSize:= 2048;
  hintForURLWidth:= 400;
  hintForURLHeight:= 200;
  hintForURLUseHead:= true;
  hintForURLWaitTime := 1000;
  hintCancelGetExt := TStringList.Create;

  oprCatBySingleClick := true;
  oprShowSubjectCache := false;
  oprSelPreviousThread := false;
  oprScrollToPreviousRes := true;
  oprScrollToNewRes := false;
  oprScrollTop := true;
  oprToggleRView := false;
  //oprAlwaysCheck := false;
  //oprTabStopOnTracePane := false;
  oprDisableTabKeyInView := true;
  oprBoardTreeExpandOneCategory := false;
  oprCheckNewWRedraw := false;
  oprDrawLines := 0;

  //oprAlwaysCreateNewView := false;
  oprOpenThreWNewView := false;
  oprOpenFavWNewView := true;
  oprOpenBoardWNewTab := false;

  oprGestureBrdClick := gotLOCAL;
  oprGestureBrdDblClk:= gotCHECK;
  oprGestureBrdMenu  := gotCHECK;
  oprGestureBrdOther := gotGRACEFUL;
  oprGestureThrClick := gotGRACEFUL;
  oprGestureThrDblClk:= gotCHECK;
  oprGestureThrMenu  := gotGRACEFUL;
  oprGestureThrOther := gotGRACEFUL;

  oprThreBgOpen   := false;
  oprFavBgOpen    := false;
  oprClosedBgOpen := false;
  oprAddrBgOpen   := false;
  oprUrlBgOpen    := false;

  oprAddPosNormal := tapEnd;
  oprAddPosRelative := tapEnd;
  oprClosetPos := tcpRight;

  optEnableBoardMenu := true;
  optEnableFavMenu := true;
  optDateTimeFormat := 'yy/mm/dd hh:mm';
  optMonthNames := 'Jan,Feb,Mar,Apr,May,Jun,Jul,Aug,Sep,Oct,Nov,Dec';
  optDayOfWeek  := 'Sun,Mon,Tue,Wed,Thu,Fri,Sat';
  optHomeIfSubjectIsEmpty := True;

  optCharsInTab := 10;
  //optShowCacheOnBoot := true;
  optSaveLastItems := false;
  optAutoSort := false;
  optAllowFavoriteDuplicate := false;
  optLogListLimitCount := 0;

  tstCommHeaders := false;
  tstCloseAfterWriting := true;
  tstEnableHTTPTrace := false;
  tstDebugEnabled := false;

  brdRecyclableCount := 5;

  compressRatio := 0.5;
  compressRatioSamples := 0;

  datDeleteOutOfTime := false;

  tstAuthorizedAccess := false; (* Ή *)

  accUserID := '';
  accPasswd := '';
  accAutoAuth := false;
  tmpChanged := false;
  accPassphrasedPasswd := '';

  viewZoomSize := 2; (*  *)

  viewNGMsgMarker := 'ځ`';
  viewTransparencyAbone := false;
  viewListMarkerNone := '';
  viewListMarkerRead := 'E';
  viewListMarkerReadWNewMsg := 'I';
  viewListMarkerReadWMsg    := 'H';
  viewListMarkerReadNoUpdate:= '';
  viewListMarkerMarked   := '';
  viewListMarkerMarkedWNewMsg := '';
  viewListMarkerMarkedWMsg    := '';
  viewListMarkerMarkedNoUpdate:= '';

  {$IFNDEF IE}
  viewVerticalCaretMargin := 1;
  viewScrollLines := 3;
  viewPageScroll := false;
  viewCaretVisible := true;
  InitTextAttrib;
  {$ENDIF}

  {beginner} //ifndefړ
  viewZoomPointArray[0] := -9;
  viewZoomPointArray[1] := -10;
  viewZoomPointArray[2] := -12;
  viewZoomPointArray[3] := -14;
  viewZoomPointArray[4] := -15;
  {/beginner}


  stlVerticalDivision := false;
  stlToolBarVisible := true;
  stlLinkBarVisible := true;
  stlAddressBarVisible := true;
  stlTreeVisible := true;
  stlThreadToolBarVisible := true;
  stlThreadTitleLabelVisible := true;

  for i := 0 to High(stlClmnArray) do
    stlClmnArray[i] := i;

  stlTabStyle     := 2;  // tsFlatButtons
  stlListTabStyle := 2;  // tsFlatButtons
  stlTreeTabStyle := 0;  // tsTabs
  stlTabMultiline := true;
  stlTabWidth := 0;
  stlTabHeight := 20;
  stlListTabWidth := 0;
  stlListTabHeight := 20;

  stlMenuIcons := false;
  stlLinkBarIcons := false;
  stlTabIcons := false;
  stlTreeIcons := true;
  stlListMarkIcons := true;
  stlListTitleIcons := true;
  stlListViewUseExtraBackColor := false;
  stlShowTreeMarks := true;

  wrtFormTop:=145;
  wrtFormLeft:=274;
  wrtFormHeight:=339;
  wrtFormWidth:=491;

  wrtRecordWriting := false;
  wrtRecordNameMail := false; //521
  wrtFormStayOnTop := false; //521
  wrtDefaultSageCheck := true;
  wrtReplyMark := '>>';
  wrtShowThreadTitle := true;
  wrtNameList := TStringList.Create;
  wrtMailList := TStringList.Create;
  wrtFmUseTaskBar := false;
  wrtUseDefaultName := false;
  wrtDiscrepancyWarning := True;
  wrtDisableStatusBar := False;
  wrtAutoAgreement := False;
  wrtAdditionalAgreementField := '';

  grepPopup := true;
  grepPopMaxSeq := 5;
  grepPopEachThreMax := 10;

  mseUseWheelTabChange := false;
  mseGestureMargin := Screen.Height div 40;
  mseGestureList := TStringList.Create;

  {$IFNDEF IE}
  clViewColor := clWindow;
  {$ENDIF}
  clListViewOddBackColor := clMoneyGreen;
  clListViewEvenBackColor := clCream;
  clHintOnFix := $00efffef;

  cmdExecuteList := TStringList.Create;
  cmdConfigList :=  TStringList.Create;

  ColorChanged := false;
  FontChanged  := false;
  StyleChanged := false;

  Modified := False;
end;

procedure TJaneConfig.SetDateTimeFormat;
var
  strList: TStringList;
  i: integer;
begin
  strList := TStringList.Create;
  strList.CommaText := self.optMonthNames;
  for i := 0 to strList.Count -1 do
  begin
    if 12 <= i then
      break;
    ShortMonthNames[i + 1] := strList.Strings[i];
  end;
  strList.Clear;
  strList.CommaText := self.optDayOfWeek;
  for i := 0 to strList.Count -1 do
  begin
    if 7 <= i then
      break;
    ShortDayNames[i + 1] := strList.Strings[i];
  end;
  strList.Free;
end;

(*  *)
procedure TJaneConfig.Load;
  procedure ExtractFontInfo(var info: TFontInfo; const str: string);
  var
    strList: TStringList;
  begin
    info.face := ''; //'lr oSVbN';
    info.charset := SHIFTJIS_CHARSET;
    info.height := -12;
    info.size := -9;
    info.style := 0;
    info.color := clWindowText;
    strList := TStringList.Create;
    try
      strList.CommaText := str;
      info.face := strList.Strings[0];
      info.charset := StrToInt(strList.Strings[1]);
      info.height := StrToInt(strList.Strings[2]);
      info.size  := StrToInt(strList.Strings[3]);
      info.style := StrToInt(strList.Strings[4]);
      info.color := HexToInt(strList.Strings[5]);
    except
    end;
    strList.Free;
  end;

  {$IFNDEF IE}
  procedure LoadTextAttribute(ini: TMemIniFile);
  var
    sl: TStringList;
    s: string;
    index: integer;
  begin
    sl := TStringList.Create;
    for index := 0 to High(THogeAttribute) div 2 do
    begin
      s := ini.ReadString(INI_ATTRIB_SECT, 'TextAttrib' + IntToStr(index), '');
      if length(s) <= 0 then
        continue;
      with viewTextAttrib[index*2] do
      begin
        color := clWindowText;
        style := [];
      end;
      with viewTextAttrib[index*2+1] do
      begin
        color := clWindowText;
        style := [fsBold];
      end;
      sl.CommaText := s;
      if 2 <= sl.Count then
      begin
        try
          with viewTextAttrib[index*2] do
          begin
            color := HexToInt(sl[0]);
            style := BitToFontStyles(StrToInt(sl[1]));
          end;
          with viewTextAttrib[index*2+1] do
          begin
            color := viewTextAttrib[index*2].color;
            style := viewTextAttrib[index*2].style + [fsBold];
          end;
        except
        end;
      end;
    end;
    sl.Free;
  end;
  {$ENDIF}

  procedure LoadAccount;
  var
    ini: TMemIniFile;
    cryptObj: THogeCryptAuto;
    plainStream, cryptedStream: TStringStream;
    savePasswd: string;
  begin
    if not FileExists(AccPath) then
      exit;
    ini := TMemIniFile.Create(AccPath);
    accUserID := ini.ReadString(INI_USER_SECT, 'UserID', accUserID);
    savePasswd := ini.ReadString(INI_USER_SECT, 'Passwd', '');
    accPassphrasedPasswd := ini.ReadString(INI_USER_SECT, 'ALT', accPassphrasedPasswd);
    accAutoAuth := ini.ReadBool(INI_USER_SECT, 'Auto', accAutoAuth);

    accPasswd := ini.ReadString(INI_USER_SECT, 'Password', accPasswd);

    cryptObj := nil;
    plainStream := nil;
    cryptedStream := nil;
    if (0 < length(accPasswd)) then
    begin
      ; (* eXgpAJEg *)
    end
    else if (length(savePasswd) <= 0) or (length(accUserID) <= 0) then
    begin
      ;(* AJEg͐ݒ肳ĂȂ *)
    end
    else begin
      cryptObj := THogeCryptAuto.Create;
      plainStream := TStringStream.Create('');
      try
        cryptedStream := TStringStream.Create(HogeBase64Decode(savePasswd));
        if cryptObj.Decrypt(cryptedStream, '', plainStream) then
          accPasswd := plainStream.DataString
        else
          raise Exception.Create('');
      except
        Application.MessageBox('pX[hȂȂႢ܂'#13#10'[ݒ]-[User]','H');
      {
      // Íĕۑ
      if Assigned(cryptedStream) then
        cryptedStream.Free;
      cryptedStream := TStringStream.Create('');
      if Assigned(plainStream) then
        plainStream.Free;
      plainStream := TStringStream.Create(accPasswd);
      if cryptObj.Encrypt(plainStream, '', cryptedStream) then
        ini.WriteString(INI_USER_SECT, 'Password',
                        HogeBase64Encode(cryptedStream.DataString));
      }
      end;
    end;
    tstAuthorizedAccess := accAutoAuth;

    if plainStream <> nil then plainStream.Free;
    if cryptedStream <> nil then cryptedStream.Free;
    if cryptObj <> nil then cryptObj.Free;
    ini.Free;
  end;

  //(clWindowColor = $80000005, clBtnFace = $8000000F)
  procedure LoadColors(ini: TMemIniFile);
  var
    c: string;
  begin
    MainWnd.TreeView.Color := HexToInt(ini.ReadString(INI_CL_SECT, 'TreeViewColor', '80000005'));
    MainWnd.FavoriteView.Color := HexToInt(ini.ReadString(INI_CL_SECT, 'FavoriteViewColor', '80000005'));
    MainWnd.ListView.Color := HexToInt(ini.ReadString(INI_CL_SECT, 'ListViewColor', '80000005'));
    MainWnd.Memo.Color := HexToInt(ini.ReadString(INI_CL_SECT, 'TraceViewColor', '80000005'));
    MainWnd.ThreadToolPanel.Color := HexToInt(ini.ReadString(INI_CL_SECT, 'ThreadTitleViewColor', '8000000F'));
    {$IFNDEF IE}
    clViewColor := HexToInt(ini.ReadString(INI_CL_SECT, 'TextViewColor', '80000005'));
    MainWnd.WebPanel.Color := clViewColor;
    {$ENDIF}
    c := ini.ReadString(INI_CL_SECT, 'ListViewOddBackColor', '');
    if c <> '' then
      clListViewOddBackColor  := HexToInt(c);
    c := ini.ReadString(INI_CL_SECT, 'ListViewEvenBackColor', '');
    if c <> '' then
      clListViewEvenBackColor := HexToInt(c);
    {beginner}
    c := ini.ReadString(INI_CL_SECT, 'HintColor', '');
    if c <> '' then
      MainWnd.PopupHint.Color := HexToInt(c)
    else
      MainWnd.PopupHint.Color := clInfoBk;
    clHintOnFix := HexToInt(ini.ReadString(INI_CL_SECT, 'HintColorFix', '00efffef'));
    {/beginner}
  end;

  procedure LoadCommand;
  var
    datFile: string;
    i: integer;
  begin
    datFile := BasePath + COMMAND_FILE;
    if not FileExists(datFile) then
      exit;
    cmdConfigList.LoadFromFile(datFile);
    with cmdConfigList do
    begin
      for i := 0 to Count -1 do
        cmdExecuteList.Add(Values[Names[i]]);
    end;
  end;

  procedure LoadColumnArray(ini: TMemIniFile);
  var
    sl: TStringList;
    i: integer;
  begin
    sl := TStringList.Create;
    try
      sl.CommaText := ini.ReadString(INI_STL_SECT, 'ColumnArray', '');
      if sl.Count > 0 then
      begin
        for i := 0 to sl.Count -1 do
          stlClmnArray[i] := StrToInt(sl[i]);
        for i := sl.Count to High(stlClmnArray) do // ͔\
          stlClmnArray[i] := -1;
      end else
        for i := 0 to High(stlClmnArray) do
          stlClmnArray[i] := i;
    except // ftHg
      for i := 0 to High(stlClmnArray) do
        stlClmnArray[i] := i;
    end;
    sl.Free;
  end;
  procedure LoadZoomPoint(ini: TMemIniFile);
  var
    sl: TStringList;
    i: integer;
  begin
    sl := TStringList.Create;
    try
      sl.CommaText := ini.ReadString(INI_VIEW_SECT, 'ZoomPoint', '');
      if sl.Count = 5 then
      begin
        for i := 0 to 4 do
          viewZoomPointArray[i] := StrToInt(sl[i]);
      end;
    except
    end;
    sl.Free;
  end;

var
  ini: TMemIniFile;
  //oprAlwaysCheck: boolean;
  s: string;
begin
  ini := TMemIniFile.Create(IniPath);

  LogConfPath := ini.ReadString(INI_PATH_SECT, 'LogBasePath', LogConfPath);
  if (LogConfPath <> '') then
    LogBasePath := GetFullPath(LogConfPath);

  SkinConfPath := ini.ReadString(INI_PATH_SECT, 'SkinPath', SkinConfPath);
  if (SkinConfPath <> '') then
    SkinPath := GetFullPath(SkinConfPath);

  netUseProxy    := ini.ReadBool   (INI_NET_SECT, 'UseProxy', netUseProxy);
  netProxyServer := ini.ReadString (INI_NET_SECT, 'ProxyServer', '');
  netProxyPort   := ini.ReadInteger(INI_NET_SECT, 'ProxyPort', netProxyPort);
  netReadTimeout := ini.ReadInteger(INI_NET_SECT, 'ReadTimeout', netReadTimeout);
  netRecvBufferSize := ini.ReadInteger(INI_NET_SECT, 'RecvBufferSize', netRecvBufferSize);
  netProxyServerForWriting := netProxyServer;
  netProxyPortForWriting := netProxyPort;
  netProxyServerForWriting := ini.ReadString (INI_NET_SECT, 'ProxyServerForWriting', '');
  netProxyPortForWriting   := ini.ReadInteger(INI_NET_SECT, 'ProxyPortForWriting', netProxyPortForWriting);
  netProxyServerForSSL     := ini.ReadString (INI_NET_SECT, 'ProxyServerForSSL', '');
  netProxyPortForSSL       := ini.ReadInteger(INI_NET_SECT, 'ProxyPortForSSL', 0);
  netOnline := ini.ReadBool(INI_NET_SECT, 'Online', netOnline);
  //netUseReadCGI := ini.ReadBool(INI_NET_SECT, 'UseReadCGI', netUseReadCGI);
  netNoCache := ini.ReadBool(INI_NET_SECT, 'NoCache', netNoCache);

  extBrowserSpecified := ini.ReadBool  (INI_EXT_SECT, 'BrowserSpecified', extBrowserSpecified);
  extBrowserPath      := ini.ReadString(INI_EXT_SECT, 'BrowserPath', extBrowserPath);

  bbsMenuURL          := ini.ReadString(INI_BBS_SECT, 'URL', bbsMenuURL);
  bbs2chServers.CommaText := ini.ReadString(INI_BBS_SECT, '2chServers',
                                            '.2ch.net,.bbspink.com');
  bbsMachiServers.CommaText := ini.ReadString(INI_BBS_SECT, 'MachiServers',
                                              '.machibbs.com,.machi.to');
  bbsJBBSServers.CommaText := ini.ReadString(INI_BBS_SECT, 'JBBSServers',
                                             'jbbs.livedoor.jp,jbbs.livedoor.com,jbbs.shitaraba.com');
  (*
  bbsMenuFetchOnStart := ini.ReadBool  (INI_BBS_SECT, 'FetchOnStart', bbsMenuFetchOnStart);
  *)

  hintEnabled       := ini.ReadBool   (INI_OPT_SECT, 'HintEnabled', hintEnabled);
  hintHoverTime     := ini.ReadInteger(INI_OPT_SECT, 'HintHoverTime', hintHoverTime);
  hintHintHoverTime := ini.ReadInteger(INI_OPT_SECT, 'HintHintHoverTime', hintHintHoverTime);
  hintForOtherThread:= ini.ReadBool   (INI_OPT_SECT, 'HintForOtherThread', hintForOtherThread);
  hintNestingPopUp  := ini.ReadBool   (INI_OPT_SECT, 'HintNestingPopUp', hintNestingPopUp);
  hintAutoEnableNesting  := ini.ReadBool   (INI_OPT_SECT, 'AutoEnableNesting', hintAutoEnableNesting);
  hintHintAutoEnableNesting  := ini.ReadBool   (INI_OPT_SECT, 'HintAutoEnableNesting', hintHintAutoEnableNesting);
  hintForURL        := ini.ReadBool   (INI_OPT_SECT, 'HintForURL', hintForURL);
  hintForURLMaxLine := ini.ReadInteger(INI_OPT_SECT, 'HintForURLMaxLine', hintForURLMaxLine);
  hintForURLMaxSize := ini.ReadInteger(INI_OPT_SECT, 'HintForURLMaxSize', hintForURLMaxSize);
  hintForURLWidth   := ini.ReadInteger(INI_OPT_SECT, 'HintForURLWidth', hintForURLWidth);
  hintForURLHeight  := ini.ReadInteger(INI_OPT_SECT, 'HintForURLHeight', hintForURLHeight);
  hintForURLUseHead := ini.ReadBool   (INI_OPT_SECT, 'HintForURLUseHead', hintForURLUseHead);
  hintForURLWaitTime:= ini.ReadInteger(INI_OPT_SECT, 'HintForURLWaitTime', hintForURLWaitTime);
  hintCancelGetExt.CommaText := ini.ReadString(INI_OPT_SECT, 'HintCancelExt', '');

  oprCatBySingleClick := ini.ReadBool(INI_OPR_SECT, 'CategoryOprBySingleClick', oprCatBySingleClick);
  oprShowSubjectCache := ini.ReadBool(INI_OPR_SECT, 'ShowSubjectCache', oprShowSubjectCache);
  oprSelPreviousThread := ini.ReadBool(INI_OPR_SECT, 'SelectPreviousThread', oprSelPreviousThread);
  oprScrollToPreviousRes := ini.ReadBool(INI_OPR_SECT, 'ScrollToPreviousRes', oprScrollToPreviousRes);
  oprScrollToNewRes   := ini.ReadBool(INI_OPR_SECT, 'ScrollToNewRes', oprScrollToNewRes);
  oprScrollTop        := ini.ReadBool(INI_OPR_SECT, 'ScrollTop', oprScrollTop);
  oprToggleRView    := ini.ReadBool(INI_OPR_SECT, 'ToggleRView', oprToggleRView);
  //oprTabStopOnTracePane := ini.ReadBool(INI_OPR_SECT, 'TabStopOnTracePane', oprTabStopOnTracePane);
  oprDisableTabKeyInView := ini.ReadBool(INI_OPR_SECT, 'DisableTabKeyInVew', oprDisableTabKeyInView);
  oprBoardTreeExpandOneCategory := ini.ReadBool(INI_OPR_SECT, 'BoardTreeExpandOneCategory', oprBoardTreeExpandOneCategory);
  oprCheckNewWRedraw := ini.ReadBool(INI_OPR_SECT, 'CheckNewWithRedraw', oprCheckNewWRedraw);
  oprDrawLines := ini.ReadInteger(INI_OPR_SECT, 'DrawLines', oprDrawLines);

  (* ڍs *)
  //oprAlwaysCreateNewView := ini.ReadBool(INI_OPR_SECT, 'AlwaysCreateNewView', oprAlwaysCreateNewView);
  oprOpenThreWNewView := ini.ReadBool(INI_OPR_SECT, 'AlwaysCreateNewView', oprOpenThreWNewView);
  oprOpenThreWNewView := ini.ReadBool(INI_OPR_SECT, 'OpenThreadWithNewView', oprOpenThreWNewView);
  oprOpenFavWNewView  := ini.ReadBool(INI_OPR_SECT, 'OpenFavoriteWithNewView', oprOpenFavWNewView);
  oprOpenBoardWNewTab := ini.ReadBool(INI_OPR_SECT, 'OpenBoardWithNewTab', oprOpenBoardWNewTab);

{  if 0 < length(ini.ReadString(INI_OPR_SECT, 'AlwaysCheck', '')) then
  begin
    oprAlwaysCheck   := ini.ReadBool(INI_OPR_SECT, 'AlwaysCheck', false);
    if oprAlwaysCheck then
    begin
      oprGestureBrdClick  := gotCHECK;
      oprGestureBrdDblClk := gotCHECK;
      oprGestureBrdOther  := gotCHECK;
      oprGestureThrClick  := gotCHECK;
      oprGestureThrDblClk := gotCHECK;
      oprGestureThrOther  := gotCHECK;
    end
    else begin
      oprGestureBrdClick  := gotLOCAL;
      oprGestureBrdDblClk := gotCHECK;
      oprGestureBrdOther  := gotLOCAL;
      oprGestureThrClick  := gotGRACEFUL;
      oprGestureThrDblClk := gotCHECK;
      oprGestureThrOther  := gotGRACEFUL;
    end;
  end;}
  oprGestureBrdClick := TGestureOprType(ini.ReadInteger(INI_OPR_SECT, 'GestureBrdClick', Ord(oprGestureBrdClick)));
  oprGestureBrdDblClk:= TGestureOprType(ini.ReadInteger(INI_OPR_SECT, 'GestureBrdDblClk', Ord(oprGestureBrdDblClk)));
  oprGestureBrdMenu  := TGestureOprType(ini.ReadInteger(INI_OPR_SECT, 'GestureBrdMenu', Ord(oprGestureBrdMenu)));
  oprGestureBrdOther := TGestureOprType(ini.ReadInteger(INI_OPR_SECT, 'GestureBrdOther', Ord(oprGestureBrdOther)));

  oprGestureThrClick := TGestureOprType(ini.ReadInteger(INI_OPR_SECT, 'GestureThrClick', Ord(oprGestureThrClick)));
  oprGestureThrDblClk:= TGestureOprType(ini.ReadInteger(INI_OPR_SECT, 'GestureThrDblClk', Ord(oprGestureThrDblClk)));
  oprGestureThrMenu  := TGestureOprType(ini.ReadInteger(INI_OPR_SECT, 'GestureThrMenu', Ord(oprGestureThrMenu)));
  oprGestureThrOther := TGestureOprType(ini.ReadInteger(INI_OPR_SECT, 'GestureThrOther', Ord(oprGestureThrOther)));

  oprThreBgOpen   := ini.ReadBool(INI_OPR_SECT, 'ThreBgOpen', oprThreBgOpen);
  oprFavBgOpen    := ini.ReadBool(INI_OPR_SECT, 'FavBgOpen', oprFavBgOpen);
  oprClosedBgOpen := ini.ReadBool(INI_OPR_SECT, 'ClosedBgOpen', oprClosedBgOpen);
  oprAddrBgOpen   := ini.ReadBool(INI_OPR_SECT, 'AddrBgOpen', oprAddrBgOpen);
  oprUrlBgOpen    := ini.ReadBool(INI_OPR_SECT, 'UrlBgOpen', oprUrlBgOpen);

  oprAddPosNormal := TTabAddPos(ini.ReadInteger(INI_OPR_SECT, 'AddPosNormal', Ord(oprAddPosNormal)));
  oprAddPosRelative := TTabAddPos(ini.ReadInteger(INI_OPR_SECT, 'AddPosRelative', Ord(oprAddPosRelative)));
  oprClosetPos := TTabClosePos(ini.ReadInteger(INI_OPR_SECT, 'ClosePos', Ord(oprClosetPos)));

  optEnableBoardMenu:= ini.ReadBool(INI_OPT_SECT, 'EnableBoardMenu', optEnableBoardMenu);
  optEnableFavMenu  := ini.ReadBool(INI_OPT_SECT, 'EnableFavMenu', optEnableFavMenu);
  optDateTimeFormat := ini.ReadString(INI_OPT_SECT, 'DateTimeFormat', self.optDateTimeFormat);
  optMonthNames     := ini.ReadString(INI_OPT_SECT, 'MonthNames', self.optMonthNames);
  optDayOfWeek      := ini.ReadString(INI_OPT_SECT, 'DayOfWeek', self.optDayOfWeek);
  SetDateTimeFormat;

  optCharsInTab := ini.ReadInteger(INI_OPT_SECT, 'CharsInTab', optCharsInTab);
  //optShowCacheOnBoot := ini.ReadBool(INI_OPT_SECT, 'ShowCacheOnBoot', optShowCacheOnBoot);
  optSaveLastItems := ini.ReadBool(INI_OPT_SECT, 'SaveLastItems', optSaveLastItems);
  optAutoSort := ini.ReadBool(INI_OPT_SECT, 'AutoSort', optAutoSort);
  optAllowFavoriteDuplicate := ini.ReadBool(INI_OPT_SECT, 'AllowFavoriteDuplicate', optAllowFavoriteDuplicate);
  optLogListLimitCount := ini.ReadInteger(INI_OPT_SECT, 'LogListLimitCount', optLogListLimitCount);
  optHomeIfSubjectIsEmpty := ini.ReadBool(INI_OPT_SECT, 'HomeIfSubjectIsEmpty', optHomeIfSubjectIsEmpty);
  
  compressRatio := ini.ReadFloat(INI_TEST_SECT, 'CompressRatio', compressRatio);
  compressRatioSamples := ini.ReadInteger(INI_TEST_SECT, 'CompressRatioSamples', compressRatioSamples);
  tstCommHeaders := ini.ReadBool(INI_TEST_SECT, 'HEADERS', tstCommHeaders);
  tstCloseAfterWriting := ini.ReadBool(INI_TEST_SECT, 'CloseAfterWriting', tstCloseAfterWriting);
  tstEnableHTTPTrace := ini.ReadBool(INI_TEST_SECT, 'EnableHTTPTrace', tstEnableHTTPTrace);
  tstDebugEnabled := ini.ReadBool(INI_TEST_SECT, 'DebugEnabled', tstDebugEnabled);
  tstWrtCookie := ini.ReadString(INI_TEST_SECT, 'WrtCookie', '');
  s := ini.ReadString(INI_TEST_SECT, 'AccountDir', '');
  if 0 < length(s) then
    AccPath := self.BasePath + s + 'account.cfg';

  brdRecyclableCount := ini.ReadInteger(INI_TEST_SECT, 'RecyclableCount', brdRecyclableCount);

  datDeleteOutOfTime := ini.ReadBool(INI_DAT_SECT, 'DeleteOutOfTime', datDeleteOutOfTime);

  //tstAuthorizedAccess := ini.ReadBool(INI_TEST_SECT, 'AuthorizedAccess', tstAuthorizedAccess);

  viewZoomSize := ini.ReadInteger(INI_VIEW_SECT, 'ZoomSize', viewZoomSize);


  s := ini.ReadString(INI_VIEW_SECT, 'TreeViewFont', '');
  ExtractFontInfo(viewTreeFontInfo, s);
  s := ini.ReadString(INI_VIEW_SECT, 'TraceFont', '');
  ExtractFontInfo(viewTraceFontInfo, s);
  s := ini.ReadString(INI_VIEW_SECT, 'DefaultFont', '');
  ExtractFontInfo(viewDefFontInfo, s);
  //Xʂɐݒ
  s := ini.ReadString(INI_VIEW_SECT, 'ListViewFont', '');
  ExtractFontInfo(viewListFontInfo, s);
  //[457]
  s := ini.ReadString(INI_VIEW_SECT, 'ThreadTitleFont', '');
  ExtractFontInfo(viewThreadTitleFontInfo, s);
  s := ini.ReadString(INI_VIEW_SECT, 'WriteFont', '');
  ExtractFontInfo(viewWriteFontInfo, s);
  {beginner}
  s := ini.ReadString(INI_VIEW_SECT, 'HintFont', '');
  ExtractFontInfo(viewHintFontInfo, s);
  viewHintFontLinkColor := ini.ReadInteger(INI_VIEW_SECT, 'HintFontLinkColor', clBlue);
  {/beginner}


  viewNGMsgMarker := ini.ReadString(INI_VIEW_SECT, 'NGMsgMarker', viewNGMsgMarker);
  viewTransparencyAbone := ini.ReadBool(INI_VIEW_SECT, 'TransparencyAbone', viewTransparencyAbone);
  viewListMarkerNone := ini.ReadString(INI_VIEW_SECT, 'ListMarkerNone', viewListMarkerNone);
  viewListMarkerRead := ini.ReadString(INI_VIEW_SECT, 'ListMarkerRead', viewListMarkerRead);
  viewListMarkerReadWNewMsg := ini.ReadString(INI_VIEW_SECT, 'ListMarkerReadWNewMsg', viewListMarkerReadWNewMsg);
  viewListMarkerReadWMsg    := ini.ReadString(INI_VIEW_SECT, 'ListMarkerReadWMsg', viewListMarkerReadWMsg);
  viewListMarkerReadNoUpdate:= ini.ReadString(INI_VIEW_SECT, 'ListMarkerReadNoUpdate', viewListMarkerReadNoUpdate);
  viewListMarkerMarked   := ini.ReadString(INI_VIEW_SECT, 'ListMarkerMarked', viewListMarkerMarked);
  viewListMarkerMarkedWNewMsg := ini.ReadString(INI_VIEW_SECT, 'ListMarkerMarkedWNewMsg', viewListMarkerMarkedWNewMsg);
  viewListMarkerMarkedWMsg    := ini.ReadString(INI_VIEW_SECT, 'ListMarkerMarkedWMsg', viewListMarkerMarkedWMsg);
  viewListMarkerMarkedNoUpdate:= ini.ReadString(INI_VIEW_SECT, 'ListMarkerMarkedNoUpdate', viewListMarkerMarkedNoUpdate);
  {$IFNDEF IE}
  viewVerticalCaretMargin := ini.ReadInteger(INI_VIEW_SECT, 'CaretMargin', viewVerticalCaretMargin);
  viewScrollLines := ini.ReadInteger(INI_VIEW_SECT, 'ScrollLines', viewScrollLines);
  viewPageScroll := ini.ReadBool(INI_VIEW_SECT, 'PageScroll', viewPageScroll);
  viewCaretVisible := ini.ReadBool(INI_VIEW_SECT, 'CaretVisible', viewCaretVisible);
  LoadZoomPoint(ini);
  {$ENDIF}

  stlVerticalDivision := ini.ReadBool(INI_STL_SECT, 'VerticalDivision', stlVerticalDivision);
  stlToolBarVisible := ini.ReadBool(INI_STL_SECT, 'ToolBarVisible', stlToolBarVisible);
  stlLinkBarVisible := ini.ReadBool(INI_STL_SECT, 'LinkBarVisible', stlLinkBarVisible);
  stlAddressBarVisible := ini.ReadBool(INI_STL_SECT, 'AddressBarVisible', stlAddressBarVisible);
  stlTreeVisible := ini.ReadBool(INI_STL_SECT, 'TreeVisible', stlTreeVisible);
  stlThreadToolBarVisible := ini.ReadBool(INI_STL_SECT, 'ThreadToolBarVisible', stlThreadToolBarVisible);
  stlThreadTitleLabelVisible := ini.ReadBool(INI_STL_SECT, 'ThreadTitleVisible', stlThreadTitleLabelVisible);

  stlTabStyle := ini.ReadInteger(INI_STL_SECT, 'TabStyle', stlTabStyle);
  stlListTabStyle := ini.ReadInteger(INI_STL_SECT, 'ListTabStyle', stlListTabStyle);
  stlTreeTabStyle := ini.ReadInteger(INI_STL_SECT, 'TreeTabStyle', stlTreeTabStyle);
  stlTabMultiline := ini.ReadBool(INI_STL_SECT, 'TabMultiline', stlTabMultiline);
  stlTabWidth := ini.ReadInteger(INI_STL_SECT, 'TabWidth', stlTabWidth);
  stlTabHeight := ini.ReadInteger(INI_STL_SECT, 'TabHeight', stlTabHeight);
  stlListTabWidth := ini.ReadInteger(INI_STL_SECT, 'ListTabWidth', stlListTabWidth);
  stlListTabHeight := ini.ReadInteger(INI_STL_SECT, 'ListTabHeight', stlListTabHeight);

  stlMenuIcons    := ini.ReadBool(INI_STL_SECT, 'MenuIcons', stlMenuIcons);
  stlLinkBarIcons := ini.ReadBool(INI_STL_SECT, 'LinkBarIcons', stlLinkBarIcons);
  stlTabIcons     := ini.ReadBool(INI_STL_SECT, 'TabIcons', stlTabIcons);
  stlTreeIcons    := ini.ReadBool(INI_STL_SECT, 'TreeIcons', stlTreeIcons);
  stlListMarkIcons    := ini.ReadBool(INI_STL_SECT, 'ListMarkIcons', stlListMarkIcons);
  stlListTitleIcons    := ini.ReadBool(INI_STL_SECT, 'ListTitleIcons', stlListTitleIcons);
  stlListViewUseExtraBackColor := ini.ReadBool(INI_STL_SECT, 'ListViewUseExtraBackColor', stlListViewUseExtraBackColor);
  stlShowTreeMarks := ini.ReadBool(INI_STL_SECT, 'ShowTreeMarks', stlShowTreeMarks);

  wrtFormTop := ini.ReadInteger(INI_WRT_SECT, 'WriteFormTop', wrtFormTop);
  wrtFormLeft := ini.ReadInteger(INI_WRT_SECT, 'WriteFormLeft', wrtFormLeft);
  wrtFormHeight := ini.ReadInteger(INI_WRT_SECT, 'WriteFormHeight', wrtFormHeight);
  wrtFormWidth := ini.ReadInteger(INI_WRT_SECT, 'WriteFormWidth', wrtFormWidth);

  wrtRecordWriting := ini.ReadBool(INI_WRT_SECT, 'RecordWriting', wrtRecordWriting);
  wrtRecordNameMail := ini.ReadBool(INI_WRT_SECT, 'RecordNameMail', wrtRecordNameMail); //521
  wrtFormStayOnTop := ini.ReadBool(INI_WRT_SECT, 'WriteFormStayOnTop', wrtFormStayOnTop); //521
  wrtDefaultSageCheck := ini.ReadBool(INI_WRT_SECT, 'DefaultSageCheck', wrtDefaultSageCheck);
  wrtReplyMark := ini.ReadString(INI_WRT_SECT, 'ReplyMark', wrtReplyMark);
  wrtShowThreadTitle := ini.ReadBool(INI_WRT_SECT, 'ShowThreadTitle', wrtShowThreadTitle);
  wrtFmUseTaskBar := ini.ReadBool(INI_WRT_SECT, 'FormUseTaskBar', wrtFmUseTaskBar);
  wrtUseDefaultName := ini.ReadBool(INI_WRT_SECT, 'UseDefaultName', wrtUseDefaultName);
  wrtDiscrepancyWarning := ini.ReadBool(INI_WRT_SECT, 'DiscrepancyWarning', wrtDiscrepancyWarning);
  wrtDisableStatusBar := ini.ReadBool(INI_WRT_SECT, 'DisableStatusBar', wrtDisableStatusBar);
  wrtAutoAgreement := ini.ReadBool(INI_WRT_SECT, 'AutoAgreement', wrtAutoAgreement);
  wrtAdditionalAgreementField := ini.ReadString(INI_WRT_SECT, 'AdditionalAgreementField', wrtAdditionalAgreementField);

  grepPopup := ini.ReadBool(INI_GREP_SECT, 'Popup', grepPopup);
  grepPopMaxSeq := ini.ReadInteger(INI_GREP_SECT, 'PopMaxSequence', grepPopMaxSeq);
  grepPopEachThreMax := ini.ReadInteger(INI_GREP_SECT, 'PopEachThreMax', grepPopEachThreMax);

  mseUseWheelTabChange := ini.ReadBool(INI_MSE_SECT, 'WheelTabChange', mseUseWheelTabChange);
  mseGestureMargin := ini.ReadInteger(INI_MSE_SECT, 'GestureMargin', mseGestureMargin);

  LoadColors(ini);
  LoadColumnArray(ini);

  ini.Free;


  {$IFNDEF IE}
  ini := TMemIniFile.Create(GetFullPath(SkinPath) + ATTRIBUTE_FILE);
  LoadTextAttribute(ini);
  if ini.SectionExists(INI_CL_SECT) then
    clViewColor := HexToInt(ini.ReadString(INI_CL_SECT, 'TextViewColor', IntToHex(clViewColor, 6)));
  ini.Free;
  {$ENDIF}


  try
    wrtNameList.LoadFromFile(Config.BasePath + 'name.dat');
  except
  end;
  try
    wrtMailList.LoadFromFile(Config.BasePath + 'mail.dat');
  except
  end;

  if FileExists(BasePath + MOUSE_FILE) then
    mseGestureList.LoadFromFile(BasePath + MOUSE_FILE);

  LoadCommand;
  LoadAccount;

  // ȑÕo[W̃S~
  Windows.WritePrivateProfileString(PChar(INI_OPR_SECT), 'AlwaysCheck', nil, PChar(IniPath));
  Windows.WritePrivateProfileString(PChar(INI_OPR_SECT), 'AlwaysCreateNewView', nil, PChar(IniPath));
  Windows.WritePrivateProfileString(PChar(INI_TEST_SECT), 'ReadPengings', nil, PChar(IniPath));
  //Windows.WritePrivateProfileString(PChar(INI_WIN_SECT), 'Column6', nil, PChar(IniPath));
  Windows.WritePrivateProfileString(PChar(INI_TEST_SECT), 'AuthorizedAccess', nil, PChar(IniPath));
  Windows.WritePrivateProfileString(PChar(INI_NET_SECT), 'UseReadCGI', nil, PChar(IniPath));
end;

(*  *)
procedure TJaneConfig.Save;
  function FontInfoToStr(info: TFontInfo): string;
  var
    strList: TStringList;
  begin
    strList := TStringList.Create;
    strList.Add(info.face);
    strList.Add(IntToStr(info.charset));
    strList.Add(IntToStr(info.height));
    strList.Add(IntToStr(info.size));
    strList.Add(IntToStr(info.style));
    strList.Add(IntToHex(info.color, 8)); //Fǉ
    result := strList.CommaText;
    strList.Free;
  end;

  {$IFNDEF IE}
  procedure SaveTextAttrib(ini: TMemIniFile);
  var
    index: integer;
    s: string;
  begin
    for index := 0 to High(THogeAttribute) div 2 do
    begin
      with viewTextAttrib[index*2] do
      begin
        s := Format('%08.8x,%d', [color, StylesToBit(style)]);
        ini.WriteString(INI_ATTRIB_SECT, 'TextAttrib' + IntToStr(index), s);
      end;
    end;
  end;
  {$ENDIF}

  procedure SaveAccount;
  var
    ini: TMemIniFile;
    cryptObj: THogeCryptAuto;
    plainStream, cryptedStream: TStringStream;
    savePasswd: string;
  begin
    if (accUserID = '') and (accPasswd = '') then
      exit;
    cryptObj := THogeCryptAuto.Create;
    plainStream := TStringStream.Create(accPasswd);
    cryptedStream := TStringStream.Create('');
    if cryptObj.Encrypt(plainStream, '', cryptedStream) then
      savePasswd := HogeBase64Encode(cryptedStream.DataString)
    else
      savePasswd := accPasswd;
    plainStream.Free;
    cryptedStream.Free;
    cryptObj.Free;

    ini := TMemIniFile.Create(AccPath);
    ini.WriteString(INI_USER_SECT, 'UserID', accUserID);
    ini.WriteString(INI_USER_SECT, 'Passwd', savePasswd);
    ini.WriteString(INI_USER_SECT, 'ALT', accPassphrasedPasswd);
    ini.WriteBool  (INI_USER_SECT, 'Auto', accAutoAuth);
    ini.UpdateFile;
    ini.Free;

    Windows.WritePrivateProfileString(PChar(INI_USER_SECT), 'Password', nil, PChar(AccPath));
  end;

  //F
  procedure SaveColors(ini: TMemIniFile);
  begin
    ini.WriteString(INI_CL_SECT, 'TreeViewColor', IntToHex(MainWnd.TreeView.Color, 8));
    ini.WriteString(INI_CL_SECT, 'FavoriteViewColor', IntToHex(MainWnd.FavoriteView.Color, 8));
    ini.WriteString(INI_CL_SECT, 'ListViewColor', IntToHex(MainWnd.ListView.Color, 8));
    ini.WriteString(INI_CL_SECT, 'TraceViewColor', IntToHex(MainWnd.Memo.Color, 8));
    ini.WriteString(INI_CL_SECT, 'ThreadTitleViewColor', IntToHex(MainWnd.ThreadToolPanel.Color, 8)); //[457]
    {$IFNDEF IE}
    ini.WriteString('COLOR', 'TextViewColor', IntToHex(Config.clViewColor, 8));
    {$ENDIF}
    ini.WriteString(INI_CL_SECT, 'ListViewOddBackColor', IntToHex(clListViewOddBackColor, 8));
    ini.WriteString(INI_CL_SECT, 'ListViewEvenBackColor', IntToHex(clListViewEvenBackColor, 8));
    ini.WriteString(INI_CL_SECT, 'HintColor', IntToHex(MainWnd.PopupHint.Color, 8));
    ini.WriteString(INI_CL_SECT, 'HintColorFix', IntToHex(clHintOnFix, 8));
  end;

  procedure SaveCommand;
  begin
    if cmdConfigList.Text <> '' then
      cmdConfigList.SaveToFile(BasePath + COMMAND_FILE);
  end;

  procedure SaveMouseGesture;
  begin
    if (mseGestureList.Text <> '') or FileExists(BasePath + MOUSE_FILE) then
      mseGestureList.SaveToFile(BasePath + MOUSE_FILE);
  end;

  procedure SaveColumnArray(ini: TMemIniFile);
  var
    sl: TStringList;
    i: integer;
  begin
    sl := TStringList.Create;
    for i := 0 to High(stlClmnArray) do
    begin
      if stlClmnArray[i] < 0 then
        break;
      sl.Add(IntToStr(stlClmnArray[i]));
    end;
    ini.WriteString(INI_STL_SECT, 'ColumnArray', sl.CommaText);
    sl.Free;
  end;

  procedure SaveZoomPoint(ini: TMemIniFile);
  var
    s: string;
  begin
    s := IntToStr(viewZoomPointArray[0]) + ','
       + IntToStr(viewZoomPointArray[1]) + ','
       + IntToStr(viewZoomPointArray[2]) + ','
       + IntToStr(viewZoomPointArray[3]) + ','
       + IntToStr(viewZoomPointArray[4]);
    ini.WriteString(INI_VIEW_SECT, 'ZoomPoint', s);
  end;

var
  ini: TMemIniFile;
begin
  ini := TMemIniFile.Create(IniPath);

  ini.WriteString(INI_PATH_SECT, 'LogBasePath', LogConfPath);
  ini.WriteString(INI_PATH_SECT, 'SkinPath', SkinConfPath);

  ini.WriteBool   (INI_NET_SECT, 'UseProxy', netUseProxy);
  ini.WriteString (INI_NET_SECT, 'ProxyServer', netProxyServer);
  ini.WriteInteger(INI_NET_SECT, 'ProxyPort', netProxyPort);
  ini.WriteInteger(INI_NET_SECT, 'ReadTimeout', netReadTimeout);
  ini.WriteInteger(INI_NET_SECT, 'RecvBufferSize', netRecvBufferSize);
  ini.WriteString (INI_NET_SECT, 'ProxyServerForWriting', netProxyServerForWriting);
  ini.WriteInteger(INI_NET_SECT, 'ProxyPortForWriting', netProxyPortForWriting);
  ini.WriteString (INI_NET_SECT, 'ProxyServerForSSL', netProxyServerForSSL);
  ini.WriteInteger(INI_NET_SECT, 'ProxyPortForSSL', netProxyPortForSSL);
  ini.WriteBool   (INI_NET_SECT, 'Online', netOnline);
  //ini.WriteBool   (INI_NET_SECT, 'UseReadCGI', netUseReadCGI);
  ini.WriteBool   (INI_NET_SECT, 'NoCache', netNoCache);

  ini.WriteBool  (INI_EXT_SECT, 'BrowserSpecified', extBrowserSpecified);
  ini.WriteString(INI_EXT_SECT, 'BrowserPath', extBrowserPath);

  ini.WriteString(INI_BBS_SECT, 'URL', bbsMenuURL);
  (*
  ini.WriteBool  (INI_BBS_SECT, 'FetchOnStart', bbsMenuFetchOnStart);
  *)

  ini.WriteBool   (INI_OPT_SECT, 'HintEnabled', hintEnabled);
  ini.WriteInteger(INI_OPT_SECT, 'HintHoverTime', hintHoverTime);
  ini.WriteInteger(INI_OPT_SECT, 'HintHintHoverTime', hintHintHoverTime);
  ini.WriteBool   (INI_OPT_SECT, 'HintForOtherThread', hintForOtherThread);
  ini.WriteBool   (INI_OPT_SECT, 'HintNestingPopUp', hintNestingPopUp);
  ini.WriteBool   (INI_OPT_SECT, 'AutoEnableNesting', hintAutoEnableNesting);
  ini.WriteBool   (INI_OPT_SECT, 'HintAutoEnableNesting', hintHintAutoEnableNesting);
  ini.WriteBool   (INI_OPT_SECT, 'HintForURL', hintForURL);
  ini.WriteInteger(INI_OPT_SECT, 'HintForURLMaxLine', hintForURLMaxLine);
  ini.WriteInteger(INI_OPT_SECT, 'HintForURLMaxSize', hintForURLMaxSize);
  ini.WriteInteger(INI_OPT_SECT, 'HintForURLWidth', hintForURLWidth);
  ini.WriteInteger(INI_OPT_SECT, 'HintForURLHeight', hintForURLHeight);
  ini.WriteBool   (INI_OPT_SECT, 'HintForURLUseHead', hintForURLUseHead);
  ini.WriteInteger(INI_OPT_SECT, 'HintForURLWaitTime', hintForURLWaitTime);
  ini.WriteString(INI_OPT_SECT, 'HintCancelExt', hintCancelGetExt.CommaText);

  ini.WriteBool(INI_OPR_SECT, 'CategoryOprBySingleClick', oprCatBySingleClick);
  //ini.WriteBool(INI_OPR_SECT, 'ShowSubjectCache', oprShowSubjectCache);
  ini.WriteBool(INI_OPR_SECT, 'SelectPreviousThread', oprSelPreviousThread);
  ini.WriteBool(INI_OPR_SECT, 'ScrollToPreviousRes', oprScrollToPreviousRes);
  ini.WriteBool(INI_OPR_SECT, 'ScrollToNewRes', oprScrollToNewRes);
  ini.WriteBool(INI_OPR_SECT, 'ScrollTop', oprScrollTop);
  ini.WriteBool(INI_OPR_SECT, 'ToggleRView', oprToggleRView);
  //ini.WriteBool(INI_OPR_SECT, 'AlwaysCheck', oprAlwaysCheck);
  //ini.WriteBool(INI_OPR_SECT, 'TabStopOnTracePane', oprTabStopOnTracePane);
  ini.WriteBool(INI_OPR_SECT, 'DisableTabKeyInVew', oprDisableTabKeyInView);
  ini.WriteBool(INI_OPR_SECT, 'BoardTreeExpandOneCategory', oprBoardTreeExpandOneCategory);
  ini.WriteBool(INI_OPR_SECT, 'CheckNewWithRedraw', oprCheckNewWRedraw);
  ini.WriteInteger(INI_OPR_SECT, 'DrawLines', oprDrawLines);

  //ini.WriteBool(INI_OPR_SECT, 'AlwaysCreateNewView', oprAlwaysCreateNewView);
  ini.WriteBool(INI_OPR_SECT, 'OpenThreadWithNewView', oprOpenThreWNewView);
  ini.WriteBool(INI_OPR_SECT, 'OpenFavoriteWithNewView', oprOpenFavWNewView);
  ini.WriteBool(INI_OPR_SECT, 'OpenBoardWithNewTab', oprOpenBoardWNewTab);

  ini.WriteInteger(INI_OPR_SECT, 'GestureBrdClick', Ord(oprGestureBrdClick));
  ini.WriteInteger(INI_OPR_SECT, 'GestureBrdDblClk', Ord(oprGestureBrdDblClk));
  ini.WriteInteger(INI_OPR_SECT, 'GestureBrdMenu', Ord(oprGestureBrdMenu));
  ini.WriteInteger(INI_OPR_SECT, 'GestureBrdOther', Ord(oprGestureBrdOther));

  ini.WriteInteger(INI_OPR_SECT, 'GestureThrClick', Ord(oprGestureThrClick));
  ini.WriteInteger(INI_OPR_SECT, 'GestureThrDblClk', Ord(oprGestureThrDblClk));
  ini.WriteInteger(INI_OPR_SECT, 'GestureThrMenu', Ord(oprGestureThrMenu));
  ini.WriteInteger(INI_OPR_SECT, 'GestureThrOther', Ord(oprGestureThrOther));

  ini.WriteBool(INI_OPR_SECT, 'ThreBgOpen', oprThreBgOpen);
  ini.WriteBool(INI_OPR_SECT, 'FavBgOpen', oprFavBgOpen);
  ini.WriteBool(INI_OPR_SECT, 'ClosedBgOpen', oprClosedBgOpen);
  ini.WriteBool(INI_OPR_SECT, 'AddrBgOpen', oprAddrBgOpen);
  ini.WriteBool(INI_OPR_SECT, 'UrlBgOpen', oprUrlBgOpen);

  ini.WriteInteger(INI_OPR_SECT, 'AddPosNormal', Ord(oprAddPosNormal));
  ini.WriteInteger(INI_OPR_SECT, 'AddPosRelative', Ord(oprAddPosRelative));
  ini.WriteInteger(INI_OPR_SECT, 'ClosePos', Ord(oprClosetPos));

  ini.WriteBool(INI_OPT_SECT, 'EnableBoardMenu', optEnableBoardMenu);
  ini.WriteBool(INI_OPT_SECT, 'EnableFavMenu', optEnableFavMenu);
  ini.WriteString(INI_OPT_SECT, 'DateTimeFormat', self.optDateTimeFormat);
  ini.WriteString(INI_OPT_SECT, 'MonthNames', self.optMonthNames);
  ini.WriteString(INI_OPT_SECT, 'DayOfWeek', self.optDayOfWeek);
  ini.WriteInteger(INI_OPT_SECT, 'CharsInTab', optCharsInTab);
  //ini.WriteBool   (INI_OPT_SECT, 'ShowCacheOnBoot', optShowCacheOnBoot);
  ini.WriteBool   (INI_OPT_SECT, 'SaveLastItems', optSaveLastItems);
  ini.WriteBool(INI_OPT_SECT, 'AutoSort', optAutoSort);
  ini.WriteBool(INI_OPT_SECT, 'AllowFavoriteDuplicate', optAllowFavoriteDuplicate);
  ini.WriteInteger(INI_OPT_SECT, 'LogListLimitCount', optLogListLimitCount);

  //ini.WriteBool   (INI_TEST_SECT, 'ShowWritingResult', debugWriting);
  ini.WriteFloat  (INI_TEST_SECT, 'CompressRatio', compressRatio);
  ini.WriteInteger(INI_TEST_SECT, 'CompressRatioSamples', compressRatioSamples);
  ini.WriteBool   (INI_TEST_SECT, 'HEADERS', tstCommHeaders);
  ini.WriteString (INI_TEST_SECT, 'WrtCookie', tstWrtCookie);

  ini.WriteInteger(INI_TEST_SECT, 'RecyclableCount', brdRecyclableCount);

  ini.WriteBool(INI_DAT_SECT, 'DeleteOutOfTime', datDeleteOutOfTime);

  //ini.WriteBool(INI_TEST_SECT, 'AuthorizedAccess', tstAuthorizedAccess);
  ini.WriteBool(INI_TEST_SECT, 'CloseAfterWriting', tstCloseAfterWriting);

  ini.WriteInteger(INI_VIEW_SECT, 'ZoomSize', viewZoomSize);
  ini.WriteString(INI_VIEW_SECT, 'TreeViewFont', FontInfoToStr(viewTreeFontInfo));
  ini.WriteString(INI_VIEW_SECT, 'TraceFont', FontInfoToStr(viewTraceFontInfo));
  ini.WriteString(INI_VIEW_SECT, 'DefaultFont', FontInfoToStr(viewDefFontInfo));
  ini.WriteString(INI_VIEW_SECT, 'ListViewFont', FontInfoToStr(viewListFontInfo)); //Xʂɐݒ
  ini.WriteString(INI_VIEW_SECT, 'ThreadTitleFont', FontInfoToStr(viewThreadTitleFontInfo)); //[457]
  ini.WriteString(INI_VIEW_SECT, 'WriteFont', FontInfoToStr(viewWriteFontInfo));
  ini.WriteString(INI_VIEW_SECT, 'HintFont', FontInfoToStr(viewHintFontInfo));
  ini.WriteInteger(INI_VIEW_SECT, 'HintFontLinkColor', viewHintFontLinkColor);

  ini.WriteString(INI_VIEW_SECT, 'NGMsgMarker', viewNGMsgMarker);
  ini.WriteBool(INI_VIEW_SECT, 'TransparencyAbone', viewTransparencyAbone);
  ini.WriteString(INI_VIEW_SECT, 'ListMarkerNone', viewListMarkerNone);
  ini.WriteString(INI_VIEW_SECT, 'ListMarkerRead', viewListMarkerRead);
  ini.WriteString(INI_VIEW_SECT, 'ListMarkerReadWNewMsg', viewListMarkerReadWNewMsg);
  ini.WriteString(INI_VIEW_SECT, 'ListMarkerReadWMsg', viewListMarkerReadWMsg);
  ini.WriteString(INI_VIEW_SECT, 'ListMarkerReadNoUpdate', viewListMarkerReadNoUpdate);
  ini.WriteString(INI_VIEW_SECT, 'ListMarkerMarked', viewListMarkerMarked);
  ini.WriteString(INI_VIEW_SECT, 'ListMarkerMarkedWNewMsg', viewListMarkerMarkedWNewMsg);
  ini.WriteString(INI_VIEW_SECT, 'ListMarkerMarkedWMsg', viewListMarkerMarkedWMsg);
  ini.WriteString(INI_VIEW_SECT, 'ListMarkerMarkedNoUpdate', viewListMarkerMarkedNoUpdate);
  {$IFNDEF IE}
  ini.WriteInteger(INI_VIEW_SECT, 'CaretMargin', viewVerticalCaretMargin);
  ini.WriteInteger(INI_VIEW_SECT, 'ScrollLines', viewScrollLines);
  ini.WriteBool(INI_VIEW_SECT, 'PageScroll', viewPageScroll);
  ini.WriteBool(INI_VIEW_SECT, 'CaretVisible', viewCaretVisible);
  SaveZoomPoint(ini);
  {$ENDIF}

  ini.WriteBool(INI_STL_SECT,'VerticalDivision', stlVerticalDivision);
  ini.WriteBool(INI_STL_SECT, 'ToolBarVisible', stlToolBarVisible);
  ini.WriteBool(INI_STL_SECT, 'LinkBarVisible', stlLinkBarVisible);
  ini.WriteBool(INI_STL_SECT, 'AddressBarVisible', stlAddressBarVisible);
  ini.WriteBool(INI_STL_SECT, 'TreeVisible', stlTreeVisible);
  ini.WriteBool(INI_STL_SECT, 'ThreadToolBarVisible', stlThreadToolBarVisible);
  ini.WriteBool(INI_STL_SECT, 'ThreadTitleVisible', stlThreadTitleLabelVisible);

  ini.WriteInteger(INI_STL_SECT, 'TabStyle', stlTabStyle);
  ini.WriteInteger(INI_STL_SECT, 'ListTabStyle', stlListTabStyle);
  ini.WriteInteger(INI_STL_SECT, 'TreeTabStyle', stlTreeTabStyle);
  ini.WriteBool(INI_STL_SECT, 'TabMultiline', stlTabMultiline);
  ini.WriteInteger(INI_STL_SECT, 'TabWidth', stlTabWidth);
  ini.WriteInteger(INI_STL_SECT, 'TabHeight', stlTabHeight);
  ini.WriteInteger(INI_STL_SECT, 'ListTabWidth', stlListTabWidth);
  ini.WriteInteger(INI_STL_SECT, 'ListTabHeight', stlListTabHeight);

  ini.WriteBool(INI_STL_SECT, 'MenuIcons', stlMenuIcons);
  ini.WriteBool(INI_STL_SECT, 'LinkBarIcons', stlLinkBarIcons);
  ini.WriteBool(INI_STL_SECT, 'TabIcons', stlTabIcons);
  ini.WriteBool(INI_STL_SECT, 'TreeIcons', stlTreeIcons);
  ini.WriteBool(INI_STL_SECT, 'ListMarkIcons', stlListMarkIcons);
  ini.WriteBool(INI_STL_SECT, 'ListTitleIcons', stlListTitleIcons);
  ini.WriteBool(INI_STL_SECT, 'ListViewUseExtraBackColor', stlListViewUseExtraBackColor);
  ini.WriteBool(INI_STL_SECT, 'ShowTreeMarks', stlShowTreeMarks);

  ini.WriteBool(INI_WRT_SECT, 'RecordWriting', wrtRecordWriting);
  ini.WriteBool(INI_WRT_SECT, 'DefaultSageCheck', wrtDefaultSageCheck);
  ini.WriteString(INI_WRT_SECT, 'ReplyMark', wrtReplyMark);
  ini.WriteBool(INI_WRT_SECT, 'ShowThreadTitle', wrtShowThreadTitle);
  ini.WriteBool(INI_WRT_SECT, 'FormUseTaskBar', wrtFmUseTaskBar);
  ini.WriteBool(INI_WRT_SECT, 'UseDefaultName', wrtUseDefaultName);
  ini.WriteBool(INI_WRT_SECT, 'DiscrepancyWarning', wrtDiscrepancyWarning);
  ini.WriteBool(INI_WRT_SECT, 'DisableStatusBar', wrtDisableStatusBar);
  ini.WriteBool(INI_WRT_SECT, 'AutoAgreement', wrtAutoAgreement);
  ini.WriteString(INI_WRT_SECT, 'AdditionalAgreementField', wrtAdditionalAgreementField);

  ini.WriteBool(INI_MSE_SECT, 'WheelTabChange', mseUseWheelTabChange);
  ini.WriteInteger(INI_MSE_SECT, 'GestureMargin', mseGestureMargin);

  ini.WriteBool(INI_GREP_SECT, 'Popup', grepPopup);
  ini.WriteInteger(INI_GREP_SECT, 'PopMaxSequence', grepPopMaxSeq);
  ini.WriteInteger(INI_GREP_SECT, 'PopEachThreMax', grepPopEachThreMax);

  if ColorChanged then
    SaveColors(ini);
  SaveColumnArray(ini);
  ini.UpdateFile;
  ini.Free;

  {$IFNDEF IE}
  if DirectoryExists(SkinPath) and not FileExists(SkinPath + ATTRIBUTE_FILE) then
  begin
    ini := TMemIniFile.Create(SkinPath + ATTRIBUTE_FILE);
    SaveTextAttrib(ini);
    ini.UpdateFile;
    ini.Free;
  end;
  {$ENDIF}

  if wrtNameList.Text <> '' then
    wrtNameList.SaveToFile(BasePath + 'name.dat');
  if wrtMailList.Text <> '' then
    wrtMailList.SaveToFile(BasePath + 'mail.dat');

  SaveMouseGesture;
  SaveCommand;
  if tmpChanged then
    SaveAccount;

  Modified := False;
end;

{beginner}  //݃_CAÖʒuۑ
procedure TJaneConfig.SaveWriteFormPos(Rect:TRect);
var
  ini: TMemIniFile;
begin
  ini := TMemIniFile.Create(IniPath);

  ini.WriteInteger(INI_WRT_SECT, 'WriteFormTop', Rect.Top);
  ini.WriteInteger(INI_WRT_SECT, 'WriteFormLeft', Rect.Left);
  ini.WriteInteger(INI_WRT_SECT, 'WriteFormHeight', Rect.Bottom-Rect.Top);
  ini.WriteInteger(INI_WRT_SECT, 'WriteFormWidth', Rect.Right-Rect.Left);

  ini.UpdateFile;
  ini.Free;
end;

(* k̓vXV *)
procedure TJaneConfig.AddSample(compressed, uncompressed: cardinal);
var
  ratio: double;
begin
  if uncompressed = 0 then
    exit;
  if compressed = 0 then (* kĂȂ *)
    exit;
  ratio := compressed / uncompressed;
  compressRatio := (compressRatio * compressRatioSamples + ratio)/(compressRatioSamples + 1);
  Inc(compressRatioSamples);
  if cardinal(100000) <= compressRatioSamples then
    compressRatioSamples := 100000;
end;


procedure TJaneConfig.SetFontInfo(var info: TFontInfo; font: TFont);
begin
  info.face := font.Name;
  info.charset := font.Charset;
  info.height := font.Height;
  info.size := font.Size;
  info.style := StylesToBit(font.Style);
  info.color := font.Color; //Fǉ
end;

procedure TJaneConfig.SetFont(var font: TFont; info: TFontInfo);
begin
  font.Name := info.face;
  font.Charset := info.charset;
  font.Height := info.height;
  if info.size <> 0 then
    font.Size := info.size;
  font.Style := BitToFontStyles(info.style);
  font.Color := info.color; //Fǉ
end;

(* \ttpXɕϊ *)
function TJaneConfig.GetFullPath(path: string): string;
begin
  if (length(path) >= 2) and
     ((path[2] = ':') or (Copy(path, 1, 2) = '\\')) and
     DirectoryExists(path) then
    result := path
  else
    result := BasePath + path;
  if (path[length(path)] <> '\') then
    result := result + '\';
  if (result = '\') or not DirectoryExists(result) then
    result := BasePath;
end;

end.
