unit U2chBoard;
(* 2˂@{[hiXbhꗗj *)
(* Copyright (c) 2001,2002 Twiddle <hetareprog@hotmail.com> *)

interface

uses
  Classes, SysUtils, StrUtils, DateUtils,
  U2chThread, FileSub, StrSub, UBoardCustomize
  (*[457]*), UFavorite;

const
  HOST_BRDFUNCTIONAL = 'Jane';

type
  (*-------------------------------------------------------*)
  TBBSType = (bbsNone, bbs2ch, bbsJBBS, bbsShitaraba, bbsJBBSShitaraba, bbsMachi, bbsOther);
  (*-------------------------------------------------------*)
  (*  = Xꗗ *)
  TBoard = class(TList)
  protected
    refCount: integer;
    subjectTxt: string;
    datModified : boolean;
    idxModified : boolean;
    bbstype: TBBSType;
    moved: boolean;
    FHost: string;
    FSelDatName: string;
    FCustomHeader: string;
    FUma: boolean;
    FCustomize: TBoardCustomizeData;
    function GetItems(index: integer): TThreadItem;
    procedure SetItems(index: integer; value: TThreadItem);
    procedure MergeCache;
    procedure ChangeThreadItemURI;
    procedure SetSelDatName(const datName: string);
    procedure SetCustomHeader(const str: string);
    procedure SetUma(val: boolean);
    procedure SetHost(newHost: string); virtual;
    function GetMaxResNum: Integer;
    class procedure PutToRecyleList(Board: TBoard);
    class function  RemoveFromRecyleList(Board: TBoard): Boolean;
    class procedure FlushRecyleList;
  public
    redirect: TBoard;       (* u߁vƂ̏dpBgp  *)
    category: TObject;      (* {TCategoryBAhĈŃLXgĎg  *)
    name: string;           (*  *)
    bbs:  string;
    lastModified: string;
    past: Boolean;          (* ߋO{[h *)
    lastAccess: TDateTime;
    sortColumn: integer;    (* Xꗗł̃\[g *)
    threadSearched: Boolean; (* Xꗗł̃Xiݏ *)
    timeValue: Int64;       (* T[o bbs.cgiւPOSTɎgp *)
    constructor Create(category: TObject);
    destructor Destroy; override;
    procedure Clear; override;
    procedure SafeClear; virtual;
    procedure AddRef; virtual;
    procedure Release; virtual;
    procedure Analyze((*const*) txt: string; const lstModified: string; refresh: boolean);
    property Items[index: integer]: TThreadItem read GetItems write SetItems;
    function Find(const datName: string): TThreadItem; overload;
    function GetLogDir: string;
    function GetURIBase: string;
    function Refered: boolean;
    function GetBBSType: TBBSType;
    procedure LoadIndex; virtual;
    procedure Load; virtual;
    procedure SaveIndex; virtual;
    procedure Save; virtual;
    procedure Activate;
    procedure ResetListState;
    procedure AssignCustomizeData(BoardCustomize: TBoardCustomize);
    property selDatName: string read FSelDatName write SetSelDatName;
    property customHeader: string read FCustomHeader write SetCustomHeader;
    property subjectText: string read subjectTxt;
    property uma: boolean read FUma write SetUma;
    property host: string read FHost write SetHost;
    property MaxResNum: Integer read GetMaxResNum;
  end;

  (*-------------------------------------------------------*)
  //[457]
  TFunctionalBoard = class(TBoard)
  public
    procedure LoadIndex; override;
    procedure Load; override; abstract;
    procedure SaveIndex; override;
    procedure Save; override;
    procedure Clear; override;
    procedure SafeClear; override;
    procedure SetHost(newHost: string); override;
    procedure Release; override;
  end;

  (*-------------------------------------------------------*)
  //[457]
  TFavoriteListBoard = class(TFunctionalBoard)
  protected
    favs: TFavoriteList;
    favChanged: boolean;
  public
    constructor Create(category: TObject; favs: TFavoriteList = nil);
    procedure Load; override;
    procedure SetFavList(favList: TFavoriteList);
  end;

  (*-------------------------------------------------------*)
  //[457]
  TLogListBoard = class(TFunctionalBoard)
  public
    constructor Create(category: TObject);
    procedure Load; override;
  end;

  (*-------------------------------------------------------*)
  //[457]
  (* ƂĊJCɓێ *)
  TFavoriteListBoardAdmin = class(TObject)
  protected
    objlist: TList;
    category: TObject;
  public
    constructor Create(category: TObject);
    destructor Destroy; override;
    function GetBoard(favs: TFavoriteList): TFavoriteListBoard;
    procedure GarbageCollect();
  end;

  (*-------------------------------------------------------*)
  (* X^uɊJĂێ *)
  TBoardList = class(TList)
  private
    procedure Open(board: TBoard);
    procedure Close(board: TBoard);
    function GetItems(index: integer): TBoard;
    procedure SetItems(index: integer; board: TBoard);
  public
    procedure Add(board: TBoard);
    procedure Insert(index: integer; board: TBoard);
    procedure Delete(index: integer);
    property Items[index: integer]: TBoard read GetItems write SetItems;
  end;


(*=======================================================*)
implementation
(*=======================================================*)

uses
  U2chCat, Main;

const
  SUBJECT_TXT = '\subject.txt';
  SUBJECT_IDX = '\subject.idb';

  IDX_TITLE        = 0; (* Subject of the board *)
  IDX_MODIFIED     = 1; (* Last-Modified: ̒l *)
  IDX_SELECTED     = 2; (* I𒆂dat *)
  IDX_CUSTOMHEADER = 3;
  IDX_MARKER       = 4;

(*=======================================================*)

(* TBoard̔j҂XgpNX֐Q *) // beginner

var
  RecycleList: TList;

{j}
class procedure TBoard.PutToRecyleList(Board: TBoard);
begin
  if RecycleList.IndexOf(Board) < 0 then
    RecycleList.Add(Board);
  FlushRecyleList;
end;

class function TBoard.RemoveFromRecyleList(Board: TBoard): Boolean;
begin
  Result := (RecycleList.Remove(Board) >= 0);
end;

class procedure TBoard.FlushRecyleList;
begin
  while RecycleList.Count > Config.brdRecyclableCount do
    TBoard(RecycleList[0]).SafeClear;
end;

(*=======================================================*)

(* \z *)
constructor TBoard.Create(category: TObject);
begin
  inherited Create;
  self.redirect := nil;
  self.category := category;
  self.refCount := 0;
  self.FUma := false;
  datModified := false;
  idxModified := false;
  past := false;
  lastAccess := 0;
  bbstype := bbsNone;
  moved := false;
end;

(* j *)
destructor TBoard.Destroy;
begin
  Save;
  Clear;
  FCustomize.Release;
  inherited;
end;

(* | *)
procedure TBoard.Clear;
var
  index: integer;
begin
  for index := 0 to Count -1 do
  begin
    Items[index].Free;
  end;
  RemoveFromRecyleList(Self);
  inherited;
end;

(* Â *)
procedure TBoard.SafeClear;
var
  i: integer;
begin
  for i := 0 to Count -1 do
  begin
    if not Items[i].Refered then
    begin
      Items[i].Free;
      Items[i] := nil;
    end;
  end;
  Pack;
  if Count <= 0 then
  begin
    self.subjectTxt := '';
    self.lastModified := '';
    self.datModified := false;
    self.idxModified := false;
  end;
  RemoveFromRecyleList(Self);
end;

(* QƑ *)
procedure TBoard.AddRef;
begin
  if (refCount = 0) and not(RemoveFromRecyleList(Self)) then
    Load;
  Inc(refCount);
end;

(* Ȃ *)
procedure TBoard.Release;
begin
  Dec(refCount);
  if refCount <= 0 then
    PutToRecyleList(Self);
end;

(* QƒH *)
function TBoard.Refered: boolean;
begin
  if 0 < refCount then
  begin
    result := true;
  end
  else begin
    SafeClear;
    result := (0 < Count);
  end;
end;

(* Xbhꗗ͂ *)
procedure TBoard.Analyze((*const*) txt: string; const lstModified: string; refresh: boolean);
var
  refered: TList;

  (* w肳ꂽdat̃XT *)
  function GetReferedThreadItem(const datName: string): TThreadItem;
  var
    i: integer;
  begin
    for i := 0 to refered.Count -1 do
    begin
      if AnsiCompareStr(TThreadItem(refered.Items[i]).datName, datName) = 0 then
      begin
        result := TThreaditem(refered.Items[i]);
        refered.Delete(i);
        exit;
      end;
    end;
    result := nil;
  end;

  (* ؂T *)
  function findDelimiter(i: integer; endOfRec: integer): integer;
  begin
    while (i <= endOfRec) do
    begin
      case txt[i] of
      ',': begin result := i; exit; end;
      '<': begin result := i; exit; end;
      end;
      Inc(i);
    end;
    result := 0;
  end;

  (*  *)
  function topOfSubject(i: integer): integer;
  begin
    case txt[i] of
    ',': result := i + 1;
    '<':
      begin
        if (i < length(txt) -1) and (txt[i+1] = '>') then
          result := i + 2
        else
          result := i + 1;
      end;
    else
      result := 0;
    end;
  end;

  (*  *)
  function endOfSubject(index, endOfRec: integer): integer;
  var
    i: integer;
  begin
    for i := endOfRec downto index do
    begin
      if (txt[i] = '(') or (txt[i] = '<') or
         ((i < endOfRec) and (txt[i] = #$81) and (txt[i+1] = #$69))then
      begin
        if (index <= i -1) and (txt[i-1] = ' ') then
          result := i -1
        else
          result := i;
        exit;
      end;
    end;
    result := 0;
  end;

  (* ԍ̐擪 *)
  function topOfNums(index, endOfRec: integer): integer;
  var
    i: integer;
  begin
    for i := index to endOfRec do begin
      case Ord(txt[i]) of
      $30..$39: begin result := i; exit; end;
      end;
    end;
    result := 0;
  end;

  function endOfNums(index, endOfRec: integer): integer;
  var
    i: integer;
  begin
    for i := index to endOfRec do begin
      case Ord(txt[i]) of
      $30..$39:;
      else
        begin result := i; exit; end;
      end;
    end;
    result := endOfRec;
  end;

  function endOfRecord(i: integer): integer;
  var
    len: integer;
  begin
    len := Length(txt);
    while (i <= len) do begin
      if (Ord(txt[i]) = 10) then begin
        result := i;
        exit;
      end;
      Inc(i);
    end;
    result := 0;
  end;

  procedure addRecord(i: integer; endOfRec: integer);
  var
    refPos, refEnd: integer;
    item: TThreadItem;
    datName: string;
    subject: string;
    nums: string;
    num: integer;
  begin
    (* dat-name delimiter subject space (num) *)
    (* dat *)
    refPos := i;
    refEnd := findDelimiter(i, endOfRec);
    if (refEnd <= 0) then
      exit;
    datName := ChangeFileExt(Copy(txt, refPos, refEnd - refPos), '');
    (* subject *)
    refPos := topOfSubject(refEnd);
    refEnd := endOfSubject(refPos, endOfRec);
    subject := Copy(txt, refPos, refEnd - refPos);
    (* num擾 *)
    refPos := topOfNums(refEnd, endOfRec);
    refEnd := endOfNums(refPos, endOfRec);
    nums := Copy(txt, refPos, refEnd - refPos);
    try
      num := StrToInt(nums);
    except
      num :=0;
    end;
    (* *)
    item := GetReferedThreadItem(datName);
    if item = nil then
      item := TThreadItem.Create(self);
    if 0 < Pos(#0, subject) then
      subject := ReplaceStr(subject, #0, ' ');
    item.title := subject;
    item.datName := datName;
    item.itemCount := num;
    //item.contemporary := true;
    Add(item);
    item.number := Count;
  end;

var
  i, len: integer;
  endOfRec: integer;
  firstline: string;
begin
  if refresh then
    SafeClear;
  refered := TList.Create;
  for i := 0 to Count -1 do
  begin
    refered.Add(Items[i]);
  end;
  inherited Clear;

  if GetBBSType = bbsShitaraba then
    txt := AnsiReplaceStr(txt, '<><>NULL<>'#10, #10);
  len := length(txt);
  if GetBBSType in [bbsJBBSShitaraba, bbsJBBS] then
  begin
    firstline := Copy(txt, 1, Pos(#10, txt));
    if AnsiEndsStr(firstline, txt) and (Length(firstline) < len) then
    begin
      len := len - Length(firstline);
      SetLength(txt, len);
    end;
  end;

  i := 1;
  while i < len do
  begin
    endOfRec := endOfRecord(i);
    if (endOfRec <= 0) then
      break;
    addRecord(i, endOfRec);
    i := endOfRec + 1;
  end;

  for i := 0 to refered.Count -1 do
  begin
    if not refresh and (TThreadItem(refered[i]).lines <= 0) and
       not TThreadItem(refered[i]).Refered then
      TThreadItem(refered[i]).Free
    else begin
      TThreadItem(refered[i]).number := 0; //false;
      Add(refered[i]);
    end;
  end;
  refered.Free;
  if refresh then
    MergeCache;
  if moved then
    ChangeThreadItemURI;
  self.subjectTxt := txt;
  self.lastModified := lstModified;
  self.datModified := true;
  self.idxModified := true;
end;

(*  *)
function TBoard.GetItems(index: integer): TThreadItem;
begin
  result := inherited Items[index];
end;

(*  *)
procedure TBoard.SetItems(index: integer; value: TThreadItem);
begin
  inherited Items[index] := value;
end;

(* w肳ꂽdat̃XT *)
function TBoard.Find(const datName: string): TThreadItem;
var
  i, endPos: integer;
  thread: TThreadItem;
begin
  endPos := Count -1;
  for i := 0 to endPos do begin
    thread := Items[i];
    if (thread <> nil)
      and (datName = thread.datName) then begin
      result := thread;
      exit;
    end;
  end;
  result := nil;
end;

(* LbV}[W *)
procedure TBoard.MergeCache;
var
  path: string;
  sr: TSearchRec;
  item: TThreadItem;
  datName: string;
  URI: string;
  MergingList: TList;
begin
  MergingList := TList.Create;
  path := self.GetLogDir + '\*.dat';
  if FindFirst(path, faArchive, sr) = 0 then begin
    URI := GetURIBase;
    repeat
      datName := ChangeFileExt(sr.Name, '');
      item := Find(datName);
      if item <> nil then
      begin (* sXbh *)
        if not item.Refered then
          item.LoadIndexData(true);
        if (item.URI <> URI) and ((item.state <> tsComplete) and (item.itemCount > 0)) then
        begin
          item.URI := URI;
          item.state := tsCurrency;
          item.SaveIndexData;
        end;
      end
      else begin
        item := TThreadItem.Create(self);
        item.datName := datName;
        item.LoadIndexData;
        if (Main.Config.datDeleteOutOfTime) and (not FUma) and
           (item.mark = timNONE) then
        begin
          item.RemoveLog;
          item.Free;
        end
        else
          MergingList.Add(item);
      end;
    until FindNext(sr) <> 0;
    FindClose(sr);
  end;
  Assign(MergingList, laOr);
  MergingList.Free;
end;

function TBoard.GetLogDir: string;
begin
  if assigned(redirect) then
    result := redirect.GetLogDir
  else
    result := TCategory(category).GetLogDir + '\' + Convert2FName(name);
end;

function TBoard.GetURIBase:string;
begin
  result := 'http://' + FHost + '/' + bbs;
end;


procedure TBoard.LoadIndex;
var
  fname: string;
  strList: TStringList;
begin
  fname := GetLogDir + SUBJECT_IDX;
  strList := TStringList.Create;
  lastModified := '';
  selDatName := '';
  FUma := false;
  if FileExists(fname) then
  begin
    try
      strList.LoadFromFile(fname);
      lastModified  := strList.Strings[IDX_MODIFIED];
      selDatName   := strList.Strings[IDX_SELECTED];
      FCustomHeader := strList.Strings[IDX_CUSTOMHEADER];
      try FUma := Boolean(StrToInt(strList.Strings[IDX_MARKER])); except end;
    except
    end;
  end;
  strList.Free;
end;

(* ۑXꗗ擾 *)
procedure TBoard.Load;
var
  stream: TPSStream;
  fname: string;
  txt, modified: string;
begin
  fname := GetLogDir + SUBJECT_TXT;
  subjectTxt := '';
  if FileExists(fname) then
  begin
    stream := TPSStream.Create('');
    try
      stream.LoadFromFile(fname);
      Txt := stream.DataString;
    except
    end;
    stream.Free;
  end;

  LoadIndex;
  modified := lastModified;

  Analyze(Txt, modified, refcount <= 0);
  datModified := false;
  idxModified := false;
end;

procedure TBoard.SaveIndex;
var
  strList: TStringList;
begin
  if idxModified then
  begin
    RecursiveCreateDir(GetLogDir);
    strList := TStringList.Create;
    strList.Add(self.name);
    strList.Add(self.lastModified);
    strList.Add(self.selDatName);
    strList.Add(self.FCustomHeader);
    strList.Add(IntToStr(Integer(self.FUma)));
    try
      strList.SaveToFile(GetLogDir + SUBJECT_IDX);
    except
    end;
    strList.Free;
    idxModified := false;
  end;
end;

(* Xꗗۑ *)
procedure TBoard.Save;
var
  stream: TPSStream;
begin
  if datModified then
  begin
    RecursiveCreateDir(GetLogDir);
    stream := TPSStream.Create(subjectTxt);
    try
      stream.SaveToFile(GetLogDir + SUBJECT_TXT);
    except
    end;
    stream.Free;
    datModified := false;
  end;
  SaveIndex;
end;

(*  *)
procedure TBoard.Activate;
begin
  if length(subjectTxt) <= 0 then
    Load;
end;

procedure TBoard.SetSelDatName(const datName: string);
begin
  FSelDatName := datName;
  idxModified := true;
end;

procedure TBoard.SetCustomHeader(const str: string);
begin
  FCustomHeader := str;
  idxModified := true;
end;

procedure TBoard.SetUma(val: boolean);
begin
  FUma := val;
  idxModified := true;
end;

function TBoard.GetBBSType: TBBSType;
var
  i: integer;
begin
  if bbstype = bbsNone then
  begin
    for i := 0 to Config.bbs2chServers.Count -1 do
    begin
      if AnsiEndsStr(Config.bbs2chServers[i], FHost) then
      begin
        bbstype := bbs2ch;
        result := bbs2ch;
        exit;
      end;
    end;
    for i := 0 to Config.bbsMachiServers.Count -1 do
    begin
      if AnsiEndsStr(Config.bbsMachiServers[i], FHost) then
      begin
        bbstype := bbsMachi;
        result := bbsMachi;
        exit;
      end;
    end;
    for i := 0 to Config.bbsJBBSServers.Count -1 do
    begin
      if AnsiStartsStr(Config.bbsJBBSServers[i], FHost) then
      begin
        bbstype := bbsJBBSShitaraba;
        result := bbsJBBSShitaraba;
        exit;
      end;
    end;
    if AnsiStartsStr('www.jbbs.net', FHost) or AnsiStartsStr('green.jbbs.net', FHost) then
      bbstype := bbsJBBS
    else if AnsiStartsStr('www.shitaraba.com', FHost) then
      bbstype := bbsShitaraba
    else
      bbstype := bbsOther
  end;
  result := bbstype;
end;

(* Xꗗł̏ԂZbg *)
procedure TBoard.ResetListState;
var
  i: integer;
begin
  if not Config.oprSelPreviousThread then //ŌɌĂʒuփWvȂ΃NA
    selDatName := '';
  if Config.optAutoSort then //\[gԂ̏
    sortColumn := 0
  else
    SortColumn := 1;

  if threadSearched then //iĂX̌ԂNA
  begin
    for i := 0 to Count -1 do
      Items[i].liststate := 0;
    threadSearched := false;
  end;
end;

procedure TBoard.SetHost(newHost: string);
begin
  if StartWith('jbbs.',  newHost, 1) and
     not StartWith(Config.bbsJBBSServers[0], newHost, 1) then
      newHost := Config.bbsJBBSServers[0] + Copy(newHost, FindPos('/', newHost, 5), High(Integer));
  if newHost = FHost then
    exit;
  FHost := newHost;
  if Count > 0 then
    moved := true; //AnalyzeChangeThreadItemURIĂяo
end;

(* hostύXۂɎq̃XbhURIC *)
procedure TBoard.ChangeThreadItemURI;
var
  URI: String;
  i: Integer;
begin
  URI := GetURIBase;
  for i := 0 to Count - 1 do
    if Assigned(Items[i]) and (Items[i].URI <> '') and (Items[i].number > 0) and
       ((Items[i].state <> tsComplete) and (Items[i].itemCount > 0)) then
    begin
      Items[i].URI := URI;
      Items[i].state := tsCurrency;
      Items[i].SaveIndexData;
    end;
  moved := false;
end;

function TBoard.GetMaxResNum: Integer;
begin
  if FCustomize.MaxResNum = BRDCUST_DEF_MAXRESNUM then
  begin
    case GetBBSType of
      bbs2ch:   Result := 1000;
      bbsMachi: Result := 1000;
    else
      Result := 100000;
    end;
  end else
    Result := FCustomize.MaxResNum;
end;

procedure TBoard.AssignCustomizeData(BoardCustomize: TBoardCustomize);
var
  NewCustomize: TBoardCustomizeData;
begin
  if host = HOST_BRDFUNCTIONAL then
    NewCustomize := BoardCustomize.Null
  else
    NewCustomize := BoardCustomize.Items[getURIBase + '/'];
  if FCustomize <> NewCustomize then
  begin
    FCustomize.Release;
    FCustomize := NewCustomize;
    FCustomize.AddRef;
  end;
end;

(*=======================================================*)
procedure TFunctionalBoard.LoadIndex;
begin
end;

procedure TFunctionalBoard.SaveIndex;
begin
end;

procedure TFunctionalBoard.Save;
begin
end;

procedure TFunctionalBoard.Clear;
begin
  SafeClear;
  inherited;
end;

//Qƒ̃X͖{̔ɕԂ
procedure TFunctionalBoard.SafeClear;
var
  i: integer;
begin
  for i := 0 to Count -1 do
  begin
    if Items[i] <> nil then
    begin
      Items[i].Release;
      Items[i] := nil;
    end;
  end;
  Pack;
//  RemoveFromRecyleList(Self);
end;

procedure TFunctionalBoard.Release;
begin
  Dec(refCount);
  if refCount <= 0 then
    SafeClear;
end;

procedure TFunctionalBoard.SetHost(newHost: string);
begin
  FHost := newHost;
end;

(*=======================================================*)

//Oꗗ
procedure TLogListBoard.Load;
var
  i, j, k:integer;
  datcount: integer;
  board: TBoard;
  path: string;
  sr: TSearchRec;
  item: TThreadItem;
begin
  for i := 0 to i2ch.Count -1 do
  begin
    for j := 0 to i2ch.Items[i].Count -1 do
    begin
      board := i2ch.Items[i].Items[j];
      path := board.GetLogDir + '\*.dat';

      //datt@C
      if FindFirst(path, faArchive, sr) <> 0 then
        continue;
      if (Main.Config.optLogListLimitCount > 0) then //
      begin
        datCount := 0;
        repeat
          Inc(datCount);
          if (Main.Config.optLogListLimitCount <= datCount) then
          begin
            datCount := 0;
            break;
          end;
        until (FindNext(sr) <> 0);
      end else  //Ȃ
        datCount := 1;

      FindClose(sr);
      if datcount = 0 then
        continue;

      board.AddRef;
      for k := 0 to board.Count -1 do
      begin
        item := board.items[k];
        if item.lines > 0 then //X
        begin
          item.AddRef(false); //OꗗŎQƒ
          self.Add(item);
        end;
      end;
      board.Release;
    end;
  end;
end;

//[457]
constructor TLogListBoard.Create(category: TObject);
begin
  inherited;
  //test
  FHost := HOST_BRDFUNCTIONAL;   //KǂCɓŎg߂
  bbs := 'Log';
  Name := 'Oꗗ';
end;

(*=======================================================*)
//[457]
constructor TFavoriteListBoard.Create(category: TObject; favs: TFavoriteList);
begin
  inherited Create(category);
  if favs = nil then
    favs := favorites;
  FHost := HOST_BRDFUNCTIONAL;
  bbs := favs.name;// 'fav';
  SetFavList(favs);
end;

//[457]
procedure TFavoriteListBoard.Load;
var
  //list: TList;
  refBoard: TList;

  //OtH_Ń\[g
  {function CompareFunc(Item1, Item2: Pointer): integer;
  begin
    result := AnsiCompareFileName(TBoard(TThreadItem(Item1).board).GetLogDir,
                                  TBoard(TThreadItem(Item2).board).GetLogDir);
  end;}
  //boardŃ\[g
  {function CompareFunc(Item1, Item2: Pointer): integer;
  var
    cat: TCategory;
  begin
    result := i2ch.IndexOf(TBoard(TThreadItem(Item1).board).category)
            - i2ch.IndexOf(TBoard(TThreadItem(Item2).board).category);
    if result <> 0 then
      exit;
    cat := TBoard(TThreadItem(Item1).board).category as TCategory;
    result := cat.IndexOf(TBoard(TThreadItem(Item1).board))
            - cat.IndexOf(TBoard(TThreadItem(Item2).board));
  end;

  //subject.txt烌X擾
  procedure LoadSubjectData;
  var
    subject: TStringList;

    //wdat̃X擾
    function GetItemCountFromSubject(datName: string): integer;
    var
      index, len, i: integer;
    begin
      result := 0;
      subject.Find(datName, index);
      if not AnsiStartsStr(datName, subject[index]) then
        exit;
      len := length(subject[index]);
      for i := len downto 0 do
      begin
        if subject[index][i]= '(' then
        begin
          result := StrToIntDef(copy(subject[index], i+1, len - (i+1)), 0);
          exit;
        end;
      end;
    end;

  var
    i: Integer;
    prevsubjectname, tmpsubjectname: string;
    item: TThreadItem;
  begin
    subject := TStringList.Create;
    for i:=0 to list.Count-1 do
    begin
      item := TThreadItem(list.Items[i]);
      tmpsubjectname := TBoard(item.board).GetLogDir + SUBJECT_TXT;
      if prevsubjectname <> tmpsubjectname then
      begin
        try
          prevsubjectname := tmpsubjectname;
          subject.LoadFromFile(tmpsubjectname);
          //Log(tmpsubjectname);
          subject.Sort;
        except
          continue;
        end;
      end;
      item.itemCount := GetItemCountFromSubject(item.datName);
    end;
    subject.Free;
  end;
  }
  procedure AddItem(fav: TFavorite);
  var
    item: TThreadItem;
    board: TBoard;
  begin
    //XłȂAo^ς݁A{[h̃f[^ȂCɓ͖
    if fav.datName = '' then
      exit;
    item := self.Find(fav.datName);
    if (item <> nil) and (TBoard(item.board).bbs = fav.bbs) then
      exit;
    board := i2ch.FindBoard(fav.host, fav.bbs);
    if board = nil then
      exit;
    //[h
    if refBoard.IndexOf(board) < 0 then
    begin
      board.AddRef;
      refBoard.Add(board);
    end;
    //X[hTĂCɓɉ
    item := board.Find(fav.datName);
    if item = nil then
    begin
      item := TThreadItem.Create(board);
      item.datName := fav.datName;
      item.LoadIndexData;
      if item.title = '' then
        item.title := fav.name;
      board.Add(item)
    end;
    item.AddRef(false); //CɓŎQƒ
    //list.Add(item);
    self.Add(item);
  end;

  procedure AddFavList(favs: TFavoriteList);
  var
    i: Integer;
  begin
  for i := 0 to favs.Count - 1 do
    if (favs.Items[i] is TFavorite) then
      AddItem(TFavorite(favs.Items[i]))
    else if (favs.Items[i] is TFavoriteList) then
    begin
      AddFavList(TFavoriteList(favs.Items[i]));
    end;
  end;
var
  i: integer;
begin
  for i := 0 to Count -1 do
  begin
    Items[i].Release;
    if not Items[i].Refered then
    Items[i] := nil;
  end;
  Pack;
  //list := TList.Create;
  refBoard := TList.Create;
  AddFavList(favs);
  //list.Sort(@CompareFunc);
  //LoadSubjectData;
  //list.Free;
  for i := 0 to refBoard.Count -1 do
    TBoard(refBoard.Items[i]).Release;
  refBoard.Free;
  favChanged :=false;
end;

procedure TFavoriteListBoard.SetFavList(favList: TFavoriteList);
begin
  favChanged := favs <> favList;
  if favChanged then
  begin
    favs := favList;
    name := favList.name;
  end;
end;

(*=======================================================*)
//[457]
function TFavoriteListBoardAdmin.GetBoard(favs: TFavoriteList): TFavoriteListBoard;
var
  i: Integer;
  favsboard: TFavoriteListBoard;
begin
  result := nil;
  for i := 0 to objlist.Count - 1 do
  begin
    if TFavoriteListBoard(objlist.Items[i]).bbs = favs.name then
    begin
      result := TFavoriteListBoard(objlist.Items[i]);
      break;
    end;
  end;

  if not Assigned(result) then
  begin
    favsboard := TFavoriteListBoard.Create(category, favs);
    objlist.Add(favsboard);
    result := favsboard;
  end
end;

//[457]
constructor TFavoriteListBoardAdmin.Create(category: TObject);
begin
  inherited Create;
  self.category := category;
  objlist := TList.Create;
end;

//[457]
destructor TFavoriteListBoardAdmin.Destroy;
var
  i: Integer;
begin
  for i:=objlist.Count-1 downto 0 do
  begin
    TFavoriteListBoard(objlist.Items[i]).Free;
    objlist.Delete(i);
  end;
  objlist.Free;
  inherited;
end;

//[457]
procedure TFavoriteListBoardAdmin.GarbageCollect;
var
  i: integer;
begin
  for i:=objlist.Count-1 downto 0 do
  begin
    if (TFavoriteListBoard(objlist.Items[i]).refCount <= 0) and
       (boardList.IndexOf(objlist.Items[i]) < 0) then
    begin
      TFavoriteListBoard(objlist.Items[i]).Free;
      objlist.Delete(i);
    end;
  end;
end;


(*=======================================================*)
(* X^uɔJ *)
procedure TBoardList.Open(board: TBoard);
begin
  board.AddRef; //X^uł̎QƑ
  board.ResetListState;
end;

(* X^uJ *)
procedure TBoardList.Close(board: TBoard);
var
  i: integer;
begin
  if board.threadSearched then //iĂcX̌ԂNA
  begin
    for i := 0 to Count -1 do
      board.Items[i].liststate := 0;
    board.threadSearched := false;
  end;
  board.Release; //X^uł̎QƏI
end;

(* LXg *)
function TBoardList.GetItems(index:integer): TBoard;
begin
  result := inherited Items[index];
end;

(* ̓ւ *)
procedure TBoardList.SetItems(index: integer; board: TBoard);
begin
  Close(Items[index]);
  Open(board);
  inherited Items[index] := board;
end;

(* ڒǉ *)
procedure TBoardList.Add(board: TBoard);
begin
  Open(board);
  inherited Add(board);
end;

procedure TBoardList.Insert(index: integer; board: TBoard);
begin
  Open(board);
  inherited Insert(index, board);
end;

(* ڍ폜 *)
procedure TBoardList.Delete(index: integer);
begin
  Close(Items[index]);
  inherited Delete(index);
end;

initialization
  RecycleList := TList.Create;
finalization
  RecycleList.Free;
end.
