unit UViewItem;
(* X̒g\WebBrowserTThreadItem̊֘At *)
(* Copyright (c) 2001,2002 Twiddle <hetareprog@hotmail.com> *)

interface

uses
   SysUtils,
   Classes,
   Controls,
   ExtCtrls,
   AppEvnts,
   Messages,
   {$IFDEF IE}
   SHDocVw_TLB,
   MSHTML_TLB,
   ActiveX,
   HTMLDocumentEvent,
   {$ENDIF}
   HogeTextView,
   UTVSub,
   UPopupTextView,
   StrUtils,
   Forms,
   IdGlobal, Types, Windows,
   U2chThread, U2chBoard, U2chCat, U2chCatList, UAsync, JConfig, UDat2HTML,
   USynchro, StrSub, StdCtrls;

{const
  TESTVER = 'test71+75';
  SYRUPTESTVER = 'Syrup_test35';}
type
  ECancelViewException = class (Exception);

  {$IFDEF IE}
  (* WebBrowserWriteOɃobt@OXg[ *)
  (* ꎞt@CĂ̖c *)
  TWebOutBufferStream = class(THTMLDatOut)
  protected
    FStream: TMemoryStream;
    browser: TWebBrowser;
    //hintForProcessMessages: integer;
    re_entrant: integer;
    canceled: boolean;
  public
    //flushThreshold: integer;
    constructor Create(browser: TWebBrowser);
    destructor Destroy; override;
    function ExtractCache: string;
    procedure WriteText(str: PChar; size: integer); override;
    procedure Flush; override;
    procedure Cancel;
  end;

  {beginner}
  TWebOutBufferStreamForExtraction = class(TWebOutBufferStream)
  public
    Base:string;
    BBSType: TBBSType;
    procedure WriteAnchor(const Name: string;
                          const HRef: string;
                          str: PChar; size: integer); override;
  end;
  {/beginner}

  {$ENDIF}

  TDat2View = class(TConvDatOut)
  protected
    FBrowser: THogeTextView;
    re_entrant: integer;
    canceled: boolean;
    FAttribute: THogeAttribute;
    FBold: THogeAttribute;
    FStream: THogeMemoryStream;
    flushCount: integer;
    FOffsetLeft: integer;
    FBiteSpaces: boolean;
    FUser: integer;
    FHref: string;
    EnableFontTag: boolean;
    FDDOffsetLeft: Integer;
    function ProcTag: boolean; override;
    function ProcEntity: boolean; override;
    function ProcBlank: boolean; override;
    procedure BeginAnchor; virtual;
    procedure EndAnchor; virtual;
  public
    constructor Create(browser: THogeTextView);
    destructor Destroy; override;
    procedure WriteText(str: PChar; size: integer); override;
    procedure WriteAnchor(const Name: string;
                          const HRef: string;
                          str: PChar; size: integer); override;
    procedure WriteChar(c: Char); override;
    procedure WriteUNICODE(str: PChar; size: integer);
    procedure WriteBR;
    procedure SetBold(boldP: boolean);
    procedure Flush; override;
    procedure Cancel;
    property DDOffsetLeft: Integer read FDDOffsetLeft write FDDOffsetLeft;
  end;

  TDat2PopupView = class(TDat2View)
  public
    function ProcBlank: boolean; override;
    procedure WriteChar(c: Char); override;
  end;

  {$IFNDEF IE}
  TDat2ViewForExtraction = class(TDat2View)
  public
    Base:string;
    BBSType: TBBSType;
    procedure WriteAnchor(const Name: string;
                          const HRef: string;
                          str: PChar; size: integer); override;
  end;
  {$ENDIF}

  TSimpleDat2View = class(TDat2View)
  protected
    function ProcTag: boolean; override;
    procedure ProcHTML; override;
    procedure BeginAnchor; override;
    procedure EndAnchor; override;
  public
    procedure Flush; override;
  end;

  (*-------------------------------------------------------*)
  TViewList = class;
  TProgState = (tpsNone, tpsProgress, tpsReady, tpsWorking, tpsDone);

  BoolArray = array of boolean;

  (* TWebBrowserTTreadItem̊֘At *)

  TPopupViewItem = class;
  TPopupViewList = class;

  (* ʂ̃X[p[NX *)
  TBaseViewItem = class(TObject)
  protected
    FThread: TThreadItem;
    FPossessionView: TPopupViewItem;
    FLockCount: Integer;
    FPopupViewList: TPopupViewList;
    function GetBaseItem: TBaseViewItem; virtual; abstract;
    function GetBaseThread: TThreadItem; virtual;
    function GetRootControl: TWinControl; virtual; abstract;
    function GetDerivativeBrowser: TControl; virtual; abstract;
    function GetDerivativeStream: TDatOut; virtual; abstract;
    function GetStreamCanceled: Boolean; virtual; abstract;
    function _ExtractKeyWord(thread: TThreadItem; dest: TDatOut;
      target: String; Max: Integer): Integer;
  public
    constructor Create;
    destructor Destroy; override;
    procedure Cancel; virtual; abstract;
    function GetSelection: String; virtual; abstract;
    function GetFocusedLink: String; virtual;
    procedure SelectAll; virtual;
    procedure Lock; virtual;
    procedure UnLock; virtual;
    function Locked: Boolean;
    procedure ReleasePossessionView;
    function IsMouseInPane: Boolean; virtual;
    function BrowserQueryClose: Boolean; virtual;
    function ValidateURI(source: String; var full: String): Boolean; virtual;
    property BaseItem: TBaseViewItem read GetBaseItem;
    property BaseThread: TThreadItem read GetBaseThread;
    property thread: TThreadItem read FThread;
    property PossessionView:TPopupViewItem read FPossessionView;
    property RootControl: TWinControl read GetRootControl;
    property PopUpViewList: TPopupViewList read FPopupViewList;
  end;

  (* Doe,DoeꂼTHogeTextView,TWebBrowserǗ邽߂̊bNX *)

  TPlainViewItem = class(TBaseViewItem)
  protected
    FRootControl: TWinControl;
    {$IFDEF IE}
    FBrowser: TWebBrowser;
    FStream: TWebOutBufferStream;
    FEvent: THTMLDocumentEventSink;
    {$ELSE}
    FBrowser: THogeTextView;
    FStream: TDat2View;
    {$ENDIF}
    {$IFDEF IE}
    procedure SetBrowser(value: TWebBrowser);
    {$ELSE}
    procedure SetBrowser(value: THogeTextView);
    {$ENDIF}
    function GetBaseItem: TBaseViewItem; override;
    function GetRootControl: TWinControl; override;
    function GetDerivativeBrowser: TControl; override;
    function GetDerivativeStream: TDatOut; override;
    function GetStreamCanceled: Boolean; override;
  public
    {$IFDEF IE}
    constructor Create;
    destructor Destroy; override;
    property browser: TWebBrowser read FBrowser write SetBrowser;
    property stream: TWebOutBufferStream read FStream;
    property event: THTMLDocumentEventSink read FEvent write FEvent;
    {$ELSE}
    property browser: THogeTextView read FBrowser write SetBrowser;
    property stream: TDat2View read FStream;
    {$ENDIF}
    function GetSelection: String; override;
    procedure Cancel; override;
    property RootControl: TWinControl read GetRootControl write FRootControl;
    property PopUpViewList: TPopupViewList read FPopupViewList write FPopupViewList;
  end;

  (* vr[Ŏg߂̔ėpviewItem *)

  // TViewItembrowserthread̊Ǘ@\ԊǗ̎dg݂
  // ̂ɑ΂ÃNXł͎OŉȂǂ̏
  TFlexViewItem = class(TPlainViewItem)
  protected
    FBase: String;
  public
    function ValidateURI(source: String; var full: String): Boolean; override;
    property thread read FThread write FThread;
    property Base: String read FBase write FBase;
  end;

  (* Xr[p *)
  TViewItem = class(TPlainViewItem)
  protected
    FProgress: TProgState;
    FNaviStat: TProgState;
    FPreStat:  TProgState;
    FAsyncStat: TProgState;
    viewList: TViewList;

    re_entrant: integer;
    freeByCancel: boolean;
    canceled: boolean;

    currentCheckNew: boolean;
    nextThread: TThreadItem;
    nextCheckOpr: TGestureOprType;
    pumpCount: integer;
    currentStartLine : integer;
    FNavigateToViewPos: Boolean;
    drawStartLine: integer;
    newdrawStartLine: integer;

    backStack: array of integer;
    forwordStack: array of integer;

    FWantTraceLogDone: Boolean;

    procedure FreeStream;
    function  SetViewPos: boolean;
    procedure OnCancel;
    procedure OnAsyncNotifyProc(thread: TThreadItem);
    procedure OnAsyncDoneProc(thread: TThreadItem);
    procedure PumpChunk;
    procedure ClearBrowser;
    procedure SaveViewPos;
    procedure WriteSkin(str: PChar; size: integer; thread: TThreadItem = nil);
    function GetBaseThread: TThreadItem; override;
  public
    HintText: string; //beginner
    procedure FreeThread(savePos: boolean = True);
    constructor Create(parent: TViewList);
    destructor Destroy; override;
    procedure DoWorking;
    procedure NewRequest(thread: TThreadItem; oprType: TGestureOprType;
                         position: integer = -1; force: Boolean = False;
                         redraw: Boolean = False);
    procedure AutoFree;
    function Drain: boolean;
    procedure OnNavigateDone;
    procedure ZoomBrowser(zoom: integer);
    function ScrollToNewRes: boolean;
    function ScrollToAnchor(num: integer; isTop: boolean; redraw: boolean): boolean;
    procedure GoBack;
    function CanGoBack: boolean;
    procedure GoForword;
    function CanGoForword: boolean;
    function MessageLoop: boolean;
    procedure ExtractKeyword(const target:string; ExThread:TThreadItem);
    procedure Grep(const target: string; targetBoardList: TList;
                         threadtitleonly: boolean = false; writepopup: boolean = false;
                         const popupmaxseq: Integer = 5; const popupeachthremax: Integer = 10);
    procedure Reload;
    procedure LocalReload(line: integer; drawline: integer = -1); //[457]
    procedure About;
    function GetTopRes: integer;
    property Progress: TProgState read FProgress;
  end;
  (*-------------------------------------------------------*)
  (* TWebBrowserꗗ *)
    TViewList = class(TList)
  private
    synchro: THogeMutex;
    garbageList: TList;    (* ǂHTMLhLgcĂۂ̂œł *)
    function GetItems(index: integer): TViewItem;
    procedure SetItems(index: integer; viewItem: TViewItem);
  public
    constructor Create;
    destructor Destroy; override;
    procedure Delete(index: integer);
    procedure Clear; override;
    {$IFDEF IE}
    function NewView(browser: TWebBrowser; index: integer = -1): TViewItem;
    {$ELSE}
    function NewView(browser: THogeTextView; index: integer = -1): TViewItem;
    {$ENDIF}
    function FindViewItem(thread: TThreadItem): TViewItem; overload;
    function FindViewitem(browser: TComponent): TViewItem; overload;
    function GetGarbage(insertIndex: integer = -1): TViewItem;
    procedure DoWorkingAll;
    procedure MasterNotifyProc(thread: TThreadItem);
    procedure MasterDoneProc(thread: TThreadItem);
    procedure UpdateFocus(index: integer); overload;
    procedure UpdateFocus(viewItem: TViewItem); overload;
    procedure Debug;
    property Items[index: integer]: TViewItem read GetItems write SetItems;
  end;

  (*-------------------------------------------------------*)

  (* d|bvAbvpTViewItem *)

  //Lock,Unlockɂ
  //|bvAbv̏processmessageɂ̃CX^Xɕ̌Ăяo
  //ɋN\AɃJ[\̈ړŎIɉdg݂Ȃ̂ŁA
  //Cxgnhsɕʂ̃CxgnhCX^X̂
  //h߂ɃbNKvB
  //bN|ƁATPopupViewList.ConfirmEnabled:=FalseReleaseꂸA
  //ɖIReleaseĂłʂ邾łɊJꂸA
  //UnlockŃbNJEg0ɂȂƂɉ܂BbNKvɂȂ̂́A
  //bZ[W܂͖IRelease\ꏊŁAOpenJaneł
  //TDat2HTMLɂXo(processmessage)A[__CAO\Aj[\B
  //KvȂƂ́AǂLockUnlock̎sRXĝ͈
  //TPopupView̍ŏƍŌŏLock,UnlockĂB
  //܂ÂTPopupViewItem̉ReleaseōsA
  //FreeADestroy͂Ȃ悤ɂĂB
  //Ȃ݂TBaseViewItemhNX̂ATPopupViewItemȊOLock,Unlock
  //̂Ƃ_~[ŉ̏܂B

  TPopupViewItem = class(TBaseViewItem)
  protected
    FOwnerView: TBaseViewItem;
    FBrowser: TPopupTextView;
    FStream: TDat2View;
    FHadPointed: Boolean;
    FReleased: Boolean;
    FOwnerCofirmation: Boolean;
    FIdStr: String;
    FOnEnabled: TNotifyEvent;
    procedure PopUp(Point: TPoint);
    procedure SetThread(const AThread: TThreadItem);
    function GetBaseItem: TBaseViewItem; override;
    function GetBaseThread: TThreadItem; override;
    function GetRootControl: TWinControl; override;
    function GetEnabled: Boolean;
    procedure SetEnabled(const Value: Boolean);
    function GetDerivativeBrowser: TControl; override;
    function GetDerivativeStream: TDatOut; override;
    function GetStreamCanceled: Boolean; override;
  public
    constructor Create(ABrowser: TPopupTextView; AOwnerView: TBaseViewItem); reintroduce;
    destructor Destroy; override;
    procedure Cancel; override;
    procedure UnLock; override;
    procedure Release;
    function BrowserQueryClose: Boolean; override;
    function GetSelection: String; override;
    procedure Show2chInfo(AIdStr: String; ATarget: String; ABoard: TBoard;
      AThread: TThreadItem; ARangearray: TRangeArray; Point: TPoint);
    procedure ShowTextInfo(AIdStr: String; Text: String; AThread: TThreadItem;
      HTML: Boolean; Point: TPoint);
    function ExtractKeyword(AIdStr: String; AThread: TThreadItem;
      Target: String; Max: Integer;Point: TPoint): Integer;
    property OwnerView:TBaseViewItem read FOwnerView;
    property Enabled: Boolean read GetEnabled write SetEnabled;
    property HadPointed: Boolean read FHadPointed write FHadPointed;
    property IdStr: String read FIdStr;
    property OwnerCofirmation: Boolean read FOwnerCofirmation write FOwnerCofirmation;
    property OnEnabled: TNotifyEvent read FOnEnabled write FOnEnabled;
  end;

  (*-------------------------------------------------------*)
  (* |bvAbvꗗ *)
  TPopupViewList = class(TObject)
  private
    FList: TList;
    FOnChange: TNotifyEvent;
  protected
    FAppEvent: TApplicationEvents;
    FTimer: TTimer;
    FPrevPoint: TPoint;
    function GetItems(index: integer): TPopupViewItem;
    function GetCount: Integer;
    function Add(Item: TPopupViewItem): Integer;
    function Extract(Item: TPopupViewItem): TPopupViewItem;
    procedure FTimerTimer(Sender: TObject);
    procedure FAppEventMessage(var Msg: tagMSG; var Handled: Boolean);
    procedure Change;
  public
    constructor Create;
    destructor Destroy; override;
    procedure Clear(Force: Boolean);
    procedure Confirm(Point: TPoint);   (* }EXʒuɂqg̔񑽒iÅǗ *)
    property Items[Index: Integer]: TPopupViewItem read GetItems;
    property Count: Integer read GetCount;
    property OnChange: TNotifyEvent read FOnChange write FOnChange;
  end;

  procedure Make2chInfo(dest: TDatOut; URI: string; basethread: TThreadItem;
    board: TBoard; thread: TThreadItem; RangeArray: TRangeArray);

(*=======================================================*)
implementation
(*=======================================================*)

uses
  Main;

type
  CharEntity = record
    Cd: Word;
    Ent: String;
  end;

const
  CharEntryList: Array[0..246] of CharEntity = (
  (Cd: 8194; Ent: 'ensp'),    (Cd: 8195; Ent: 'emsp'),    (Cd: 8201; Ent: 'thinsp'),
  (Cd: 9674; Ent: 'loz'),    (Cd: 9824; Ent: 'spades'),  (Cd: 9827; Ent: 'clubs'),  (Cd: 9829; Ent: 'hearts'), (Cd: 9830; Ent: 'diams'),
  (Cd: 161; Ent: 'iexcl'),   (Cd: 162; Ent: 'cent'),     (Cd: 163; Ent: 'pound'),
  (Cd: 164; Ent: 'curren'),  (Cd: 165; Ent: 'yen'),      (Cd: 166; Ent: 'brvbar'),  (Cd: 167; Ent: 'sect'),
  (Cd: 168; Ent: 'uml'),     (Cd: 169; Ent: 'copy'),     (Cd: 170; Ent: 'ordf'),    (Cd: 171; Ent: 'laquo'),
  (Cd: 172; Ent: 'not'),     (Cd: 173; Ent: 'shy'),      (Cd: 174; Ent: 'reg'),     (Cd: 175; Ent: 'macr'),
  (Cd: 176; Ent: 'deg'),     (Cd: 177; Ent: 'plusmn'),   (Cd: 178; Ent: 'sup2'),    (Cd: 179; Ent: 'sup3'),
  (Cd: 180; Ent: 'acute'),   (Cd: 181; Ent: 'micro'),    (Cd: 182; Ent: 'para'),    (Cd: 183; Ent: 'middot'),
  (Cd: 184; Ent: 'cedil'),   (Cd: 185; Ent: 'sup1'),     (Cd: 186; Ent: 'ordm'),    (Cd: 187; Ent: 'raquo'),
  (Cd: 188; Ent: 'frac14'),  (Cd: 189; Ent: 'frac12'),   (Cd: 190; Ent: 'frac34'),  (Cd: 191; Ent: 'iquest'),
  (Cd: 192; Ent: 'Agrave'),  (Cd: 193; Ent: 'Aacute'),   (Cd: 194; Ent: 'Acirc'),   (Cd: 195; Ent: 'Atilde'),
  (Cd: 196; Ent: 'Auml'),    (Cd: 197; Ent: 'Aring'),    (Cd: 198; Ent: 'AElig'),   (Cd: 199; Ent: 'Ccedil'),
  (Cd: 200; Ent: 'Egrave'),  (Cd: 201; Ent: 'Eacute'),   (Cd: 202; Ent: 'Ecirc'),   (Cd: 203; Ent: 'Euml'),
  (Cd: 204; Ent: 'Igrave'),  (Cd: 205; Ent: 'Iacute'),   (Cd: 206; Ent: 'Icirc'),   (Cd: 207; Ent: 'Iuml'),
  (Cd: 208; Ent: 'ETH'),     (Cd: 209; Ent: 'Ntilde'),   (Cd: 210; Ent: 'Ograve'),  (Cd: 211; Ent: 'Oacute'),
  (Cd: 212; Ent: 'Ocirc'),   (Cd: 213; Ent: 'Otilde'),   (Cd: 214; Ent: 'Ouml'),    (Cd: 215; Ent: 'times'),
  (Cd: 216; Ent: 'Oslash'),  (Cd: 217; Ent: 'Ugrave'),   (Cd: 218; Ent: 'Uacute'),  (Cd: 219; Ent: 'Ucirc'),
  (Cd: 220; Ent: 'Uuml'),    (Cd: 221; Ent: 'Yacute'),   (Cd: 222; Ent: 'THORN'),   (Cd: 223; Ent: 'szlig'),
  (Cd: 224; Ent: 'agrave'),  (Cd: 225; Ent: 'aacute'),   (Cd: 226; Ent: 'acirc'),   (Cd: 227; Ent: 'atilde'),
  (Cd: 228; Ent: 'auml'),    (Cd: 229; Ent: 'aring'),    (Cd: 230; Ent: 'aelig'),   (Cd: 231; Ent: 'ccedil'),
  (Cd: 232; Ent: 'egrave'),  (Cd: 233; Ent: 'eacute'),   (Cd: 234; Ent: 'ecirc'),   (Cd: 235; Ent: 'euml'),
  (Cd: 236; Ent: 'igrave'),  (Cd: 237; Ent: 'iacute'),   (Cd: 238; Ent: 'icirc'),   (Cd: 239; Ent: 'iuml'),
  (Cd: 240; Ent: 'eth'),     (Cd: 241; Ent: 'ntilde'),   (Cd: 242; Ent: 'ograve'),  (Cd: 243; Ent: 'oacute'),
  (Cd: 244; Ent: 'ocirc'),   (Cd: 245; Ent: 'otilde'),   (Cd: 246; Ent: 'ouml'),    (Cd: 247; Ent: 'divide'),
  (Cd: 248; Ent: 'oslash'),  (Cd: 249; Ent: 'ugrave'),   (Cd: 250; Ent: 'uacute'),  (Cd: 251; Ent: 'ucirc'),
  (Cd: 252; Ent: 'uuml'),    (Cd: 253; Ent: 'yacute'),   (Cd: 254; Ent: 'thorn'),   (Cd: 255; Ent: 'yuml'),
  (Cd: 338; Ent: 'OElig'),   (Cd: 339; Ent: 'oelig'),    (Cd: 352; Ent: 'Scaron'),  (Cd: 353; Ent: 'scaron'),
  (Cd: 376; Ent: 'Yuml'),    (Cd: 710; Ent: 'circ'),     (Cd: 732; Ent: 'tilde'),   (Cd: 402; Ent: 'fnof'),
  (Cd: 913; Ent: 'Alpha'),   (Cd: 914; Ent: 'Beta'),     (Cd: 915; Ent: 'Gamma'),   (Cd: 916; Ent: 'Delta'),
  (Cd: 917; Ent: 'Epsilon'), (Cd: 918; Ent: 'Zeta'),     (Cd: 919; Ent: 'Eta'),     (Cd: 920; Ent: 'Theta'),
  (Cd: 921; Ent: 'Iota'),    (Cd: 922; Ent: 'Kappa'),    (Cd: 923; Ent: 'Lambda'),  (Cd: 924; Ent: 'Mu'),
  (Cd: 925; Ent: 'Nu'),      (Cd: 926; Ent: 'Xi'),       (Cd: 927; Ent: 'Omicron'), (Cd: 928; Ent: 'Pi'),
  (Cd: 929; Ent: 'Rho'),     (Cd: 931; Ent: 'Sigma'),    (Cd: 932; Ent: 'Tau'),     (Cd: 933; Ent: 'Upsilon'),
  (Cd: 934; Ent: 'Phi'),     (Cd: 935; Ent: 'Chi'),      (Cd: 936; Ent: 'Psi'),     (Cd: 937; Ent: 'Omega'),
  (Cd: 945; Ent: 'alpha'),   (Cd: 946; Ent: 'beta'),     (Cd: 947; Ent: 'gamma'),   (Cd: 948; Ent: 'delta'),
  (Cd: 949; Ent: 'epsilon'), (Cd: 950; Ent: 'zeta'),     (Cd: 951; Ent: 'eta'),     (Cd: 952; Ent: 'theta'),
  (Cd: 953; Ent: 'iota'),    (Cd: 954; Ent: 'kappa'),    (Cd: 955; Ent: 'lambda'),  (Cd: 956; Ent: 'mu'),
  (Cd: 957; Ent: 'nu'),      (Cd: 958; Ent: 'xi'),       (Cd: 959; Ent: 'omicron'), (Cd: 960; Ent: 'pi'),
  (Cd: 961; Ent: 'rho'),     (Cd: 962; Ent: 'sigmaf'),   (Cd: 963; Ent: 'sigma'),   (Cd: 964; Ent: 'tau'),
  (Cd: 965; Ent: 'upsilon'), (Cd: 966; Ent: 'phi'),      (Cd: 967; Ent: 'chi'),     (Cd: 968; Ent: 'psi'),
  (Cd: 969; Ent: 'omega'),   (Cd: 977; Ent: 'thetasym'), (Cd: 978; Ent: 'upsih'),   (Cd: 982; Ent: 'piv'),
  (Cd: 8204; Ent: 'zwnj'),   (Cd: 8205; Ent: 'zwj'),     (Cd: 8206; Ent: 'lrm'),    (Cd: 8207; Ent: 'rlm'),
  (Cd: 8211; Ent: 'ndash'),  (Cd: 8212; Ent: 'mdash'),  (Cd: 8216; Ent: 'lsquo'),   (Cd: 8217; Ent: 'rsquo'),
  (Cd: 8218; Ent: 'sbquo'),  (Cd: 8220; Ent: 'ldquo'),  (Cd: 8221; Ent: 'rdquo'),   (Cd: 8222; Ent: 'bdquo'),
  (Cd: 8224; Ent: 'dagger'), (Cd: 8225; Ent: 'Dagger'), (Cd: 8226; Ent: 'bull'),    (Cd: 8230; Ent: 'hellip'),
  (Cd: 8240; Ent: 'permil'), (Cd: 8242; Ent: 'prime'),  (Cd: 8243; Ent: 'Prime'),   (Cd: 8249; Ent: 'lsaquo'),
  (Cd: 8250; Ent: 'rsaquo'), (Cd: 8254; Ent: 'oline'),  (Cd: 8260; Ent: 'frasl'),   (Cd: 8364; Ent: 'euro'),
  (Cd: 8465; Ent: 'image'),  (Cd: 8472; Ent: 'ewierp'), (Cd: 8476; Ent: 'real'),    (Cd: 8482; Ent: 'trade'),
  (Cd: 8501; Ent: 'alefsym'),(Cd: 8592; Ent: 'larr'),   (Cd: 8593; Ent: 'uarr'),    (Cd: 8594; Ent: 'rarr'),
  (Cd: 8595; Ent: 'darr'),   (Cd: 8596; Ent: 'harr'),   (Cd: 8629; Ent: 'crarr'),   (Cd: 8656; Ent: 'lArr'),
  (Cd: 8657; Ent: 'uArr'),   (Cd: 8658; Ent: 'rArr'),   (Cd: 8659; Ent: 'dArr'),    (Cd: 8660; Ent: 'hArr'),
  (Cd: 8704; Ent: 'forall'), (Cd: 8706; Ent: 'part'),   (Cd: 8707; Ent: 'exist'),   (Cd: 8709; Ent: 'empty'),
  (Cd: 8711; Ent: 'nabla'),  (Cd: 8712; Ent: 'isin'),   (Cd: 8713; Ent: 'notin'),   (Cd: 8715; Ent: 'ni'),
  (Cd: 8719; Ent: 'prod'),   (Cd: 8721; Ent: 'sum'),    (Cd: 8722; Ent: 'minus'),   (Cd: 8727; Ent: 'lowast'),
  (Cd: 8730; Ent: 'radic'),  (Cd: 8733; Ent: 'prop'),   (Cd: 8734; Ent: 'infin'),   (Cd: 8736; Ent: 'ang'),
  (Cd: 8743; Ent: 'and'),    (Cd: 8744; Ent: 'or'),     (Cd: 8745; Ent: 'cap'),     (Cd: 8746; Ent: 'cup'),
  (Cd: 8747; Ent: 'int'),    (Cd: 8756; Ent: 'there4'), (Cd: 8764; Ent: 'sim'),     (Cd: 8773; Ent: 'cong'),
  (Cd: 8776; Ent: 'asymp'),  (Cd: 8800; Ent: 'ne'),     (Cd: 8801; Ent: 'equiv'),   (Cd: 8804; Ent: 'le'),
  (Cd: 8805; Ent: 'ge'),     (Cd: 8834; Ent: 'sub'),    (Cd: 8835; Ent: 'sup'),     (Cd: 8836; Ent: 'nsub'),
  (Cd: 8838; Ent: 'sube'),   (Cd: 8839; Ent: 'supe'),   (Cd: 8853; Ent: 'oplus'),   (Cd: 8855; Ent: 'otimes'),
  (Cd: 8869; Ent: 'perp'),   (Cd: 8901; Ent: 'sdot'),   (Cd: 8968; Ent: 'lceil'),   (Cd: 8969; Ent: 'rceil'),
  (Cd: 8970; Ent: 'lfloor'), (Cd: 8971; Ent: 'rfloor'), (Cd: 9001; Ent: 'lang'),    (Cd: 9002; Ent: 'rang')
  );

{$IFDEF IE}
(*  *)
constructor TWebOutBufferStream.Create(browser: TWebBrowser);
begin
  inherited Create;
  FStream := TMemoryStream.Create;
  FStream.Size := 4096;
  self.browser := browser;
  //hintForProcessMessages := 0;
  canceled := false;
  //flushThreshold := 3 * 1024;  (* ȏ̃oCg܂flush *)
  re_entrant := 0;
end;

(*  *)
destructor TWebOutBufferStream.Destroy;
begin
  FStream.Free;
  inherited;
end;


(*  *)
function TWebOutBufferStream.ExtractCache: string;
var
  len: integer;
begin
  with FStream do
  begin
    len := Position;
    if 0 < len then
    begin
      Position := 0;
      SetLength(result, len);
      ReadBuffer(result[1], len);
      Position := 0;
    end
    else begin
      result := '';
    end;
  end;
end;

(*  *)
procedure TWebOutBufferStream.WriteText(str: PChar; size: integer);
begin
  FStream.WriteBuffer(str^, size);
  //Inc(hintForProcessMessages, size);
end;


(*  *)
procedure TWebOutBufferStream.Flush;
var
  str: string;
  i: integer;
begin
  str := ExtractCache;
  if length(str) <= 0 then
    exit;
  for i := 1 to length(str) do
  begin
    if (str[i] < ' ') and (not (str[i] in [#10, #13])) then
      str[i] := ' ';
  end;
  Inc(re_entrant);
  if assigned(browser) and assigned(browser.document) then
  begin
    olevariant(browser.document as IHTMLDocument2).write(str);
    Application.ProcessMessages;
    if canceled then
      raise ECancelViewException.Create('navigation canceled')
  end;
  Dec(re_entrant);
end;

(*  *)
procedure TWebOutBufferStream.Cancel;
begin
  canceled := true;
end;

{beginner}
procedure TWebOutBufferStreamForExtraction.WriteAnchor(const Name: string;
                      const HRef: string;
                      str: PChar; size: integer);
var
  ModifHref:string;
  Hyphen: Integer;
begin
  ModifHref := HRef;
  if (HRef<>'') then begin
    if HRef[1] = '#' then
      case BBSType of
        bbsJBBS, bbsMachi: begin
          Hyphen := Pos('-', HRef);
          if Hyphen > 0 then
            ModifHref := Base + '&START=' + copy(HRef, 2, Hyphen - 2) + '&END=' + copy(HRef, Hyphen + 1, High(Integer))
          else
            ModifHref := Base + '&START=' + copy(HRef, 2, High(Integer)) + '&END=' + copy(HRef, 2, High(Integer));
        end;
      else
        ModifHref := Base + copy(HRef, 2, High(Integer));
      end
    else if StrLIComp('menu:', pchar(HRef), 5) = 0 then
      case BBSType of
        bbsJBBS, bbsMachi:
          ModifHref := Base + '&START=' + copy(HRef, 6, High(Integer)) + '&END=' + copy(HRef, 6, High(Integer));
      else
        ModifHref := Base + copy(HRef, 6, High(Integer));
      end;
  end;
  inherited WriteAnchor(Name,ModifHref,str,size);
end;
{/beginner}

{$ENDIF}

(* =========================================================== *)
function ZoomToPoint(zoom: integer): Integer;
begin
  try
    result := Config.viewZoomPointArray[zoom];
  except
    result := -9;
  end;
  {case zoom of
  0: result := -9;
  1: result := -10;
  2: result := -12;
  3: result := -14;//521 -16
  4: result := -15;//521 -24
  end;}
end;

function ZoomToExternalLeading(zoom: integer): Integer;
begin
  result := 1;
  case zoom of
  0: result := 1;
  1: result := 2;
  2: result := 2;
  3: result := 3;
  4: result := 4;
  end;
end;

function FindAnchorName(item: THogeTVItem; var startPos, size: integer): boolean;
var
  i: integer;
begin
  if startPos <= 0 then
    i := 1
  else begin
    i := startPos + size;
    size := 0;
  end;
  startPos := 0;
  result := True;
  for i := i to length(item.FAttrib) do
  begin
    if (Ord(item.FAttrib[i]) and (htvVMASK or htvATTMASK))
       = (htvHIDDEN or ATTRIB_ANCHOR_NAME) then
    begin
      if startPos <= 0 then
        startPos := i
    end
    else if 0 < startPos then
    begin
      size := i - startPos;
      exit;
    end;
  end;
  if startpos > 0 then
    size := length(item.FAttrib) - startpos + 1
  else
    result := false;
end;

(* =========================================================== *)

(* =========================================================== *)

constructor TDat2View.Create(browser: THogeTextView);
begin
  inherited Create;
  FBrowser := browser;
  canceled := false;
  re_entrant := 0;
  FAttribute := 0;
  FBold := 0;
  FStream := THogeMemoryStream.Create;
  FStream.Size := 4096;
  flushCount := 0;
  FOffsetLeft := 0;
  FBiteSpaces := False;
  FUser := 0;
  EnableFontTag := false;
  FDDOffsetLeft := DD_OFFSET_LEFT;
end;

destructor TDat2View.Destroy;
begin
  FStream.Free;
  inherited;
end;

procedure TDat2View.BeginAnchor;
var
  name, value: string;
begin
  FHref := '';
  while GetAttribPair(name, value) do
  begin
    if name = 'href' then
    begin
      FHref := value;
      break;
    end;
  end;
  if AnsiStartsStr('mailto:', FHref) then
  begin
    Flush;
    FUser := htvUSER or ATTRIB_LINK;
  end;
end;

procedure TDat2View.EndAnchor;
begin
  if AnsiStartsStr('mailto:', FHref) then
  begin
    Flush;
    FBrowser.Append(FHref, ATTRIB_ANCHOR_HREF or htvHIDDEN);
    FUser := 0;
  end;
end;

function TDat2View.ProcTag: boolean;
  procedure SetFont;
  var
    name, value: string;
  begin
    if not EnableFontTag then
      exit;
    while GetAttribPair(name, value) do
    begin
      if (name = 'face') and (0 < length(value)) then
      begin
        FBrowser.SetFont(value, ZoomToPoint(Config.viewZoomSize));
        break;
      end;
    end;
  end;

  procedure SetAttrib;
  var
    name, value: string;
    att: integer;
  begin
    while GetAttribPair(name, value) do
    begin
      if (name = 'i') and (0 < length(value)) then
      begin
        att := (Str2Int(value) * 2) mod 32;
        if att <> FAttribute then
        begin
          Flush;
          FAttribute := att;
        end;
        break;
      end;
    end;
  end;

var
  tag: string;
begin
  if (str + index)^ = '<' then
  begin
    Inc(index);
    tag := GetTagName;
    if (tag = 'br') or (tag = 'hr') or (tag = '/p') or (tag = '/li') or
       (tag = 'ul') then
      WriteBR
    else if (tag = 'dd') then
    begin
      WriteBR;
      FOffsetLeft := FDDOffsetLeft;
    end
    else if (tag = '/dd') then
    begin
      FOffsetLeft := 0;
    end
    else if (tag = 'b') then
      SetBold(True)
    else if (tag = '/b') then
      SetBold(False)
    else if (tag = 'font') then
      SetFont
    else if (tag = 'sa') then
      SetAttrib
    else if (tag = 'a') then
      BeginAnchor
    else if (tag = '/a') then
      EndAnchor;
    EndOfTag;
    result := True;
  end
  else
    result := false;
end;

(* (str + index)^ = '&' *)
function TDat2View.ProcEntity: boolean;
var
  i, len, val: integer;

  procedure OutCode;
  begin

    Inc(i, len);
    if  130 < val then
    begin
      if val <> 3642 then
        WriteUNICODE(PChar(@val), 2);
    end
    else if Chr(val) in LeadBytes then
    begin
      FStream.WriteBuffer((str + index)^, i - index)
    end
    else if 32 <= val then
      FStream.WriteBuffer(PChar(@val)^, 1);
    index := i;
    if (str + index)^ = ';' then
      Inc(index);
  end;

  {beginner} //̎QƁjR[h
  function GetEntityCode(s: String; var Code: Word): Boolean;
  var
    i: Integer;
  begin
    Code := 0;
    Result := False;
    for i := Low(CharEntryList) to High(CharEntryList) do
      if s = CharEntryList[i].Ent then
      begin
        Code := CharEntryList[i].Cd;
        Result := True;
        Break;
      end;
  end;

  procedure OutAscii(Ch: Char);
  begin
    WriteChar(Ch);
    index := i + 1;
    if (index < size) and ((str + index)^ = ';') then
      Inc(index);
  end;
var
  s: string;
  Code: Word;
begin
  result := true;
  i := index + 1;
  if (str + i)^ = '#' then
  begin
    val := 0;
    Inc(i);
    if (str + i)^ in ['X','x'] then
    begin
      Inc(i);
      if GetHex(str + i, size - i, val, len) then
      begin
        OutCode;
        exit;
      end;
    end
    else begin
      if GetDecimal(str + i, size - i, val, len) then
      begin
        OutCode;
        exit;
      end;
    end;
  end
  else begin
    while i < size do
    begin
      case (str + i)^ of
      'A'..'Z','a'..'z','0'..'9':
        begin
          s := s + (str + i)^;
          if s = 'amp' then  (* ÂO ; ŏIȂ̂ *)
          begin
            OutAscii('&');
            exit;
          end else
          if s = 'gt' then
          begin
            OutAscii('>');
            exit;
          end else
          if s = 'lt' then
          begin
            OutAscii('<');
            exit;
          end else
          if s = 'quot' then
          begin
            OutAscii('"');
            exit;
          end else
          if s = 'nbsp' then
          begin
            WriteUNICODE(PChar(#160#0), 2);
            index := i + 1;
            if (index < size) and ((str + index)^ = ';') then
              Inc(index);
            exit;
          end;
        end;
      else
        begin
          Result := False;
          if (str + i)^ = ';' then
          begin
            Inc(i);
            if GetEntityCode(s, Code) then
            begin
              WriteUNICODE(PChar(@Code), 2);
              index := i;
              Result := True;
            end;
          end;
          Exit;
        end;
      end;
      Inc(i);
    end;
  end;
  result := false;
end;

function TDat2View.ProcBlank: boolean;
var
  i: integer;
begin
  result := true;
  i := index + 1;
  while ((str + i)^ = ' ') and (i < size) do
    Inc(i);
  index := i;
  WriteChar(' ')
end;

procedure TDat2View.WriteText(str: PChar; size: integer);
begin
  FStream.WriteBuffer(str^, size);
  FBiteSpaces := False;
end;

procedure TDat2View.WriteAnchor(const Name: string;
                                const Href: string;
                                str: PChar; size: integer);
var
  user: integer;
begin
  Flush;
  if 0 < length(Href) then
    user := htvUSER
  else
    user := 0;

  FBrowser.nAppend(str, size, FBold or ATTRIB_LINK or user);
  FBrowser.Append(Name, ATTRIB_ANCHOR_NAME or htvHIDDEN);
  FBrowser.Append(Href, ATTRIB_ANCHOR_HREF or htvHIDDEN);

  FBiteSpaces := False;
end;

procedure TDat2View.WriteBR;
  procedure TrimRight;
  var
    i: integer;
    p: PChar;
  begin
    p := FStream.Memory;
    for i := FStream.Position -1 downto 0 do
    begin
      if (p+i)^ <> ' ' then
      begin
        FStream.Position := i + 1;
        exit;
      end;
    end;
    FStream.Position := 0;
  end;

begin
  TrimRight;
  Flush;
  FBrowser.Append(#10);
  FBiteSpaces := True;
end;

procedure TDat2View.SetBold(boldP: boolean);
begin
  Flush;
  if boldP then
    FBold := 1
  else
    FBold := 0;
end;

procedure TDat2View.WriteChar(c: Char);
begin
  if FBiteSpaces and (c = ' ') then
    exit;
  FBiteSpaces := False;
  if ' ' <= c then
    FStream.WriteChar(c);
end;

procedure TDat2View.WriteUNICODE(str: PChar; size: integer);
begin
  Flush;
  FBiteSpaces := False; //beginner
  FBrowser.nAppend(str, size, FBold or FAttribute or htvUNICODE);
end;

procedure TDat2View.Flush;
begin
  FBrowser.Strings[FBrowser.Strings.Count -1].OffsetLeft := FOffsetLeft;
  if FStream.Position <= 0 then
    exit;
  if FUser <> 0 then
    FBrowser.nAppend(FStream.Memory, FStream.Position, FBold or FUser)
  else
    FBrowser.nAppend(FStream.Memory, FStream.Position, FBold or FAttribute);
  FStream.Position := 0;
  Inc(flushCount);
  {$IFNDEF IE}
  if (flushCount mod 256) = 0 then
  begin
    Inc(re_entrant);
    Application.ProcessMessages;
    Dec(re_entrant);
  end;
  {$ENDIF}
end;

procedure TDat2View.Cancel;
begin
  canceled := true;
end;

(*=======================================================*)

function TDat2PopupView.ProcBlank: boolean;
begin
  Result := False;
end;

procedure TDat2PopupView.WriteChar(c: Char);
begin
  if ' ' <= c then
    FStream.WriteChar(c);
end;

(*=======================================================*)

{$IFNDEF IE}
procedure TDat2ViewForExtraction.WriteAnchor(const Name: string;
                      const HRef: string;
                      str: PChar; size: integer);
var
  ModifHref:string;
  Hyphen: Integer;
begin
  ModifHref := HRef;
  if (HRef<>'') then begin
    if HRef[1] = '#' then
      case BBSType of
        bbsJBBS, bbsMachi: begin
          Hyphen := Pos('-', HRef);
          if Hyphen > 0 then
            ModifHref := Base + '&START=' + copy(HRef, 2, Hyphen - 2) + '&END=' + copy(HRef, Hyphen + 1, High(Integer))
          else
            ModifHref := Base + '&START=' + copy(HRef, 2, High(Integer)) + '&END=' + copy(HRef, 2, High(Integer));
        end;
      else
        ModifHref := Base + copy(HRef, 2, High(Integer));
      end
    else if StrLIComp('menu:', pchar(HRef), 5) = 0 then
      case BBSType of
        bbsJBBS, bbsMachi:
          ModifHref := Base + '&START=' + copy(HRef, 6, High(Integer)) + '&END=' + copy(HRef, 6, High(Integer));
      else
        ModifHref := Base + copy(HRef, 6, High(Integer));
      end;
  end;
  inherited WriteAnchor(Name,ModifHref,str,size);
end;
{$ENDIF}

(*=======================================================*)

procedure TSimpleDat2View.BeginAnchor;
var
  name, value: string;
begin
  Flush;
  FHref := '';
  while GetAttribPair(name, value) do
  begin
    if name = 'href' then
    begin
      FHref := value;
      break;
    end;
  end;
  FUser := htvUSER or ATTRIB_LINK;
end;

procedure TSimpleDat2View.EndAnchor;
begin
  Flush;
  FBrowser.Append(FHref, ATTRIB_ANCHOR_HREF or htvHIDDEN);
  FUser := 0;
end;

function TSimpleDat2View.ProcTag: boolean;
  procedure ProcLineFeed;
  begin
    if not FBiteSpaces then
      WriteBR;
    EndOfTag;
    result := True;
  end;
var
  tag: string;
  tmpIndex: Integer;
begin
  if (str + index)^ = '<' then
  begin
    tmpIndex  := Index;
    Inc(index);
    tag := GetTagName;
    if tag = 'blockquote' then
    begin
      ProcLineFeed;
      FOffsetLeft := DDOffsetLeft;
    end else
    if tag = '/blockquote' then
    begin
      FOffsetLeft := 0;
      ProcLineFeed;
    end else
    if (tag = 'dt') or (tag = 'dd') or (tag = 'li') or (tag = 'p') then
      ProcLineFeed
    else
    begin
      index := tmpIndex;
      result := inherited ProcTag;
    end;
  end
  else
    result := false;
end;

procedure TSimpleDat2View.ProcHTML;
begin
  while (index < size) do
  begin
    if not ((((str + index)^ = '<') and ProcTag) or
           (((str + index)^ = '&') and ProcEntity) or
           (((str + index)^ = ' ') and ProcBlank)) then
    begin
      case (str + index)^ of
      #0..#$1F:;
      else
        WriteChar((str + index)^);
      end;
      Inc(index);
    end;
  end;
end;

procedure TSimpleDat2View.Flush;
begin
  FBrowser.Invalidate;
  inherited;
end;


(*=======================================================*)

{ TBaseViewItem }

constructor TBaseViewItem.Create;
begin
  inherited;
  FLockCount := 0;
  FThread := nil;
  FPossessionView := nil;
end;

destructor TBaseViewItem.Destroy;
begin
  ReleasePossessionView;
  inherited;
end;

procedure TBaseViewItem.ReleasePossessionView;
begin
  if Assigned(FPossessionView) then
    FPossessionView.Release;
end;

function TBaseViewItem.GetBaseThread: TThreadItem;
begin
  Result := nil;
end;

function TBaseViewItem.GetFocusedLink: String;
var
  browser: THogeTextView;
  Point: TPoint;
  item: THogeTVItem;
begin
  //{abstractɂPlain̔hNXŒ`ׂǁA
  //HogeTextView2ӏŎĝŁABaseŒ`Ď蔲
  try
    browser := GetDerivativeBrowser as THogeTextView;
    if browser = nil then
      Abort;
    point := browser.Caret;
    item := browser.Strings[point.Y];
    Result := item.GetEmbed(point.X + 1);
  except
    Result := '';
  end;
end;

procedure TBaseViewItem.SelectAll;
var
  Browser: THogeTextView;
begin
  try
    browser := GetDerivativeBrowser as THogeTextView;
  except
    Browser := nil;
  end;

  if Assigned(Browser) then
    with Browser do
    begin
      BeginningOfBuffer;
      SetMarkCommand;
      EndOfBuffer;
      Selecting := True;
    end;
end;

function TBaseViewItem.IsMouseInPane: Boolean;
var
  Browser: TControl;
begin
  Browser := GetDerivativeBrowser;
  Result := Assigned(Browser) and MouseInPane(Browser);
end;

procedure TBaseViewItem.Lock;
begin
  Inc(FLockCount);
end;

procedure TBaseViewItem.UnLock;
begin
  if Locked then
    Dec(FLockCount);
end;

function TBaseViewItem.Locked: Boolean;
begin
  Result := (FLockCount > 0);
end;

function TBaseViewItem.ValidateURI(source: String; var full: String): Boolean;
begin
  full := source;
  Result := True;
end;

function TBaseViewItem.BrowserQueryClose: Boolean;
begin
  Result := False;
end;

function TBaseViewItem._ExtractKeyWord(thread: TThreadItem; dest: TDatOut;
  target: String; Max: Integer): Integer;
var
  i: Integer;
  s: String;
  dup: TThreadData;
begin
  dup := thread.DupData;
  try
    Result := 0;
    for i := 1 to thread.lines do
    begin
      s := SEARCHD2HTML.ToString(dup, i, 1);
      if AnsiContainsText(s, target) then
      begin
        D2HTML.ToDatOut(dest, dup, i, 1, thread.ABoneArray);
        inc(Result);
        if (Max > 0) and (Result >= Max) then
          Break;
      end;
      if GetStreamCanceled then
        Break;
    end;
  finally
    dup.Free;
  end;
end;

(*=======================================================*)

{ TPlainViewItem }


{$IFDEF IE}
constructor TPlainViewItem.Create;
begin
  inherited;
  FEvent := nil;
end;

destructor TPlainViewItem.Destroy;
begin
  FEvent.Free;
  inherited;
end;
{$ENDIF}


function TPlainViewItem.GetSelection: String;
{$IFDEF IE}
var
  textRange: OleVariant;
begin
  if Assigned(browser) then
  begin
    textRange := OleVariant(browser.Document as IHTMLDocument2).selection;
    textRange := textRange.createRange();
    Result := textRange.text;
  end else
    Result := '';
end;
{$ELSE}
begin
  if Assigned(browser) then
    Result := browser.Selection
  else
    Result := '';
end;
{$ENDIF}

{$IFDEF IE}
procedure TPlainViewItem.SetBrowser(value: TWebBrowser);
{$ELSE}
procedure TPlainViewItem.SetBrowser(value: THogeTextView);
{$ENDIF}
begin
  if Assigned(FBrowser) then
    FBrowser.Tag := 0;
  FBrowser := value;
  if Assigned(FBrowser) then
    FBrowser.Tag := Integer(Self);
end;

function TPlainViewItem.GetBaseItem: TBaseViewItem;
begin
  Result := Self;
end;

function TPlainViewItem.GetRootControl: TWinControl;
begin
  Result := FRootControl;
end;

function TPlainViewItem.GetDerivativeBrowser: TControl;
begin
  Result := FBrowser;
end;

function TPlainViewItem.GetDerivativeStream: TDatOut;
begin
  Result := FStream;
end;

procedure TPlainViewItem.Cancel;
begin
  if Assigned(FStream) then
    FStream.Cancel;
end;

function TPlainViewItem.GetStreamCanceled;
begin
  Result := Assigned(FStream) and FStream.canceled;
end;


(*=======================================================*)

{ TFlexViewItem }


function TFlexViewItem.ValidateURI(source: String; var full: String): Boolean;
begin
  if (Base <> '') and (source <> 'y[W\܂') and (source <> '') then
  begin
    Result := True;
    if AnsiCompareStr('about:blank', source) = 0 then
      full := source
    else if StartWith('about:', source, 1) then
      full := CombineURI(Base, Copy(source, 7, High(Integer)))
    else
      full := CombineURI(Base, source);
  end else
    Result := inherited ValidateURI(source, full);
end;

(*=======================================================*)
(*  *)
constructor TViewItem.Create(parent: TViewList);
begin
  inherited Create;
  FBrowser := nil;
  FStream  := nil;
  FThread  := nil;
  FProgress:= tpsNone;
  FNaviStat:= tpsNone;
  FPreStat := tpsNone;
  FAsyncStat:= tpsNone;
  nextThread := nil;
  viewList := parent;
  pumpCount:= 0;

  re_entrant := 0;
  freeByCancel := false;
  canceled := false;
  currentCheckNew := False;
  newDrawStartline := -1;
end;

(*  *)
destructor TViewItem.Destroy;
begin
  FreeStream;
  FreeThread;
  if assigned(nextThread) then
    nextThread.Release;
  if browser <> nil then
  begin
    browser.Free;
  end;
  inherited;
end;

(*  *)
procedure TViewItem.FreeStream;
begin
  if assigned(FSTream) then
    FStream.Free;
  FStream := nil;
end;

(*  *)
procedure TViewItem.FreeThread(savePos: boolean = True);
begin
  if assigned(FThread) then
  begin
    if savePos and assigned(browser) then
      SaveViewPos;
    FThread.Release;
  end;
  FThread := nil;
end;

(* ̃[`͉ *)
function TViewItem.GetTopRes: integer; // 521 SaveViewPosƗ
{$IFDEF IE}
var
  anchors: OleVariant;
  top, i, len: integer;

  function GetItemTop(item: OleVariant): integer;
  begin
    result := 0;
    try
      repeat
        result := result + item.offsetTop;
        item := item.offsetParent;
      until  AnsiCompareText(item.tagName, 'body') = 0;
    except
    end;
  end;

  function search(base, size: integer): integer;
  var
    off: integer;
//    anchorTop: integer;
//    item: OleVariant;
  begin
    if size <= 1 then
    begin
      result := base;
      exit;
    end;
    off := size div 2;
    if top < GetItemTop(anchors.item(IntToStr(base + off))) then
      result := search(base, off)
    else
      result := search(base + off, size - off);
  end;

begin
  result := 0;
  try
    top := olevariant(IHTMLDocument2(browser.Document)).body.scrollTop;
    anchors := OleVariant(browser.Document as IHTMLDocument2).anchors;
    //len := anchors.length;
    len := FThread.lines;
    i := search(0, len) -1;
    if i < 0 then i := 0;
    while i < len do
    begin
      result := i;
      inc(i);
      if (top <= GetItemTop(anchors.item(IntToStr(i)))) then
        break;
    end;
    //if 0 < result then
    //  inc(result, FThread.lines - len); // 521 ꂵ
  except
  end;
end;
{$ELSE}
var
  i, line: Integer;
  startPos, size: integer;
  item: THogeTVItem;
begin
  for line := FBrowser.TopLine to FBrowser.Strings.Count -1 do
  begin
    item := FBrowser.Strings[line];
    startPos := 0;
    while FindAnchorName(item, startPos, size) do
    begin
      result := 0;
      for i := startPos to startPos + size -1 do
      begin
        case item.FText[i] of
        '0'..'9': result := result * 10 + Ord(item.FText[i]) - Ord('0');
        else
          begin
            result := -1;
            break;
          end;
        end;
      end;
      if 0 < result then
      begin
        Dec(result);
        exit;
      end;
    end;
  end;
  result := thread.lines - 1;
  if result < 0 then
    result := 0;
end;
{$ENDIF}

(*  *)
procedure TViewItem.SaveViewPos;
{$IFDEF IE}
begin
  if Assigned(thread) and Assigned(browser) and Assigned(browser.Document) then
  begin
    thread.SetViewPos(GetTopRes);
    thread.SaveIndexData;
  end;
end;
{$ELSE}
begin
  if Assigned(thread) and Assigned(browser) then
  begin
    thread.SetViewPos(GetTopRes);
    thread.SaveIndexData;
  end;
end;
{$ENDIF}


function TViewItem.GetBaseThread: TThreadItem;
begin
  Result := FThread;
end;

(* LZ̏ *)
procedure TViewItem.OnCancel;
var
  thread: TThreadItem;
begin
  thread := nextThread;
  nextThread := nil;
  if thread <> nil then
  begin
    thread.Release;
    FProgress := tpsNone;
    NewRequest(thread, nextCheckOpr);
  end;
end;

(*  *)
procedure TViewItem.AutoFree;
begin
  freeByCancel := true;
  Drain;
end;

function TViewItem.Drain: boolean;
  function ReleaseObjs: boolean;
  begin
    if freeByCancel then
    begin
      Self.Free;
      result := true;
    end
    else begin
      {$IFDEF IE}
      FreeStream;
      {$ENDIF}
      FreeThread;
      if assigned(browser) then
      begin
        browser.Visible := FALSE;
        ClearBrowser;
      end;
      FProgress := tpsNone;
      FNaviStat := tpsNone;
      FPreStat  := tpsNone;
      FAsyncStat:= tpsNone;
      result := false;
    end;
  end;
begin
  result := false;
  Cancel;
  canceled := true;
  if (FProgress = tpsNONE) and (re_entrant <= 0) then
  begin
    result := ReleaseObjs;
    exit;
  end;
  if nextThread <> nil then
  begin
    nextThread.Release;
    nextThread := nil;
  end;
  if assigned(browser) then
    browser.Visible := FALSE;
  if (FPreStat <> tpsWorking) and
     (re_entrant <= 0) then
  begin
    result := ReleaseObjs;
  end;
end;


(* X\v *)
procedure TViewItem.NewRequest(thread: TThreadItem; oprType: TGestureOprType;
                               position: integer = -1; force: Boolean = False;
                               redraw: Boolean = False);
  function CheckP(thread: TThreadItem; oprType: TGestureOprType): boolean;
  begin
    result := false;
    if Config.netOnline then
    begin
      case oprType of
      gotCHECK: result := true;
      gotGRACEFUL:
        begin
          thread.AddRef;
          if ((thread.lines <= 0) or (thread.lines < thread.itemCount) or
              (thread.lines <= position)) then
            result := true;
          thread.Release;
        end;
      end;
    end;
  end;

  procedure DeleteNewRes;
  {$IFDEF IE}
  begin
    ClearBrowser;
  end;
  {$ELSE}
  var
    s: string;
    line, len: integer;
    startPos, size: integer;
    item: THogeTVItem;
  begin
    if currentStartLine > FThread.lines then
      exit;
    if currentStartLine <= 1 then
    begin
      ClearBrowser;
      exit;
    end;

    s := IntToStr(currentStartLine);
    len := length(s);
    for line := 0 to FBrowser.Strings.Count -1 do
    begin
      item := FBrowser.Strings[line];
      startPos := 0;
      while  FindAnchorName(item, startPos, size) do
      begin
        if (size = len) and StartWithP(s, @item.FText[startPos], size) then
        begin
          if FBrowser.TopLine > line then
            FBrowser.SetTop(line);
          while FBrowser.Strings.Count > line +1 do
          begin
            FBrowser.Strings.Items[line].Free;
            FBrowser.Strings.Delete(line);
          end;
          exit;
        end;
      end;
    end;
    currentStartLine := 1;
    ClearBrowser;
  end;
  {$ENDIF}

  function CalcDrawStartline: integer;
  begin
    result := thread.lines - DrawLinesArray[Config.oprDrawLines] + 1;
    if result >= thread.lines then
      result := 2;
  end;

var
  checkNew: boolean;
label DoReq;
begin
  if assigned(daemon.FatalException) then
    ResetDaemon;

  if thread = nil then
    exit;

  if FThread = thread then
  begin
    if (0 < drawStartLine) or (drawStartLine < FThread.lines) then
      newDrawStartline := drawStartLine
    else
      newDrawStartline := CalcDrawStartline;
    if (-1 < position) and (position < FThread.lines) and (position < newDrawStartline - 1) then
      newDrawStartline := position + 1;
    if newDrawStartline <> drawStartLine then
    begin
      FThread.CancelAsyncRead;
      FreeThread(false);
      drawStartLine := newDrawStartline;
    end;
  end else
  begin
    if newDrawStartline <= 0 then
    begin
      DrawStartline := CalcDrawStartline;
      if (-1 < position) and (position < thread.lines) and (position < DrawStartline - 1) then
        DrawStartline := position + 1;
    end else
      drawStartLine := newDrawStartline;
  end;
  newDrawStartline := -1;

  FNavigateToViewPos := (0 <= position);
  if FNavigateToViewPos then
    thread.viewPos := position;
  if (FProgress = tpsProgress) then
  begin
    if thread = FThread then
    begin
      checkNew := CheckP(thread, oprType);
      if checkNew and (not currentCheckNew) then
        goto DoReq;
      exit;
    end;
    if 0 < FStream.re_entrant then
    begin
      if assigned(nextThread) then
        nextThread.Release;
      nextThread := thread;
      nextCheckOpr := oprType;
      thread.AddRef;
      FStream.Cancel;
      exit;
    end;
    nextThread := nil;
  end;
  FProgress:= tpsProgress;
  FNaviStat:= tpsNone;
  FPreStat := tpsNone;
  FAsyncStat:= tpsNone;
  pumpCount := 0;

  FreeStream;

  MainWnd.TabControl.Tabs.Strings[viewList.IndexOf(self)]
     := Copy(AnsiReplaceText(HTML2String(thread.title), '&', '&&'), 1, 4095);

  checkNew := CheckP(thread, oprType);

  if (thread = FThread) and (thread.dat <> nil) then
  begin
    if checkNew and redraw and (FThread.lines > FThread.oldLines) then
    begin
      {$IFDEF IE}
      currentStartLine := 1;
      {$ELSE}
      currentStartLine := FThread.oldLines +1;
      {$ENDIF}
      if FNavigateToViewPos then
      begin
        FThread.oldLines := FThread.lines;
        FThread.anchorLine := FThread.lines;
      end else
        SaveViewPos;
      DeleteNewRes;

      if currentStartLine = 1 then
      begin
        {$IFDEF IE}
        FNaviStat := tpsProgress;
        {$ELSE}
        FNaviStat := tpsDone;
        {$ENDIF}
        FPreStat := tpsProgress;
      end
      else begin
        FNaviStat := tpsDone;
        FPreStat := tpsReady;
      end;
      SetLength(backStack, 0);
      SetLength(forwordStack, 0);
    end
    else begin
      FNaviStat := tpsDone;
      if FNavigateToViewPos then
        FPreStat := tpsReady
      else
        FPreStat := tpsDone;
    end;
    {$IFDEF IE}
    FStream := TWebOutBufferStream.Create(FBrowser);
    {$ELSE}
    FStream := TDat2View.Create(FBrowser);
    {$ENDIF}
  end
  else begin
    currentStartLine := 1;

    if FThread <> thread then
      MainWnd.ThreadClosing(FThread);

    FreeThread;
    FThread := thread;
    thread.AddRef;
    thread.anchorLine := thread.oldLines;

    FPreStat := tpsProgress;
    {$IFDEF IE}
    FStream := TWebOutBufferStream.Create(FBrowser);
    {$ELSE}
    FStream := TDat2View.Create(FBrowser);
    {$ENDIF}

    (* ʃNA *)
    {$IFDEF IE}
    FNaviStat := tpsProgress;
    {$ELSE}
    //FNaviStat := tpsDone;
    FNaviStat := tpsProgress;
    //OnNavigateDone;
    daemon.Post(OnNavigateDone);
    {$ENDIF}
    ClearBrowser;
    SetLength(backStack, 0);
    SetLength(forwordStack, 0);
  end;

 DoReq:
  currentCheckNew := True;
  FWantTraceLogDone := checkNew;

  if checkNew then
  begin
    (* 񓯊MJnFLZƂ̗݂ŏIʒm͐e *)
    FAsyncStat := tpsProgress;
    case thread.StartAsyncRead(viewList.MasterDoneProc,
                               viewList.MasterNotifyProc, force) of
    trrSuccess, trrErrorProgress: ;
    trrErrorTemporary:
      begin
        DlgTooManyConn;
        OnAsyncDoneProc(thread);
      end;
    else //trrErrorPermanent:
      OnAsyncDoneProc(thread);
    end;
  end
  else begin
    //thread.oldLines := thread.lines;
    FAsyncStat := tpsReady;
  end;

  DoWorking;

end;

(* WebBrowsernavigateI *)
procedure TViewItem.OnNavigateDone;
begin
  if FProgress = tpsProgress then
  begin
    if FNaviStat = tpsProgress then
      FNaviStat := tpsDone;
    //if browser.Visible then
    //  viewList.UpdateFocus(self);
  end;
  (* ēĂƃCȂ̂ŕʌŉ *)
  daemon.Post(viewList.DoWorkingAll);
end;


(* 񓯊MCxgnh *)
procedure TViewItem.OnAsyncDoneProc(thread: TThreadItem);
begin
  if (FProgress = tpsProgress) and (thread = FThread) then
  begin
    if FAsyncStat = tpsWorking then
    begin
      FAsyncStat := tpsReady;
      (* ŃfBXpb`Ăт *)
    end
    else begin
      FAsyncStat := tpsReady;
      DoWorking;
    end;
  end;
end;

(* Mro *)
procedure TViewItem.OnAsyncNotifyProc(thread: TThreadItem);
begin
  if thread <> FThread then
    exit;
  if (FProgress = tpsProgress) and
     (FPreStat = tpsDone) and (FAsyncStat = tpsProgress) then
  begin
    (* V\ *)
    FAsyncStat := tpsWorking;
    Inc(re_entrant);
    try
      PumpChunk;
    except
    end;
    Dec(re_entrant);
    if canceled then // and (FNaviStat in [tpsNone, tpsDone]) and (re_entrant <= 0) then
    begin
      Drain;
      exit;
    end;
    if (length(thread.title) <= 0) and
      Assigned(thread.dat) and (0 < thread.dat.Size) then
    begin
      thread.title := thread.GetSubject;
      MainWnd.UpdateTabTexts;
    end;

    (* ēĊʒmĂ邩mȂ̂ŏԂ`FbN *)
    if FAsyncStat = tpsWorking then
      FAsyncStat := tpsProgress
    else
      DoWorking;
  end
  else
    DoWorking;
end;

(* V\ *)
procedure TViewItem.PumpChunk;
var
  lines: integer;
begin
  if (FThread = nil) or (FThread.dat = nil) then
    exit;
  if (currentStartLine <= FThread.dat.Lines) then
  begin
    if (FStream = nil) or (FStream.canceled) then
      exit;
    Log(Format('ӁiͥjǕϊ(%d޲)', [FThread.dat.Size - FThread.dat.Position+1]));
    try
      if currentStartLine = FThread.anchorLine +1 then
        WriteSkin(PChar(NewMarkHTML), length(NewMarkHTML));
      //NEWD2HTML.AboneArray := FThread.AboneArray; //[457]
      //NEWD2HTML.thread :=  FThread;
      if (0 < FThread.readPos) and (currentStartLine <= FThread.readPos) then
      begin
        lines := NEWD2HTML.ToDatOut(FStream, FThread.dat, currentStartLine, FThread.readPos - currentStartLine + 1, FThread.AboneArray);
        Inc(currentStartLine, lines);
        if currentStartLine - 1 = FThread.readPos then
        begin
          WriteSkin(PChar(BookMarkHTML),length(BookMarkHTML)); // ܂œǂ
          lines := NEWD2HTML.ToDatOut(FStream, FThread.dat, FThread.readPos + 1, High(integer), FThread.AboneArray);
        end;
        if 0 < lines then
          Inc(currentStartLine, lines);
      end
      else begin
        lines := NEWD2HTML.ToDatOut(FStream, FThread.dat, currentStartLine, High(integer), FThread.AboneArray);
        if 0 < lines then
          Inc(currentStartLine, lines);
      end;
      FThread.ChkConsistency;

      {$IFNDEF IE}
      FBrowser.Invalidate;
      {$ENDIF}
      FStream.Flush;
      if not FNavigateToViewPos and Config.oprScrollToNewRes and (pumpCount = 0) then
        ScrollToNewRes;
    except
      on e: EStreamError do
      begin
        Log(Format('stream exception: may be canceled: %s', [e.Message]));
      end;
    end;
    Inc(pumpCount);
  end;
end;


(* X\FԖ̏ *)
procedure TViewItem.DoWorking;
  procedure StartWriting;
  begin
    FPreStat := tpsWorking;
    ZoomBrowser(Config.viewZoomSize);

    {$IFNDEF IE}
    FStream.EnableFontTag := true;
    {$ENDIF}
    if (FThread.board <> nil) and
       (0 < length(TBoard(FThread.board).customHeader)) then
    begin
      with TBoard(FThread.board) do
        WriteSkin(@customHeader[1], length(customHeader));
    end
    else
      WriteSkin(@HeaderHTML[1], length(HeaderHTML));
    {$IFNDEF IE}
    FStream.EnableFontTag := false;
    {$ENDIF}
    FPreStat := tpsReady;
    FStream.Flush;
  end;

  procedure PumpPreContents;
  begin
    FPreStat := tpsWorking;
    if (currentStartLine <= FThread.oldLines) and
       assigned(FThread.dat) and (0 < FThread.dat.Size) then
    begin
      Log(Format('ӁiͥjǕϊ(%d޲)', [FThread.dat.Size]));

      if currentStartLine = 1 then
      begin
        D2HTML.ToDatOut(FStream, FThread.dat, 1, 1, FThread.AboneArray);
        if FThread.readPos = 1 then
          FStream.WriteHTML(PChar(BookMarkHTML),length(BookMarkHTML));
        Inc(currentStartLine);
      end;
      if currentStartLine < drawStartLine then // \Xw
        currentStartLine := drawStartLine;

      if (0 < FThread.readPos) and (currentStartLine <= FThread.readPos) and (FThread.readPos <= Fthread.oldLines) then
      begin
        D2HTML.ToDatOut(FStream, FThread.dat,
                        currentStartLine, FThread.readPos - currentStartLine + 1, FThread.AboneArray);
        WriteSkin(PChar(BookMarkHTML),length(BookMarkHTML)); // ܂œǂ
        D2HTML.ToDatOut(FStream, FThread.dat,
                        FThread.readPos + 1, FThread.oldLines - FThread.readPos, FThread.AboneArray);
      end else
        D2HTML.ToDatOut(FStream, FThread.dat,
                        currentStartLine, FThread.oldLines - currentStartLine + 1, FThread.AboneArray{[457]}); (* ē *)

      FThread.ChkConsistency;
      currentStartLine := FThread.oldLines + 1;
      FStream.Flush;
      FWantTraceLogDone := True;
    end;
    if Config.oprScrollToPreviousRes or FNavigateToViewPos then
      SetViewPos;

    if FThread = nil then
    begin
      FPreStat := tpsDone;
    end
    else begin
      //if FThread.oldLines < currentStartLine then
        FPreStat := tpsDone
      //else
      //  FPreStat := tpsReady;
    end;
  end;


  procedure AsyncResult;
  begin
    if FAsyncStat <> tpsReady then
      exit;
    FAsyncStat := tpsWorking;
    Inc(re_entrant);
    PumpChunk;
    Dec(re_entrant);
    FAsyncStat := tpsDone;
    LogDone(FWantTraceLogDone);
    UpdateThreadInfo(FThread);
  end;

  procedure Complete;
  begin
    if not FNavigateToViewPos and Config.oprScrollToNewRes and (pumpCount = 0) then
      ScrollToNewRes;

    if FNavigateToViewPos and
       Assigned(FThread) and (FThread.oldLines <= FThread.viewPos) then
      SetViewPos;

    FBrowser.Invalidate;
    FProgress := tpsNone;
    FNaviStat:= tpsNone;
    FPreStat := tpsNone;
    FAsyncStat:= tpsNone;
    FreeStream;
    currentCheckNew := False;
    if freeByCancel then
      FreeThread
    else
      MainWnd.UpdateTabTexts;
  end;

  procedure sub;
  begin
    if FProgress <> tpsProgress then
      exit;
    if FNaviStat <> tpsDone then
      exit;
    if freeByCancel and (FAsyncStat = tpsNone) then
    begin
      FProgress := tpsNONE;
      exit;
    end;
    if FPreStat = tpsProgress then
      StartWriting;
    if FPreStat = tpsReady then
      PumpPreContents;
    if FPreStat = tpsDone then
    begin
      if FAsyncStat = tpsReady then
        AsyncResult;
      if FAsyncStat = tpsDone then
      begin
        Complete;
        if assigned(nextThread) then
          OnCancel;
      end
    end;
  end;

begin
  Inc(re_entrant);
  try
    sub;
  except
    on stream: ECancelViewException do
    begin
      Log('canceled');
      FPreStat := tpsDone;
      if not canceled then
        OnCancel;
    end;
  end;
  Dec(re_entrant);
  if canceled then
    Drain;
end;

(* Xe\ʒu̐ݒ *)
function TViewItem.SetViewPos: boolean;
{$IFDEF IE}
var
  doc: IDispatch;
begin
  result := false;
  //if not Config.oprScrollToPreviousRes then
  //  exit;
  doc := FBrowser.Document;
  if assigned(doc) then
  begin
    result := ScrollToAnchor(FThread.viewPos, true, false);
  end;
end;
{$ELSE}
begin
  //result := false;
  //if not Config.oprScrollToPreviousRes then
  //  exit;
  result := ScrollToAnchor(FThread.viewPos, true, false);
end;
{$ENDIF}

(* ̑傫ύX *)
procedure TViewItem.ZoomBrowser(zoom: integer);
{$IFDEF IE}
var
  size, res: OleVariant;
begin
  if browser.Document = nil then
    exit;
  size := zoom;
  try
    browser.ExecWB(OLECMDID_ZOOM , OLECMDEXECOPT_DONTPROMPTUSER, size, res);
  except
  end;
end;
{$ELSE}
begin
  FBrowser.ExternalLeading := ZoomToExternalLeading(Config.viewZoomSize);
  FBrowser.SetFont(FBrowser.Font.Name, ZoomToPoint(Config.viewZoomSize));
end;
{$ENDIF}

(* VփXN[ *)
function TViewItem.ScrollToNewRes: boolean;
begin
  result := false;
  if FThread = nil then
    exit;
  result := ScrollToAnchor(FThread.anchorLine, Config.oprScrollTop, false);
  {$IFNDEF IE}
  if not result then
  begin
    FBrowser.EndOfBuffer;
    SetLength(forwordStack, 0);
    SetLength(backStack, length(backStack) +1);
    backStack[length(backStack) -1] := FBrowser.LogicalTopLine;
  end;
  {$ENDIF}
end;

(* AJ[ւ̃XN[ *)
function TViewItem.ScrollToAnchor(num: integer; isTop: boolean; redraw: boolean): boolean;
{$IFDEF IE}
var
  doc: IDispatch;
  item: OleVariant;
  top: integer;
  thread: TThreadItem;
  //len: integer;
  //anchor: string;
begin
  result := false;
  if FThread = nil then
    exit;
  doc := browser.Document;
  if doc = nil then
    exit;
  if FThread.lines -1 < num then
    num := FThread.lines -1;
  //[457]
//  if Config.viewTransparencyAbone then
  num := FThread.ABoneArray.GetNearNotAboneResNumber(num+1) - 1;
  if num < 0 then
    exit;

  if (num + 1 < drawStartLine) and (num <> 0) and redraw then
  begin
    thread := FThread;
    FThread.CancelAsyncRead;
    FreeThread(false);
    NewRequest(thread, gotLOCAL, num, false, false);
    result := true;
    exit;
  end;

  try
    (* ʒuvZB␳͉Ƃ *)
    {len := OleVariant(doc as IHTMLDocument2).anchors.length;
    if num < len then
    begin}
      (*OleVariant(doc as IHTMLDocument2).anchors.item(num).scrollIntoView(true);*)
      SetLength(forwordStack, 0);
      SetLength(backStack, length(backStack) +1);
      backStack[length(backStack) -1] := OleVariant(doc as IHTMLDocument2).body.scrollTop;
      top := 0;
      item := OleVariant(doc as IHTMLDocument2).anchors.item(IntToStr(num + 1));
      repeat
        top := top + item.offsetTop;
        item := item.offsetParent;
      until  AnsiCompareText(item.tagName, 'body') = 0;
      if not isTop then
        Dec(top, browser.Height - 40);
      OleVariant(doc as IHTMLDocument2).body.scrollTop := top - 10;
      result := true;
    //end;
  except
  end;
end;
{$ELSE}
var
  s: string;
  line, len: integer;
  startPos, size: integer;
  item: THogeTVItem;
  point: TPoint;
  PrevAnchorLine: Integer;
  thread: TThreadItem;

label FoundLine;
begin
  //[457]
//  if Config.viewTransparencyAbone then
  num := FThread.ABoneArray.GetNearNotAboneResNumber(num+1) - 1;

  if (num + 1 < drawStartLine) and (num <> 0) and redraw then
  begin
    thread := FThread;
    FThread.CancelAsyncRead;
    FreeThread(false);
    NewRequest(thread, gotLOCAL, num, false, false);
    result := true;
    exit;
  end;

  if FThread.lines < num + 1 then
    num := -1;

  s := IntToStr(num+1);
  len := length(s);
  FBrowser.Selecting := False;
  PrevAnchorLine := -1;
  for line := 0 to FBrowser.Strings.Count -1 do
  begin
    item := FBrowser.Strings[line];
    startPos := 0;
    while FindAnchorName(item, startPos, size) do
    begin
      if (size = len) and StartWithP(s, @item.FText[startPos], size) then begin
        PrevAnchorLine:=line;
        goto FoundLine;
      end else
      if (size > len) or
          ((size = len) and (CompareStr(s, Copy(item.FText,startPos,size))<= 0)) then
        goto FoundLine;
      PrevAnchorLine := line;
    end;
  end;
  FoundLine:
  if PrevAnchorLine >= 0 then
  begin
    SetLength(forwordStack, 0);
    SetLength(backStack, length(backStack) +1);
    backStack[length(backStack) -1] := FBrowser.LogicalTopLine;
    point.X := 0;
    point.Y := PrevAnchorLine;
    FBrowser.SetTop(FBrowser.PhysicalToLogical(point).Y);
    FBrowser.SetPhysicalCaret(0, PrevAnchorLine + FBrowser.VerticalCaretMargin);
    result := True;
  end else
    result := false;
end;
{$ENDIF}

procedure TViewItem.GoBack;
{$IFDEF IE}
var
  doc: IDispatch;
begin
  doc := FBrowser.Document;
  if doc = nil then
    exit;
  if length(backStack) > 0 then
  begin
    SetLength(forwordStack, length(forwordStack) +1);
    forwordStack[length(forwordStack) -1] := OleVariant(doc as IHTMLDocument2).body.scrollTop;
    OleVariant(doc as IHTMLDocument2).body.scrollTop := backStack[length(backStack) -1];
    SetLength(backStack, length(backStack) -1);
  end;
end;
{$ELSE}
begin
  if length(backStack) > 0 then
  begin
    SetLength(forwordStack, length(forwordStack) +1);
    forwordStack[length(forwordStack) -1] := FBrowser.LogicalTopLine;
    FBrowser.Selecting := false;
    FBrowser.SetTop(backStack[length(backStack) -1]);
    SetLength(backStack, length(backStack) -1);
  end;
end;
{$ENDIF}

function TViewItem.CanGoBack: boolean;
begin
  result := length(backStack) > 0;
end;

procedure TViewItem.GoForword;
{$IFDEF IE}
var
  doc: IDispatch;
begin
  doc := FBrowser.Document;
  if doc = nil then
    exit;
  if length(forwordStack) > 0 then
  begin
    SetLength(backStack, length(backStack) +1);
    backStack[length(backStack) -1] := OleVariant(doc as IHTMLDocument2).body.scrollTop;
    OleVariant(doc as IHTMLDocument2).body.scrollTop := forwordStack[length(forwordStack) -1];
    SetLength(forwordStack, length(forwordStack) -1);
  end;
end;
{$ELSE}
begin
  if length(forwordStack) > 0 then
  begin
    SetLength(backStack, length(backStack) +1);
    backStack[length(backStack) -1] := FBrowser.LogicalTopLine;
    FBrowser.Selecting := false;
    FBrowser.SetTop(forwordStack[length(forwordStack) -1]);
    SetLength(forwordStack, length(forwordStack) -1);
  end;
end;
{$ENDIF}

function TViewItem.CanGoForword: boolean;
begin
  result := length(forwordStack) > 0;
end;


function TViewItem.MessageLoop: boolean;
begin
  Application.ProcessMessages;
  if canceled then
  begin
    Drain;
    result := true;
  end
  else
    result := false;
end;

{beginner} //Xbh̃L[[ho
procedure TViewItem.ExtractKeyword(const target:string; ExThread:TThreadItem);
var
  count: Integer;
  {$IFDEF IE}
  ExtStream :TWebOutBufferStreamForExtraction;
  {$ELSE}
  ExtStream :TDat2ViewForExtraction;
  {$ENDIF}
begin
  if ExThread = nil then
    exit;

  MainWnd.TabControl.Tabs.Strings[viewList.IndexOf(self)] := 'o';

  ExThread.AddRef;
  ExThread.CancelAsyncRead;

  {$IFDEF IE}
  if browser.Document = nil then
  begin
    FProgress := tpsWorking;
    ClearBrowser;
    while browser.Document = nil do
    begin
      if MessageLoop then
        exit;
    end;
  end;
  {$ELSE}
  ClearBrowser;
  {$ENDIF}
  ZoomBrowser(Config.viewZoomSize);

  {$IFDEF IE}
  ExtStream := TWebOutBufferStreamForExtraction.Create(FBrowser);
  {$ELSE}
  ExtStream := TDat2ViewForExtraction.Create(FBrowser);
  {$ENDIF}
  FStream := ExtStream;

  ExtStream.Base:= ExThread.ToURL;
  ExtStream.BBSType := TBoard(ExThread.board).GetBBSType;

  if AnsiPos(#13,ExtStream.Base)>0 then
    ExtStream.Base := copy(ExtStream.Base, 1, AnsiPos(#13, ExtStream.Base) - 1);

  {$IFNDEF IE}
  ExtStream.EnableFontTag := true;
  {$ENDIF}
  if (ExThread.board <> nil) and
     (0 < length(TBoard(ExThread.board).customHeader)) then
  begin
    with TBoard(ExThread.board) do
      //ExtStream.WriteHTML(@customHeader[1], length(customHeader));
      WriteSkin(@customHeader[1], length(customHeader), ExThread);
    end
  else
    //ExtStream.WriteHTML(@HeaderHTML[1], length(HeaderHTML));
    WriteSkin(@HeaderHTML[1], length(HeaderHTML), ExThread);
  {$IFNDEF IE}
  ExtStream.EnableFontTag := false;
  {$ENDIF}

  ExtStream.WriteHTML('yL[[hoz<br>ΏۃXF ');
  ExtStream.WriteAnchor('',ExtStream.Base,pchar(ExThread.title),length(ExThread.title));
  ExtStream.WriteHTML('<br>L[[hF '+target+'<br><br><br>');
  ExtStream.Flush;

  Count := _ExtractKeyWord(ExThread, ExtStream, target, 0);

  ExtStream.WriteHTML('<br><br><br>oXF'+inttostr(count));
  ExtStream.Flush;


  HintText := 'yL[[hoz'#13#10'ΏۃXF'+ExThread.title
             +#13#10'L[[hF'+StringReplace(target,'&','&&',[rfReplaceAll])
             +#13#10'oXF'+inttostr(count);

  ExThread.Release;

  ExtStream.flush;
  ExtStream.Free;
  FStream := nil;
  {$IFNDEF IE}
  FBrowser.SetTop(0);
  FBrowser.SetPhysicalCaret(0,0);
  {$ENDIF}

end;

(* O *)
procedure TViewItem.Grep(const target: string; targetBoardList: TList;
                         threadtitleonly: boolean = false; writepopup: boolean = false;
                         const popupmaxseq: Integer = 5; const popupeachthremax: Integer = 10);
var
  thread: TThreadItem;
  {$IFNDEF IE}
  tvc: TSimpleDat2View;
  {$ENDIF}

  procedure ShowEntry(const additional: string = ''; first: boolean = false);
  var
    brd: string;
    board: TBoard;
    category: TCategory;
  begin
    board := TBoard(thread.board);
    category := TCategory(board.category);
    if first then
      brd := '<a href="' + board.GetURIBase + '/">' + board.name + '</a>'
    else
      brd := board.name;
    {$IFDEF IE}
    OleVariant(browser.Document as IHTMLDocument2).write(
               '<li>' + category.name + ' ['+ brd + ']' + additional
               + '  '
               + '<a href="' + thread.ToURL(false, false) + '">'
               + thread.title + '</a></li>'#10
              );
    {$ELSE}
    tvc.WriteHTML(
                 '<li>' + category.name + ' ['+ brd + ']' + additional
               + '  '
               + '<a href="' + thread.ToURL(false, false) + '">'
               + thread.title + '</a></li>'
              );
    {$ENDIF}
  end;

  //[457]
  procedure ShowPopUpEntry(const numberstr: string);
  begin
    {$IFDEF IE}
    OleVariant(browser.Document as IHTMLDocument2).write(
               '<a href="' + thread.ToURL(false, false, numberstr) + '">'
               + numberstr + '</a> '#10
              );
    {$ELSE}
    tvc.WriteHTML(
               '<a href="' + thread.ToURL(false, false, numberstr) + '">'
               + numberstr + '</a> '
              );
    {$ENDIF}
  end;
var
  index: integer;
  i, k, l: integer;
  board: TBoard;
  category: TCategory;
  tgt: string;
  hasTarget: boolean;
  countInBoard: integer;
  totalCount: integer;
  //[457]
  s: string;
  popupstartline: Integer;
  popupcountthread: Integer;
  popupbreak: Boolean;

begin
  hasTarget := (0 < length(target));
  if hasTarget then
  begin
    tgt := target;
    tgt := StringReplace(tgt, '&', '&amp;', [rfReplaceAll]);
    tgt := StringReplace(tgt, '<', '&lt;', [rfReplaceAll]);
    tgt := StringReplace(tgt, '>', '&gt;', [rfReplaceAll]);
  end;
  index := viewList.IndexOf(self);
  MainWnd.TabControl.Tabs.Strings[index] := 'O';
  totalCount := 0;

  {$IFDEF IE}
  if browser.Document = nil then
  begin
    FProgress := tpsWorking;
    ClearBrowser;
    while browser.Document = nil do
    begin
      if MessageLoop then
        exit;
    end;
  end;
  ZoomBrowser(Config.viewZoomSize);
  if hasTarget then
    OleVariant(browser.Document as IHTMLDocument2).write(
               '<html><body><p>y'+ tgt +'ž</p><ul>'#10)
  else
    OleVariant(browser.Document as IHTMLDocument2).write(
               '<html><body><p>y擾ς݃Oꗗz</p><ul>'#10);
  {$ELSE}
  ZoomBrowser(Config.viewZoomSize);
  tvc := TSimpleDat2View.Create(FBrowser);
  if hasTarget then
    tvc.WriteHTML('<html><body><p>y'+ tgt +'ž</p><ul>'#10)
  else
    tvc.WriteHTML('<html><body><p>y擾ς݃Oꗗz</p><ul>'#10);
  {$ENDIF}

  for i := 0 to targetBoardList.Count -1 do
  begin
    board := TBoard(targetBoardList.Items[i]);
    board.AddRef;
    category := TCategory(board.category);
    log('  ' + board.name);
    MainWnd.WriteStatus(board.name);
    if MessageLoop then
    begin
      board.Release;
      {$IFNDEF IE}
      tvc.Free;
      {$ENDIF}
      exit;
    end;
    if hasTarget and (0 < FindPosIC(tgt, board.name, 1)) then
    begin
      {$IFDEF IE}
      OleVariant(browser.Document as IHTMLDocument2).write(
        '<li>' + category.name + ' ['
        + '<a href="http://' + board.host + '/'+ board.bbs + '/"> '
        + board.name + '</a>]</li>'#10
      );
      {$ELSE}
      tvc.WriteHTML(
        '<li>' + category.name + ' ['
        + '<a href="http://' + board.host + '/' + board.bbs + '/"> '
        + board.name + '</a>]</li>'
      );
      {$ENDIF}
      Inc(totalCount);
    end;
    countInBoard := 0;
    for k := 0 to board.Count -1 do
    begin
      if MessageLoop then
      begin
        board.Release;
        {$IFNDEF IE}
        tvc.Free;
        {$ENDIF}
        exit;
      end;
      thread := board.Items[k];
      if hasTarget then
      begin
        if 0 < FindPosIC(tgt, thread.title, 1) then
        begin
          if thread.lines <= 0 then
            ShowEntry('(擾)')
          else
          begin
            ShowEntry('');
          end;
          Inc(totalCount);
        end
        else if not threadtitleonly then
        begin
          if thread.lines <= 0 then
            continue;
          thread.AddRef;
          if thread.dat <> nil then
          begin
            if thread.dat.Contains(tgt) then
            begin
              ShowEntry;
              Inc(totalCount);

              if writepopup then
              begin
                popupstartline := 0;
                popupcountthread := 0;
                popupbreak := false;
                for l:=1 to thread.lines do
                begin
                  s := SEARCHD2HTML.ToString(thread.dat, l, 1);
                  if AnsiContainsText(s, target) then
                  begin
                    if popupstartline = 0 then
                      popupstartline := l
                    else if l - popupstartline >= popupmaxseq then //܂蒷Ɠǂ߂Ȃ
                    begin
                      ShowPopUpEntry(IntToStr(popupstartline) + '-' + IntToStr(l-1));
                      Inc(popupcountthread);
                      popupstartline := l;
                    end;
                  end
                  else begin
                    if popupstartline <> 0 then
                    begin
                      if(popupstartline <> l-1) then
                        ShowPopUpEntry(IntToStr(popupstartline) + '-' + IntToStr(l-1))
                      else
                        ShowPopUpEntry(IntToStr(popupstartline));
                      popupstartline := 0;
                      Inc(popupcountthread);
                    end;
                  end;
                  if popupcountthread >= popupeachthremax then
                  begin
                    {$IFDEF IE}
                    OleVariant(browser.Document as IHTMLDocument2).write('(ȉ)');
                    {$ELSE}
                    tvc.WriteHTML('(ȉ)');
                    {$ENDIF}
                    popupbreak := true;
                    break;
                  end;
                end;

                if (popupstartline <> 0) and (not popupbreak) then
                begin
                  if(popupstartline <> thread.lines) then
                    ShowPopUpEntry(IntToStr(popupstartline) + '-' + IntToStr(thread.lines))
                  else
                    ShowPopUpEntry(IntToStr(popupstartline));
                end;

                if popupcountthread > 0 then
                begin
                  {$IFDEF IE}
                  OleVariant(browser.Document as IHTMLDocument2).write('<BR>'#10);
                  {$ELSE}
                  tvc.WriteHTML('<BR>');
                  {$ENDIF}
                end;
              end;

            end;
          end;
          thread.Release;
        end;
      end
      else begin
        if 0 < thread.lines then
        begin
          ShowEntry('', countInBoard = 0);
          Inc(countInBoard);
          Inc(totalCount);
          if writepopup then
          begin
            ShowPopUpEntry('1-' + IntToStr(Min(popupmaxseq, thread.lines)));
            {$IFDEF IE}
            OleVariant(browser.Document as IHTMLDocument2).write('<BR>'#10);
            {$ELSE}
            tvc.WriteHTML('<BR>');
            {$ENDIF}
          end;
        end;
      end;
    end;
    board.Release;
  end;
  {$IFDEF IE}
  OleVariant(browser.Document as IHTMLDocument2).write(
        '</ul><br><p>y' + IntToStr(totalCount) + ' ܂z</p>');
  {$ELSE}
  tvc.WriteHTML(
        '</ul><br><p>y' + IntToStr(totalCount) + ' ܂z</p>');
  {$ENDIF}
  {$IFNDEF IE}
  tvc.Free;
  {$ENDIF}
  index := viewList.IndexOf(self);
  if 0 <= index then
    MainWnd.TabControl.Tabs.Strings[index] := '';
  FProgress := tpsNone;
  Log('I');
  MainWnd.WriteStatus('I');
end;

procedure TViewItem.Reload;
var
  thread: TThreadItem;
begin
  if FThread = nil then
    exit;
  FThread.CancelAsyncRead;
  FThread.MoveLog;
  FThread.Release;
  thread := FThread;
  FThread := nil;
  NewRequest(thread, gotCHECK, -1, true);
end;

//[457] X̍ĕ`iAboneLocalReload߁j- 521@
procedure TViewItem.LocalReload(line: Integer; drawline: integer = -1);
var
  thread: TThreadItem;
begin
  if FThread = nil then
    exit;

  if drawline > 0 then
  begin
    if drawline <= 1 then
      newdrawStartLine := 2
    else
      newdrawStartLine := drawline;
  end;
  FThread.CancelAsyncRead;
  thread := FThread;
  FreeThread(false);
  NewRequest(thread, gotLOCAL, line, false, false);
end;

procedure TViewItem.About;
{$IFDEF IE}
var
  index: integer;
  doc: OleVariant;
begin
  index := viewList.IndexOf(self);
  MainWnd.TabControl.Tabs.Strings[index] := 'ABOUT';

  if browser.Document = nil then
  begin
    FProgress := tpsWorking;
    ClearBrowser;
    //browser.Navigate('about:blank');
    while browser.Document = nil do
    begin
      if MessageLoop then
        exit;
    end;
  end;
  doc := OleVariant(browser.Document as IHTMLDocument2);
  doc.write('<html><head><META http-equiv="Content-Type" content="text/html; charset=Shift_JIS">'#10 +
            '<style type="text/css"><!--'#10 +
            'li { font-family:Verdana }'#10 +
            'p { font-family:Verdana }'#10 +
            '--></style></head>'#10 +
            '<body><H1><a href="' + Main.DISTRIBUTORS_SITE + '">' + Main.JANE2CH + '</a></H1>'#10);
            {  + '(<a href="http://www.geocities.co.jp/SiliconValley-Cupertino/2486/">' + TESTVER + '</a>)'
              + '(<a href="http://tokyo.cool.ne.jp/ymf754/">' + SYRUPTESTVER + '</a>)</H1>'#10);}
  doc.write('<p>Powered by <a href="http://www.monazilla.org/">Monazilla Project</a>.</p>'#10);
  doc.write('<hr>'#10'<ul>'#10);
  for index := 0 to length(Main.Copyrights) -1 do
  begin
    doc.write('<li>' + AnsiReplaceText(Main.Copyrights[index], '(c)', '&copy;') + '</li>'#10);
  end;
  doc.write('</ul>'#10'<hr>'#10);
  doc.write('</body></html>');
  ZoomBrowser(Config.viewZoomSize);
end;
{$ELSE}
var
  stv: TSimpleDat2View;
  i: Integer;
begin
  i := viewList.IndexOf(self);
  MainWnd.TabControl.Tabs.Strings[i] := 'ABOUT';

  ClearBrowser;
  ZoomBrowser(Config.viewZoomSize);

  stv := TSimpleDat2View.Create(FBrowser);
  with stv do
  begin
    WriteHTML('<html><head></head><body>');
    WriteHTML('<h1><a href="' + Main.DISTRIBUTORS_SITE + '">' + Main.JANE2CH + '</a></h1>'#10);
              {+ '(<a href="http://www.geocities.co.jp/SiliconValley-Cupertino/2486/">' + TESTVER + '</a>)'
              + '(<a href="http://tokyo.cool.ne.jp/ymf754/">' + SYRUPTESTVER + '</a>)</h1>'#10);}
    WriteHTML('<hr>');
    WriteHTML('<p>Powered by <a href="http://www.monazilla.org/">Monazilla Project</a>.</p>'#10);
    WriteHTML('<br><hr><ul>');
    for i := 0 to length(Main.Copyrights) -1 do
    begin
      WriteHTML('<li>' + AnsiReplaceText(Main.Copyrights[i], '(c)', '&copy;') + '</li>'#10);
    end;
    WriteHTML('</ul>');
    WriteHTML('</body></html>');
  end;
  stv.Free;
end;
{$ENDIF}

procedure TViewItem.ClearBrowser;
{$IFDEF IE}
var
  URL: OleVariant;
  flag: OleVariant;
begin
  URL := 'about:blank';
  flag := $0E;
  FBrowser.Navigate2(URL, flag);
end;
{$ELSE}
begin
  FBrowser.Clear;
end;
{$ENDIF}

procedure TViewItem.WriteSkin(str: PChar; size: integer; thread: TThreadItem = nil);
var
  i: integer;
begin
  if thread = nil then
    thread := FThread;
  if thread = nil then
  begin
    FStream.WriteHTML(str, size);
    exit;
  end;

  i := 0;
  while i < size do
  begin
    if str[i] = '<' then
    begin
      if StartWithP('<THREADURL/>', str+i, size-i) then
      begin
        FStream.WriteHTML(str, i);
        FStream.WriteHTML(thread.ToURL);
        str := str +i +12;
        Dec(size, i+12);
        i := 0;
      end
      else if StartWithP('<THREADNAME/>', str+i, size-i) then
      begin
        FStream.WriteHTML(str, i);
        FStream.WriteHTML(thread.title);
        str := str +i +13;
        Dec(size, i+13);
        i := 0;
      end
      else if StartWithP('<GETRESCOUNT/>', str+i, size-i) then
      begin
        FStream.WriteHTML(str, i);
        FStream.WriteHTML(IntToStr(thread.oldLines));
        str := str +i +14;
        Dec(size, i+14);
        i := 0;
      end
      else if StartWithP('<SKINPATH/>', str+i, size-i) then
      begin
        FStream.WriteHTML(str, i);
        FStream.WriteHTML(Config.SkinPath);
        str := str +i +11;
        Dec(size, i+11);
        i := 0;
      end else
        Inc(i);
    end else
      Inc(i);
  end;
  FStream.WriteHTML(str, i);
end;

(*=======================================================*)
(* \z *)
constructor TViewList.Create;
begin
  inherited;
  synchro := THogeMutex.Create;
  garbageList := TList.Create;
end;

(*  *)
destructor TViewList.Destroy;
var
  i: integer;
begin
  Clear;
  for i := 0 to garbageList.Count -1 do
    TViewItem(garbageList.Items[i]).Free;
  garbageList.Free;
  synchro.Free;
  inherited;
end;

(* ̃LXg *)
function TViewList.GetItems(index:integer): TViewItem;
begin
  result := inherited Items[index];
end;

(*  *)
procedure TViewList.SetItems(index: integer; viewItem: TViewItem);
begin
  inherited Items[index] := viewItem;
end;

(* ڍ폜 *)
procedure TViewList.Delete(index: integer);
begin
  //LEAK PREVENTION TViewItem(Items[index]).AutoFree;
  garbageList.Add(Items[index]);
  TViewItem(Items[index]).Drain;
  inherited Delete(index);
end;

(* S폜 *)
procedure TViewList.Clear;
var
  i: integer;
begin
  for i := 0 to Count -1 do
  begin
    if Items[i] <> nil then
      TViewItem(Items[i]).AutoFree;
  end;
  {
  for i := 0 to garbageList.Count -1 do
  begin
    if garbageList.Items[i] <> nil then
      TViewItem(garbageList.Items[i]).AutoFree;
  end;
  }
  inherited;
end;

function TViewList.GetGarbage(insertIndex: integer = -1): TViewItem;
var
  i: integer;
begin
  result := nil;
  for i := 0 to garbageList.Count -1 do
  begin
    if TViewItem(garbageList.Items[i]).Progress = tpsNone then
    begin
      result := garbageList[i];
      if insertIndex < 0 then
        inherited Add(result)
      else
        inherited Insert(insertIndex, result);
      garbageList.Delete(i);
      result.browser.Visible := true;
      result.browser.BringToFront;
      result.FreeThread;
      result.canceled := false;
      exit;
    end;
  end;
end;



(* VKr[ *)
{$IFDEF IE}
function TViewList.NewView(browser: TWebBrowser; index: integer = -1): TViewItem;
{$ELSE}
function TViewList.NewView(browser: THogeTextView; index: integer = -1): TViewItem;
{$ENDIF}
var
  viewItem: TViewItem;
begin
  viewItem := TViewItem.Create(self);
  viewItem.browser := browser;

  synchro.Wait;
  if index < 0 then
    Add(viewItem)
  else
    Insert(index, viewItem);
  synchro.Release;

  result := viewItem;
end;

(* XŒT *)
function TViewList.FindViewItem(thread: TThreadItem): TViewItem;
var
  i: integer;
  viewItem: TViewItem;
begin
  for i := 0 to Count -1 do
  begin
    viewItem := Items[i];
    if viewItem.thread = thread then
    begin
      result := viewitem;
      exit;
    end;
  end;
  result := nil;
end;

(* uEUŒT *)
function TViewList.FindViewitem(browser: TComponent): TViewItem;
var
  i: integer;
  viewItem: TViewItem;
begin
  for i := 0 to Count -1 do
  begin
    viewItem := Items[i];
    if viewItem.browser = browser then
    begin
      result := viewitem;
      exit;
    end;
  end;
  result := nil;
end;

(* JbRǑS *)
procedure TViewList.DoWorkingAll;
var
  i: integer;
begin
  for i := 0 to Count -1 do
  begin
    Items[i].DoWorking;
  end;
end;

(* f[^MFLẐłŎ󂯂 *)
procedure TViewList.MasterNotifyProc(thread: TThreadItem);
var
  i: integer;
begin
  for i := 0 to Count -1 do
  begin
    if Items[i].thread = thread then
    begin
      Items[i].OnAsyncNotifyProc(thread);
      exit;
    end;
  end;
  for i := 0 to garbageList.Count -1 do
  begin
    if TViewItem(garbageList.Items[i]).thread = thread then
    begin
      TViewItem(garbageList.Items[i]).OnAsyncNotifyProc(thread);
      exit;
    end;
  end;
end;

(* f[^MFLẐłŎ󂯂 *)
procedure TViewList.MasterDoneProc(thread: TThreadItem);
var
  i: integer;
begin
  for i := 0 to Count -1 do
  begin
    if Items[i].thread = thread then
    begin
      Items[i].OnAsyncDoneProc(thread);
      exit;
    end;
  end;
  for i := 0 to garbageList.Count -1 do
  begin
    if TViewItem(garbageList.Items[i]).thread = thread then
    begin
      TViewItem(garbageList.Items[i]).OnAsyncDoneProc(thread);
      exit;
    end;
  end;
end;

procedure TViewList.UpdateFocus(index: integer);
begin
  UpdateFocus(Items[index]);
end;

procedure TViewList.UpdateFocus(viewItem: TViewItem);
var
  wnd: HWND;
  i: integer;
begin
  if viewItem.browser = nil then
    exit;
  wnd := GetFocus;
  for i := 0 to Count -1 do
  begin
    with Items[i] do
    begin
      if (browser <> nil) and
         ((browser.Handle = wnd) or
          (IsChild(browser.Handle, wnd))) then
      begin
        viewItem.browser.SetFocus;
        exit;
      end;
    end;
  end;
end;

procedure TViewList.Debug;
begin
  Log(Format('browser: %d, garbage: %d', [Count, garbageList.Count]));
end;


(*=======================================================*)

{ TPopupViewItem }

constructor TPopupViewItem.Create(ABrowser: TPopupTextView; AOwnerView: TBaseViewItem);
begin
  inherited Create;
  FBrowser := ABrowser;
  FBrowser.Tag := LongInt(Self);
  FOwnerView := AOwnerView;
  if Assigned(FOwnerView) then
  begin
    if Assigned(FOwnerView.FPossessionView) then
      FOwnerView.FPossessionView.Release;
    FOwnerView.FPossessionView := Self;
    FPopupViewList := FOwnerView.PopUpViewList;
    if Assigned(FPopupViewList) then
      FPopupViewList.Add(Self);
  end else
    FPopupViewList := nil;
end;


destructor TPopupViewItem.Destroy;
begin
  SetThread(nil);
  if Assigned(FOwnerView) then
    FOwnerView.FPossessionView := nil;
  if Assigned(FPopupViewList) then
    FPopupViewList.Extract(Self);
  FBrowser.Free;
  inherited;
end;


procedure TPopupViewItem.Release;
begin
  if FReleased then
    Exit;
  if Locked then
  begin
    FReleased := True;
    Cancel;
    ReleasePossessionView;
    if Assigned(FOwnerView) then
      FOwnerView.FPossessionView := nil;
    if Assigned(FPopupViewList) then
      FPopupViewList.Extract(Self);
    FBrowser.Tag := 0;
    FBrowser.Hide;
  end else
    Free;
end;

procedure TPopupViewItem.UnLock;
begin
  if Locked then
  begin
    inherited Unlock;
    if FReleased and (not Locked) then
      Free;
  end;
end;


function TPopupViewItem.GetBaseItem: TBaseViewItem;
begin
  if Assigned(FOwnerView) then
    Result := FOwnerView.GetBaseItem
  else
    Result := nil;
end;

function TPopupViewItem.GetBaseThread: TThreadItem;
begin
  if Assigned(FOwnerView) then
    Result := FOwnerView.BaseThread
  else
    Result := nil;
end;


function TPopupViewItem.GetRootControl: TWinControl;
begin
  if Assigned(FOwnerView) then
    Result := FOwnerView.GetRootControl
  else
    Result := nil;
end;


procedure TPopupViewItem.SetThread(const AThread: TThreadItem);
begin
  if Assigned(FThread) then
    FThread.Release;
  FThread := AThread;
  if Assigned(FThread) then
    FThread.AddRef;
end;

procedure TPopupViewItem.Cancel;
begin
  if Assigned(FStream) then
    FStream.Cancel;
end;

function TPopupViewItem.GetSelection: String;
begin
  if Assigned(FBrowser) then
    Result := FBrowser.Selection
  else
    Result := '';
end;

function TPopupViewItem.GetDerivativeBrowser: TControl;
begin
  Result := FBrowser;
end;

function TPopupViewItem.GetDerivativeStream: TDatOut;
begin
  Result := FStream;
end;

function TPopupViewItem.BrowserQueryClose: Boolean;
begin
  Release;
  Result := True;
end;

function TPopupViewItem.GetStreamCanceled;
begin
  Result := Assigned(FStream) and FStream.canceled;
end;

procedure TPopupViewItem.PopUp(Point: TPoint);
var
  Rect: TRect;
  Monitor: TMonitor;
  MonitorRect: TRect;
begin
  Monitor := Screen.MonitorFromPoint(Point);
  if Assigned(Monitor) then
    MonitorRect := Monitor.WorkareaRect
  else
    MonitorRect := Screen.WorkAreaRect;

  Rect := FBrowser.CalcAdjstableSize(MonitorRect.Bottom - MonitorRect.Top,
    MonitorRect.Right - MonitorRect.Left);
  AdjustToTextViewLine(Point, Rect);
  Dec(Point.X, 32);
  if Point.X < MonitorRect.Left then
    Point.X := MonitorRect.Left
  else if Rect.Right + Point.X > MonitorRect.Right then
    Point.X := MonitorRect.Right - Rect.Right;
  if Rect.Top + Point.Y < MonitorRect.Top then
    Point.Y := MonitorRect.Top -Rect.Top;
  OffsetRect(Rect, Point.X, Point.Y);
  FBrowser.PopUp(Rect);
end;

function TPopupViewItem.GetEnabled: Boolean;
begin
  Result := Assigned(FBrowser) and FBrowser.Enabled;
end;

procedure TPopupViewItem.SetEnabled(const Value: Boolean);
begin
  if Assigned(FBrowser) then
    FBrowser.Enabled := Value;
  if Value then
  begin
    if Assigned(FOnEnabled) then
      FOnEnabled(Self);
    {$IFDEF IE}
    HadPointed := True;
    {$ENDIF}
  end;
  if not Value then
    ReleasePossessionView;
end;

procedure TPopupViewItem.Show2chInfo(AIdStr: String; ATarget: String; ABoard: TBoard;
  AThread: TThreadItem; ARangearray: TRangeArray; Point: TPoint);
begin
  try
    Lock;
    FIdStr := AIdStr;
    SetThread(Athread);
    FStream := TDat2PopupView.Create(FBrowser);
    try
      FStream.DDOffsetLeft := DD_OFFSET_LEFT div 4;
      Make2chInfo(FStream, ATarget, BaseThread, ABoard, FThread, ARangearray);
      if not FStream.canceled and FBrowser.Trim then
        PopUp(Point)
      else
        Release;
    finally
      FreeAndNil(FStream);
    end;
  finally
    UnLock;
  end;
end;

procedure TPopupViewItem.ShowTextInfo(AIdStr: String; Text: String;
  AThread: TThreadItem; HTML: Boolean; Point: TPoint);
begin
  try
    Lock;
    FIdStr := AIdStr;
    SetThread(Athread);
    FStream := TDat2PopupView.Create(FBrowser);
    try
      if HTML then
        FStream.WriteHTML(text)
      else
        FStream.WriteText(text);
      FStream.Flush;
      if not FStream.canceled and FBrowser.Trim then
        PopUp(Point)
      else
        Release;
    finally
      FreeAndNil(FStream);
    end;
  finally
    UnLock;
  end;
end;

function TPopupViewItem.ExtractKeyword(AIdStr: String; AThread: TThreadItem;
  Target: String; Max: Integer;Point: TPoint): Integer;
begin
  try
    Lock;
    FIdStr := AIdStr;
    SetThread(AThread);
    FStream := TDat2PopupView.Create(FBrowser);
    Result := 0;
    try
      FStream.DDOffsetLeft := DD_OFFSET_LEFT div 4;
      Result := _ExtractKeyWord(FThread, FStream, Target, Max);
      if not FStream.canceled and FBrowser.Trim then
        PopUp(Point)
      else
      begin
        Result := 0;
        Release;
      end;
    finally
      FreeAndNil(FStream);
    end;
  finally
    UnLock;
  end;
end;


(*=======================================================*)

{ TPopupViewList }

//|bvAbvXgĕێAɃJ[\ړɂ
//|bvAbv̔ANeBuAǗ

constructor TPopupViewList.Create;
begin
  inherited;
  FTimer := TTimer.Create(nil);
  FTimer.Enabled := False;
  FTimer.Interval := 100;
  FTimer.OnTimer := FTimerTimer;
  FList := TList.Create;
  FAppEvent := TApplicationEvents.Create(nil);
  FAppEvent.OnMessage := nil;
end;

destructor TPopupViewList.Destroy;
begin
  FAppEvent.Free;
  Clear(True);
  FList.Free;
  FTimer.Free;
  inherited;
end;

procedure TPopupViewList.Clear(Force: Boolean);
begin
  if (FList.Count > 0) and ((not Items[0].Enabled) or Force) then
  begin
    while Count > 0 do
      Items[Count - 1].Release;
    FList.Clear;
    FTimer.Enabled := False;
    FAppEvent.OnMessage := nil;
    Change;
  end;
end;

function TPopupViewList.GetItems(index: integer): TPopupViewItem;
begin
  Result := TPopupViewItem(FList.Items[index]);
end;

function TPopupViewList.GetCount: Integer;
begin
  Result := FList.Count;
end;

function TPopupViewList.Add(Item: TPopupViewItem): Integer;
begin
  //PopupViewList́APopup̌nێłȂB
  //قȂnItemaddꂽƂ́AXn
  if (Count > 0) and (Item.BaseItem <> Items[0].BaseItem) then
    Clear(True);
  Result := FList.Add(Item);
  if Result = 0 then
  begin
    if not GetCursorPos(FPrevPoint) then
      FPrevPoint := Point(-1, -1);
    FTimer.Enabled := True;
    FAppEvent.OnMessage := FAppEventMessage;
    FAppEvent.Activate;
  end;
  Change;
end;

function TPopupViewList.Extract(Item: TPopupViewItem): TPopupViewItem;
begin
  Result := TPopupViewItem(FList.Extract(Item));
  if FList.Count = 0 then
  begin
    FTimer.Enabled := False;
    FAppEvent.OnMessage := nil;
  end;
end;

procedure TPopupViewList.Confirm(Point: TPoint);
var
  i: Integer;
  Top: Integer;
  Browser: TPopUpTextView;
  ClientPoint: TPoint;
  ClientPrev: TPoint;
  NotInRootControl: Boolean;
  ControlAtCursor: TWinControl;
  RootControl: TWinControl;
  function OwnerConfirm(item: TPopupViewItem): Boolean;
  begin
    item.OwnerCofirmation := item.OwnerCofirmation and
      Assigned(item.OwnerView) and
      (item.OwnerView.GetDerivativeBrowser = ControlAtCursor);
    result := item.OwnerCofirmation;
  end;
begin
  if (Count = 0) or ((FPrevPoint.X = Point.X) and (FPrevPoint.Y = Point.Y)) then
    Exit;

  Top := -1;
  for i := Count - 1 downto 0 do
  begin
    if items[i].Enabled then
    begin
      Top := i;
      Break;
    end;
  end;

  ControlAtCursor := FindVCLWindow(Point);

  //PositionBrowser܂ނǂ̔́AȂQB
  if Top >= 0 then
  begin
    OwnerConfirm(Items[Top]);
    Browser := Items[Top].FBrowser;
    ClientPoint := Browser.ScreenToClient(Point);
    ClientPrev  := Browser.ScreenToClient(FPrevPoint);
    if (not Items[Top].Locked) and (Browser <> GetCaptureControl) then
    begin
      if ((((ClientPoint.X < -2) or (ClientPoint.X >= Browser.Width - 2)) and
           (Abs(ClientPoint.X) > Abs(ClientPrev.X))
          ) or
          (((ClientPoint.Y < -2) or (ClientPoint.Y >= Browser.Height - 2)) and
           (Abs(ClientPoint.Y) > Abs(ClientPrev.Y))
          )
         ) then
      begin
        if not Items[Top].OwnerCofirmation then
          for i := Top downto 0 do
          begin
            Browser := Items[i].FBrowser;
            ClientPoint := Browser.ScreenToClient(Point);
            if (ClientPoint.X < -2) or (ClientPoint.X >= Browser.Width - 2) or
              (ClientPoint.Y < -2) or (ClientPoint.Y >= Browser.Height - 2) then
            begin
              Items[i].Enabled := False;
            end else
              Break;
          end;
      end else if (ClientPoint.X < -2) or (ClientPoint.X >= Browser.Width - 2) or
        (ClientPoint.Y < -2) or (ClientPoint.Y >= Browser.Height - 2) then
      begin
        if Assigned(Items[i].PossessionView) then
          Items[i].PossessionView.Release;
      end;
    end;
  end;

  RootControl := Items[0].RootControl;
  if (not Items[0].Enabled) and Assigned(RootControl) then
  begin
    NotInRootControl := True;
    while Assigned(ControlAtCursor) do
    begin
      if ControlAtCursor = RootControl then
      begin
        NotInRootControl := False;
        Break;
      end;
      ControlAtCursor := ControlAtCursor.Parent;
    end;
    if NotInRootControl then
      Clear(True);
  end;

  FPrevPoint := Point;

end;

procedure TPopupViewList.FTimerTimer(Sender: TObject);
var
  P: TPoint;
begin
  if GetCursorPos(P) then
    Confirm(P);
end;

procedure TPopupViewList.FAppEventMessage(var Msg: tagMSG; var Handled: Boolean);
begin
  case Msg.message of
    WM_MOUSEMOVE, WM_NCMOUSEMOVE: Confirm(Mouse.CursorPos);
  end;
end;

procedure TPopupViewList.Change;
begin
  if Assigned(FOnChange) then
    FOnChange(Self);
end;

(*=======================================================*)

(* destɎw肳ꂽXo͂ *) //thread.addref͌ĂяoӔC
procedure Make2chInfo(dest: TDatOut; URI: string; basethread: TThreadItem;
                      board: TBoard; thread: TThreadItem; RangeArray: TRangeArray);

  procedure MakeThreadInfo(dest: TDatOut);
  var
    dat: TThreadData;
    ThreadURL: String;
    i: Integer;
  begin
    if (thread <> basethread) or (rangearray[0].st = -1) then
    begin
      ThreadURL := thread.ToURL;
      dest.WriteAnchor('', ThreadURL, PChar(ThreadURL), Length(ThreadURL));
      dest.WriteText(#13#10 +
           TCategory(TBoard(thread.board).category).name + ' ['
         + TBoard(thread.board).name + ']@g'
         + HTML2String(thread.title) + 'h' + #13#10#13#10);
    end;
    if Config.hintForOtherThread or (thread = BaseThread) then
    begin
      dat := thread.DupData;
      try
      if RangeArray[0].st >= 0 then
        for i := 0 to Length(RangeArray) - 1 do
          POPUPD2HTML.PickUpRes(dest, dat, thread.ABoneArray, RangeArray[i].st, RangeArray[i].ed);
      finally
        dat.Free;
      end;
    end;
  end;
  
begin
  if board <> nil then
  begin
    if thread <> nil then
      MakeThreadInfo(dest)
    else
    begin
      //񂾂\
      dest.WriteAnchor('', URI, PChar(URI), Length(URI));
      dest.WriteText(#13#10 + TCategory(board.category).name + ' [' + board.name + ']');
    end;
  end else
    MakeThreadInfo(dest);
  dest.Flush;
end;

end.
