unit UWriteForm;
(* ݉ *)
(* Copyright (c) 2001,2002 Twiddle <hetareprog@hotmail.com> *)

interface

uses
  Windows,
  Messages,
  SysUtils,
  Variants,
  Classes,
  Graphics,
  Controls,
  Forms,
  Dialogs,
  ExtCtrls,
  ComCtrls,
  StdCtrls,
  DateUtils,
  ActnList,
  Menus,
  {$IFDEF IE}
  OleCtrls,
  SHDocVw_TLB,
  MSHTML_TLB,
  {$ELSE}
  HogeTextView,
  UTVSub,
  {$ENDIF}
  StrUtils,
  IniFiles,
  U2chThread,
  U2chBoard,
  HTTPSub,
  IdBaseComponent,
  IdComponent,
  IdTCPConnection,
  IdTCPClient,
  IdHTTP,
  IdCookie,
  IdURI,
  JConfig,
  UDat2HTML,
  UViewItem,
  UAsync,
  UXTime,
  U2chTicket,
  ULocalCopy,
  StrSub,
  UCrypt,
  jconvert, Buttons;

const
  AGREEMENT_FILENAME = 'Agreement.txt';

type
  TPostType = (postNormal, postCheck);
  TFormType = (formWrite, formBuild);

  TWriteForm = class(TForm)
    PageControl: TPageControl;
    TabSheetMain: TTabSheet;
    Panel1: TPanel;
    TabSheetLocalRule: TTabSheet;
    EditNameBox: TComboBox;
    Label1: TLabel;
    Label2: TLabel;
    EditMailBox: TComboBox;
    CheckBoxSage: TCheckBox;
    Memo: TMemo;
    Panel2: TPanel;
    Panel3: TPanel;
    ButtonCancel: TButton;
    TabSheetResult: TTabSheet;
    Result: TMemo;
    ThreadTitlePanel: TPanel;
    RecordCheckBox: TCheckBox;
    CheckBoxTop: TCheckBox;
    EditSubjectBox: TEdit;
    TitleLabel: TLabel;
    SubjectPanel: TPanel;
    Panel4: TPanel;
    TabSheetPreview: TTabSheet;
    ActionList: TActionList;
    writeActWrite: TAction;
    writeActCancel: TAction;
    writeActFocusThread: TAction;
    AAList: TListBox;
    writeActShowAAList: TAction;
    TabSheetSettingTxt: TTabSheet;
    SettingTxt: TMemo;
    WStatusBar: TStatusBar;
    ButtonWrite: TBitBtn;
    ButtonChangePrevVisiblity: TButton;
    MemoPrevAgreement: TMemo;
    SplitterPrevAgreement: TSplitter;

    procedure PageControlChange(Sender: TObject);
    procedure CheckBoxSageClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormDeactivate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure ButtonCancelClick(Sender: TObject);
    procedure ButtonWriteClick(Sender: TObject);
    procedure FormHide(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    function Hook(var Message: TMessage): Boolean;
    procedure MemoKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure RecordCheckBoxClick(Sender: TObject); //521
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure CheckBoxTopClick(Sender: TObject);
    procedure writeActFocusThreadExecute(Sender: TObject);
    procedure AAListMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure writeActShowAAListExecute(Sender: TObject);
    procedure AAListKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure AAListExit(Sender: TObject);
    procedure MemoChange(Sender: TObject);
    procedure WStatusBarDrawPanel(StatusBar: TStatusBar;
      Panel: TStatusPanel; const Rect: TRect);
    function IsShortCut(var Message: TWMKey): Boolean; override;
    procedure EditBoxChange(Sender: TObject);
    procedure ButtonChangePrevVisiblityClick(Sender: TObject);
  private
    { Private 錾 }
    savedTop : integer;
    savedLeft : integer;
    savedWidth: integer;
    savedHeight: integer;
    gotRule: TProgState;
    procGet: TAsyncReq;
    procPost: TAsyncReq;
    storedRule: TLocalCopy;
    writeRetryCount: Integer;
    cookieRetryCount: Integer;
    postType: TPostType;
    postCode: string;
    FlagPostAgreement: Boolean;
    FlagSaveAgreement: Boolean;
    Field2chAgreement: String;
    AgreementText: String;
    PreviousAgreement: String;
    kakikomiFile: TFileStream;
    formType: TFormType;
    LoadText: TStringList;
    {$IFDEF IE}
    WebBrowser: TWebBrowser;
    Preview: TWebBrowser;
    {$ELSE}
    TextView: THogeTextView;
    Preview: THogeTextView;
    {$ENDIF}
    LocalRuleViewItem: TFlexViewItem;
    PreviewItem: TFlexViewItem;
    HideOnApplicationMinimize: Boolean; //beginner
    gotSettingTxt: TProgState;
    storedSettingTxt: TLocalCopy;
    procGetSettingTxt: TAsyncReq;
    BBSLineNumber: Integer;
    BBSMessageCount: Integer;
    BBSSubjectCount: Integer;
    BBSNameCount: Integer;
    BBSMailCount: Integer;
    PanelColor: array[0..2] of TColor;  //pl̐m
    procedure GetSettingTxt;
    procedure OnSettingTxt(sender: TAsyncReq);
    procedure PostArticle;
    procedure GetLocalRule;
    procedure ProcCookie(Cookies: TIdCookies);
    procedure OnNotify(sender: TAsyncReq; code: TAsyncNotifyCode);
    procedure OnWritten(sender: TAsyncReq);
    procedure OnLocalRule(sender: TAsyncReq);
    procedure WriteLocalRule(const localRule: string);
    procedure WritePreview;
    procedure MakePreview;
    {$IFDEF IE}
    procedure WebBrowserDocumentComplete(Sender: TObject;
      const pDisp: IDispatch; var URL: OleVariant);
    procedure PreviewBrowserDocumentComplete(Sender: TObject;
      const pDisp: IDispatch; var URL: OleVariant);
    {$ENDIF}
    procedure RequestToGetLocalRule;
    procedure PasteAAListItem;
    function IsAgreementTextUpdated(Text: String): Boolean;
    procedure PreparePostAgreement(const Text: String; ShowPrev: Boolean);
    procedure CancelAgreement;
    procedure SaveAgreement;
    function GetPrevVisible: Boolean;
    procedure SetPrevVisible(Value: Boolean);
    property PrevVisible: Boolean read GetPrevVisible write SetPrevVisible;
  protected
    procedure CreateParams(var Params: TCreateParams); override;
    function Res2Dat: string;

  public
    { Public 錾 }
    freeReserve: boolean;  //ݒύXfp̉\
    thread: TThreadItem;
    board: TBoard;
    procedure Show(threadItem: TThreadItem); overload;
    procedure Show(boardItem: TBoard); overload;
    class function Trip(const Key: string): string;
    function SavedBoundsRect:TRect; //beginner
    procedure MainWndOnHide; //beginner
    procedure MainWndOnShow; //beginner
  end;

var
  WriteForm: TWriteForm;

(*=======================================================*)
implementation
(*=======================================================*)

uses
  Main;

{$R *.dfm}

const
  BBS_LINE_NUMBER   = 'BBS_LINE_NUMBER';
  BBS_MESSAGE_COUNT = 'BBS_MESSAGE_COUNT';
  BBS_SUBJECT_COUNT = 'BBS_SUBJECT_COUNT';
  BBS_NAME_COUNT    = 'BBS_NAME_COUNT';
  BBS_MAIL_COUNT    = 'BBS_MAIL_COUNT';

(* ݉۔p̃bZ[WoCg *)
//rɃk܂܂s=CRLFSJISp
function MessageCount(Msg: String): Integer;
var
  p: PChar;
Label
  PermanentLoop;
begin
  Result := Length(Msg);
  p := PChar(Msg);
  PermanentLoop: //ɗ͌y邽gotoLoop
  begin
    case p^ of
      #0: Exit; //肱ꂾȂ̂Œ
      #13:
        begin
          Inc(p, 2);
          Inc(Result, 4);
        end;
      '>', '<':
        begin
          Inc(p);
          Inc(Result, 3);
        end;
      #$81..#$9f, #$e0..#$fc:
        Inc(p, 2);
      '"':
        begin
          Inc(p);
          Inc(Result, 5);
        end;
      else
        Inc(p);
    end;
  end;
  goto PermanentLoop;
end;


(* [J[ASETTING.TXT擾Avr[LbN *)
procedure TWriteForm.PageControlChange(Sender: TObject);
var
  ActiveTab: TTabSheet;
begin
  (*  *)
  ActiveTab := PageControl.Pages[PageControl.ActivePageIndex];

  if ActiveTab = TabSheetLocalRule then
    GetLocalRule
  else if ActiveTab = TabSheetSettingTxt then
    GetSettingTxt
  else if ActiveTab = TabSheetPreview then
    MakePreview;
  CancelAgreement;
end;

(* ^XNo[ *)
procedure TWriteForm.CreateParams(var Params: TCreateParams);
begin
  inherited;
  if FormStyle in [fsNormal, fsStayOnTop] then
    if BorderStyle in [bsSingle, bsSizeable] then
      if Config.wrtFmUseTaskBar then
      begin
        Params.ExStyle := Params.ExStyle or WS_EX_APPWINDOW;
        Params.WndParent := 0;
      end else
        Params.ExStyle := Params.ExStyle and (not WS_EX_APPWINDOW);
end;

(* ̏ *)
procedure TWriteForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Action := caFree;
  WriteForm := nil;
end;

(* őOʂ *)
procedure TWriteForm.CheckBoxTopClick(Sender: TObject);
begin
  if Visible then //\̂CreateEShowȊO͂ňʒuETCYۑ
    SavedBoundsRect;
  Config.wrtFormStayOnTop := CheckBoxTop.Checked;
  if Config.wrtFmUseTaskBar then
  begin
    SetWindowLong(self.Handle, GWL_HWNDPARENT, 0);
    if CheckBoxTop.Checked then
      FormStyle := fsStayOnTop
    else
      FormStyle := fsNormal;
  end
  else begin
    SetWindowLong(self.Handle, GWL_HWNDPARENT, MainWnd.Handle);
    FormStyle := fsNormal;
  end
end;

(* SAGE *)
procedure TWriteForm.CheckBoxSageClick(Sender: TObject);
begin
  if CheckBoxSage.Checked then
  begin
    EditMailBox.Text := 'sage';
    EditMailBox.Enabled := false;
  end
  else begin
    EditMailBox.Text := '';
    EditMailBox.Enabled := true;
  end;
end;

(* OE[L`FbN *)//521
procedure TWriteForm.RecordCheckBoxClick(Sender: TObject);
begin
  Config.wrtRecordNameMail := RecordCheckBox.checked;
end;

(*  *)
procedure TWriteForm.FormCreate(Sender: TObject);

  procedure KeyConf;
  var
    ini: TMemIniFile;
    i: integer;

    procedure SetShortCut(action: TAction);
    var
      key: string;
    begin
      key := ini.ReadString('KEY', action.Name, '');
      if key = '' then
        exit;
      action.ShortCut := TextToShortCut(key);
      if (action.ShortCut = 0) and (length(key) > 1)then
      try
        action.ShortCut := StrToInt(key);
      except
      end;
    end;
  begin
    if not FileExists(Config.BasePath + KEYCONF_FILE) then
      exit;
    ini := TMemIniFile.Create(Config.BasePath + KEYCONF_FILE);
    for i := 0 to ActionList.ActionCount -1 do
      SetShortCut(TAction(ActionList.Actions[i]));
    ini.Free;
  end;

  procedure LoadAAlist;
  var
    index: integer;
  begin
    index := 0;
    LoadText := TStringList.Create;
    if  (FileExists(IncludeTrailingPathDelimiter(Config.BasePath) + AALIST_FILE))  then
      LoadText.LoadFromFile(IncludeTrailingPathDelimiter(Config.BasePath) + AALIST_FILE);
    if LoadText.count <= 0 then
      exit;
    while (CompareStr('[aalist]', LoadText[index]) <> 0) do
    begin
      Inc(index);
      if LoadText.Count - 1 <= index then
        exit;
    end;
    Inc(index);
    while (index < LoadText.Count) and not(StartWith('[', LoadText[index], 1)) do
    begin
      AAList.Items.Add(LoadText[index]);
      Inc(Index);
    end;
  end;
var
  font: TFont;
begin
  savedLeft := 0;
  savedTop  := 0;
  savedWidth := 0;
  savedHeight := 0;
  writeRetryCount := 0;
  cookieRetryCount := 0;
  postType := postNormal;
  postCode := '';
  board := nil;
  thread := nil;
  procGet := nil;
  procPost := nil;
  {$IFDEF IE}
  WebBrowser := TWebBrowser.Create(TabSheetLocalRule);
  TOleControl(WebBrowser).Parent := TabSheetLocalRule;
  with WebBrowser do
  begin
    Align := alClient;
    OnBeforeNavigate2  := MainWnd.WebBrowserBeforeNavigate2;
    OnDownloadComplete := MainWnd.WebBrowserDownloadComplete;
    OnDocumentComplete := WebBrowserDocumentComplete;
    OnStatusTextChange := MainWnd.WebBrowserStatusTextChange;
  end;
  Preview := TWebBrowser.Create(TabSheetPreview);
  TOleControl(Preview).Parent := TabSheetPreview;
  with Preview do
  begin
    Align := alClient;
    OnBeforeNavigate2  := MainWnd.WebBrowserBeforeNavigate2;
    OnDownloadComplete := MainWnd.WebBrowserDownloadComplete;
    OnDocumentComplete := PreviewBrowserDocumentComplete;
    OnStatusTextChange := MainWnd.WebBrowserStatusTextChange;
  end;
  {$ELSE}
  TextView := THogeTextView.Create(TabSheetLocalRule);
  with TextView do
  begin
    Parent := TabSheetLocalRule;
    Align := alClient;
    Enabled := True;
    Visible := True;
    TabStop := True;
    LeftMargin := 8;
    TopMargin := 4;
    RightMargin := 8;
    ExternalLeading := 1;
    VerticalCaretMargin := 1;
    VScrollLines := 5;
    TextAttrib[1].style := [fsBold];
    TextAttrib[2].color := clBlue;
    TextAttrib[2].style := [fsUnderline];
    TextAttrib[3].color := clBlue;
    TextAttrib[3].style := [fsBold, fsUnderline];
    TextAttrib[4].color := clRed;
    TextAttrib[5].color := clGreen;
    OnMouseMove  := MainWnd.OnBrowserMouseMove;
    OnMouseDown  := MainWnd.OnBrowserMouseDown;
    OnMouseHover := MainWnd.OnBrowserMouseHover;
  end;
  Preview := THogeTextView.Create(TabSheetPreview);
  with Preview do
  begin
    Parent := TabSheetPreview;
    Align := alClient;
    LeftMargin := 8;
    TopMargin := 4;
    RightMargin := 8;
    ExternalLeading := 1;
    VerticalCaretMargin := Config.viewVerticalCaretMargin;
    WheelPageScroll := Config.viewPageScroll;
    VScrollLines := Config.viewScrollLines;
    Font.Name := 'lr oSVbN';
    Color := RGB($ef, $ef, $ef);
    TextAttrib[1].style := [fsBold];
    TextAttrib[2].color := clBlue;
    TextAttrib[2].style := [fsUnderline];
    TextAttrib[3].color := clBlue;
    TextAttrib[3].style := [fsBold, fsUnderline];
    TextAttrib[4].color := clGreen;
    TextAttrib[5].color := clGreen;
    TextAttrib[5].style := [fsBold];
    OnMouseMove :=  MainWnd.OnBrowserMouseMove;
    OnMouseDown :=  MainWnd.OnBrowserMouseDown;
    OnMouseHover := MainWnd.OnBrowserMouseHover;
  end;
  {$ENDIF}
  PreviewItem := TFlexViewItem.Create;
  PreviewItem.PopUpViewList := Main.popupviewList;
  PreviewItem.browser := Preview;
  PreviewItem.RootControl := TabSheetPreview;

  LocalRuleViewItem := TFlexViewItem.Create;
  LocalRuleViewItem.PopUpViewList := Main.popupviewList;
  LocalRuleViewItem.browser := {$IFDEF IE} WebBrowser; {$ELSE} TextView; {$ENDIF}
  LocalRuleViewItem.RootControl := TabSheetLocalRule;

  if Config.viewDefFontInfo.face <> '' then
  begin
    font := TFont.Create;
    Config.SetFont(font, Config.viewDefFontInfo);
    Self.Font.Assign(font);
    font.Free;
  end;
  if Config.viewWriteFontInfo.face <> '' then
  begin
    font := TFont.Create;
    Config.SetFont(font, Config.viewWriteFontInfo);
    Memo.Font.Assign(font);
    font.Free;
  end;

  //[457]
  ThreadTitlePanel.Color := MainWnd.ThreadToolPanel.Color;
  ThreadTitlePanel.Font := MainWnd.ThreadTitleLabel.Font;

  storedRule := nil;
  storedSettingTxt := nil;
  //CEBhẼV[gJbg𖳌
  Application.HookMainWindow(hook);
  KeyConf;
  CheckBoxTop.Enabled := Config.wrtFmUseTaskBar;

  EditNameBox.Items := Config.wrtNameList;
  EditMailBox.Items := Config.wrtMailList;

  LoadAAlist;

  HideOnApplicationMinimize := False; //beginner

  freeReserve := false;
end;

(* []\ *)
procedure TWriteForm.FormActivate(Sender: TObject);
begin
  if WindowState<>wsMaximized then begin
    if 0 < savedWidth then
      Width := savedWidth;
    if 0 < savedHeight then
      Height := savedHeight;
  end;

  //XEBhEANeBuIMEL
  SetImeMode(Handle, userImeMode);
end;

(* זɂȂȂ悤ɂ *)
procedure TWriteForm.FormDeactivate(Sender: TObject);
begin
  if WindowState<>wsMinimized then begin
    savedLeft   := Left;
    savedTop    := Top;
    savedWidth  := Width;
    savedHeight := Height;
    if not Config.wrtFmUseTaskBar then
      Height := 10;
  end;

  //XEBhEtH[JXOƂIMEԂۑ
  SaveImeMode(Handle);
end;

(* \ *)
procedure TWriteForm.Show(threadItem: TThreadItem);
begin
  if assigned(thread) then
  begin
    SetFocus;
  end
  else begin
    thread := threadItem;
    thread.AddRef;
  end;
  formType := formWrite;
  board := TBoard(thread.board);

  //XpEBhE̕\Ԑݒ
  Self.Caption := 'w' + HTML2String(thread.title) + 'x ɃX';
  ThreadTitlePanel.Visible := Config.wrtShowThreadTitle;
  SubjectPanel.Visible := false;
  ThreadTitlePanel.Caption := 'y' + StringReplace(thread.GetBoardName + 'z - ' + HTML2String(thread.title), '&', '&&', [rfReplaceAll]);
  RecordCheckBox.Enabled := true;
  PageControl.ActivePage := TabSheetMain;

  //Oƃ[
  //521 LName/Mail{bNX
  RecordCheckBox.checked := Config.wrtRecordNameMail;
  CheckBoxSage.Checked := false;
  //O
  if thread.UsedWriteMail <> '' then
    EditNameBox.Text := thread.UsedWriteName
  else if (thread.UsedWriteMail = '') and // LĂȂX(LꂽXɂ͕K!)
          Config.wrtUseDefaultName and (Config.wrtNameList.Count > 0) then
    EditNameBox.Text := Config.wrtNameList[0]
  else
    EditNameBox.Text := '';
  //[
  if thread.UsedWriteMail <> '' then
    EditMailBox.Text := thread.UsedWriteMail
  else if (thread.UsedWriteMail = '') and Config.wrtDefaultSageCheck then
    EditMailBox.Text := 'sage'
  else
    EditMailBox.Text := '';
  if AnsiStartsStr('!',EditMailBox.Text) then
    EditMailBox.Text := Copy(EditMailBox.Text, 2, length(EditMailBox.Text) - 1);

  CheckBoxTop.Checked := Config.wrtFormStayOnTop;
  if Config.wrtFmUseTaskBar and not CheckBoxTop.Checked then
    FormStyle := fsNormal;

  inherited Show;
end;

(* XĎ̕\ *)
procedure TWriteForm.Show(boardItem: TBoard);
begin
  if assigned(board) then
  begin
    SetFocus;
  end
  else begin
    board := boardItem;
  end;
  formType := formBuild;
  thread := nil;

  //XėpEBhE̕\Ԑݒ
  Self.Caption := 'y' + board.name + 'z ɐVKXbh';
  SubjectPanel.Visible := true;
  ThreadTitlePanel.Visible := false;
  EditSubjectBox.Text := '';
  RecordCheckBox.Enabled := false;
  PageControl.ActivePage := TabSheetLocalRule;

  //Oƃ[
  if (Config.wrtUseDefaultName) and (Config.wrtNameList.Count <>0) then
    EditNameBox.Text := Config.wrtNameList[0]
  else
    EditNameBox.Text := '';
  if Config.wrtDefaultSageCheck then
    EditMailBox.Text := 'sage'
  else
    EditMailBox.Text := '';

  CheckBoxTop.Checked := Config.wrtFormStayOnTop;
  if Config.wrtFmUseTaskBar and not CheckBoxTop.Checked then
    FormStyle := fsNormal;

  inherited Show;
end;

(* \ *)
procedure TWriteForm.FormShow(Sender: TObject);
var
  NeedSETTINGTXT: Boolean;
begin
  if not HideOnApplicationMinimize then
    begin
    //XEXċ
    if EditMailBox.Text = 'sage' then
    begin
      EditMailBox.Enabled := false;
      CheckBoxSage.Checked := true;
    end
    else begin
      EditMailBox.Enabled := true;
      CheckBoxSage.Checked := false;
    end;
    ButtonWrite.Enabled := true;
    TabSheetResult.TabVisible := (procPost <> nil);
    gotRule := tpsNone;
    gotSettingTxt := tpsNone;
    postType := postNormal;
    postCode := '';

    if Config.wrtDisableStatusBar then
      WStatusBar.Hide
    else
      WStatusBar.Show;

    {beginner} //ۑꂽʒuATCYɈړ
    if (Config.wrtFormTop >= 0) and (Config.wrtFormLeft >= 0) and
       (Config.wrtFormHeight >= 0) and (Config.wrtFormWidth >= 0) then
      BoundsRect := Bounds(Config.wrtFormLeft, Config.wrtFormTop,
                    Config.wrtFormWidth, Config.wrtFormHeight);
    {/beginner}

    //[JS]
    if EditNameBox.CanFocus then
      EditNameBox.SetFocus;
    if Memo.CanFocus then
      Memo.SetFocus;
    if PageControl.ActivePage = TabSheetLocalRule then
      GetLocalRule;

    CheckBoxTopClick(Sender);

    //SETTING.TXT
    FreeAndNil(storedSettingTxt);
    NeedSETTINGTXT := False;
    BBSLineNumber := 0;
    BBSMessageCount := 0;
    BBSSubjectCount := High(Integer);
    BBSNameCount := High(Integer);
    BBSMailCount := High(Integer);
    SettingTxt.Clear;
    try
      storedSettingTxt := TLocalCopy.Create(board.GetLogDir + '\setting.txt', '.idb');
      if storedSettingTxt.Load then
      begin
        SettingTxt.Text := storedSettingTxt.DataString;
        BBSLineNumber := StrToIntDef(SettingTxt.Lines.Values[BBS_LINE_NUMBER], 0);
        BBSMessageCount := StrToIntDef(SettingTxt.Lines.Values[BBS_MESSAGE_COUNT], 0);
        BBSSubjectCount := StrToIntDef(SettingTxt.Lines.Values[BBS_SUBJECT_COUNT], BBSSubjectCount);
        BBSNameCount := StrToIntDef(SettingTxt.Lines.Values[BBS_NAME_COUNT], BBSNameCount);
        BBSMailCount := StrToIntDef(SettingTxt.Lines.Values[BBS_MAIL_COUNT], BBSMailCount);
        if (storedSettingTxt.Info.Count = 0) or
           (storedSettingTxt.Info[0] <> board.GetURIBase + '/SETTING.TXT') then
          NeedSETTINGTXT := True;
        if storedSettingTxt.Updated + 30 < Now then
          NeedSETTINGTXT := True;
      end else
        NeedSETTINGTXT := True;
    finally
      FreeAndNil(storedSettingTxt);
    end;
    if (board.GetBBSType = bbs2ch) and NeedSETTINGTXT then
      GetSettingTxt;

    MemoChange(nil);
    CancelAgreement;
  end;
end;

(* ߂ *)
procedure TWriteForm.ButtonCancelClick(Sender: TObject);
begin
  if (GetKeyState(VK_ESCAPE) < 0) and (AAList.Visible) then
  begin
    AAList.Hide;
    Memo.SetFocus
  end else
    Visible := False;
end;

(* JLR *)
procedure TWriteForm.ButtonWriteClick(Sender: TObject);
var
  WarningList: TStringList;
  ActView: TViewItem;
  Lines: Integer;
begin

  //݌x֌W
  WarningList := nil;
  try
    WarningList := TStringList.Create;
    if not Config.netOnline then
      WarningList.Add('ItCłB');

    if EditNameBox.Text = '' then
    begin
     if pos('fusianasan', SettingTxt.Lines.Values['BBS_NONAME_NAME']) > 0 then
        WarningList.Add('̔̃ftHg̖fusianasan(IP\)łB')
      else if SettingTxt.Lines.Values['NANASHI_CHECK'] = '1' then
        WarningList.Add('O͂̔łB');
    end;

    if Config.wrtDiscrepancyWarning then
    begin
      if formType = formWrite then
      begin
        ActView := MainWnd.GetActiveView;
        if Assigned(ActView) and (ActView.thread <> thread) then
          WarningList.Add(Format('XƈႤƂu%svɏ݂܂B', [thread.title]));
      end else
      begin
        if (MainWnd.currentBoard <> board) then
           WarningList.Add(Format('XꗗƈႤƂu%svɃXĂ܂B', [board.name]));
      end;
    end;

    if formType = formBuild then
      if Length(EditSubjectBox.Text) <= 0 then
        WarningList.Add('X^CłB')
      else if MessageCount(EditSubjectBox.Text) > BBSSubjectCount then
        WarningList.Add('X^CłB');
    if MessageCount(EditNameBox.Text) > BBSNameCount then
      WarningList.Add('OłB');
    if MessageCount(EditMailBox.Text) > BBSMailCount then
      WarningList.Add('[łB');

    if Length(Memo.Text) <= 0 then
      WarningList.Add('bZ[WłB')
    else if (BBSMessageCount > 0) and (MessageCount(Memo.Text) > BBSMessageCount) then
      WarningList.Add('bZ[WłB');

    Lines := Memo.Lines.Count;
    if (Memo.Text <> '') and (Memo.Text[Length(Memo.Text)] = #10) then
      Inc(Lines);
    if (BBSLineNumber > 0) and (Lines > BBSLineNumber * 2) then
      WarningList.Add('słB');

    if WarningList.Count > 0 then
    begin
      WarningList.Add('');
      WarningList.Add('݂܂H');
      // MessageDlgƍőOʃtH[ɉBĂ܂
      if MessageBox(self.Handle, PChar(WarningList.Text), 'x', MB_ICONEXCLAMATION or MB_OKCANCEL) <> IDOK then
        Exit;
    end;
  finally
    WarningList.Free;
  end;

  if not Config.netOnline then
    MainWnd.actOnLineExecute(nil);

  if (postType = postCheck) and Memo.Modified then
    postType := postNormal;
  writeRetryCount := 0;
  cookieRetryCount := 0;
  Result.Clear;
  PostArticle;
  Memo.Modified := false;
  //VtgĂ烊Xgɒǉ
  if GetKeyState(VK_SHIFT) < 0 then
  begin
    if Config.wrtNameList.IndexOf(EditNameBox.Text) < 0 then
    begin
      Config.wrtNameList.Add(EditNameBox.Text);
      EditNameBox.Items := Config.wrtNameList;
    end;
    if not CheckBoxSage.Checked and (Config.wrtMailList.IndexOf(EditMailBox.Text) < 0) then
    begin
      Config.wrtMailList.Add(EditMailBox.Text);
      EditMailBox.Items := Config.wrtMailList;
    end;
    Config.Modified := true;
  end;
  if formType = formWrite then
  begin
    Config.wrtRecordNameMail := RecordCheckBox.checked; //521 NameEMail̋LEŏI
    if RecordCheckBox.checked then
    begin
      thread.UsedWriteName := EditNameBox.Text;
      thread.UsedWriteMail := '!' + EditMailBox.Text;
      thread.SaveIndexData;
    end;
  end;
end;

procedure TWriteForm.PostArticle;
var
  URI: string;
  encName, encMail: string;
  postDat: string;
  URIObj: TIdURI;
  referer: string;
  list: TStringList;
  cookie: string;
begin
  if board.timeValue <= 0 then
    board.timeValue := timeValue; //N
  case board.GetBBSType of
  bbs2ch, bbsOther:
    begin
      encName := URLEncode(EditNameBox.Text);
      encMail := URLEncode(EditMailBox.Text);
      case formType of
      formWrite:
        begin
          case postType of
          postNormal:
            begin
              URI := 'http://' + board.host + '/test/bbs.cgi';
              postDat := 'submit=' + URLEncode('')
                       + '&FROM=' + encName
                       + '&mail=' + encMail
                       + '&MESSAGE=' + URLEncode(Memo.Text)
                       + '&bbs='  + board.bbs
                       + '&key='  + ChangeFileExt(thread.datName, '')
                       + '&time=' + IntToStr(board.timeValue);
            end;
          postCheck:
            begin
              URI := 'http://' + board.host + '/test/subbbs.cgi';
              postDat := 'bbs='  + board.bbs
                       + '&key='  + ChangeFileExt(thread.datName, '')
                       + '&time=' + IntToStr(board.timeValue)
                       + '&subject='
                       + '&FROM=' + encName
                       + '&mail=' + encMail
                       + '&MESSAGE=' + URLEncode(Memo.Text)
                       + '&code='  + postCode
                       + '&submit=' + URLEncode('SӔC𕉂Ƃď');
            end;
          end;
        end;
      formBuild:
        begin
          case postType of
          postNormal:
            begin
              URI := 'http://' + board.host + '/test/bbs.cgi';
              postDat := 'subject=' + URLEncode(EditSubjectBox.Text)
                       + '&submit=' + URLEncode('VKXbh쐬')
                       + '&FROM=' + encName
                       + '&mail=' + encMail
                       + '&MESSAGE=' + URLEncode(Memo.Text)
                       + '&bbs='  + board.bbs
                       + '&time=' + IntToStr(board.timeValue);
            end;
          postCheck:
            begin
              URI := 'http://' + board.host + '/test/subbbs.cgi';
              postDat := 'subject=' + URLEncode(EditSubjectBox.Text)
                       + '&FROM=' + encName
                       + '&mail=' + encMail
                       + '&MESSAGE=' + URLEncode(Memo.Text)
                       + '&bbs='  + board.bbs
                       + '&time=' + IntToStr(board.timeValue)
                       + '&submit=' + URLEncode('SӔC𕉂Ƃď');
            end;
          end;
        end;
      end;
      postDat := postDat + ticket2ch.GetSID(URI, '&');
    end;
  bbsJBBSShitaraba:
    begin
      encName := URLEncode(sjis2euc(EditNameBox.Text));
      encMail := URLEncode(sjis2euc(EditMailBox.Text));
      URI := 'http://' + Config.bbsJBBSServers[0] + '/bbs/write.cgi';
      case formType of
      formWrite:
        begin
          postDat := 'submit=' + URLEncode(sjis2euc(''))
                   + '&NAME=' + encName
                   + '&MAIL=' + encMail
                   + '&MESSAGE=' + URLEncode(sjis2euc(Memo.Text))
                   + '&DIR=' + GetJBBSShitarabaCategory(board.host)
                   + '&BBS='  + board.bbs
                   + '&KEY='  + ChangeFileExt(thread.datName, '')
                   + '&TIME=' + IntToStr(UTC);
        end;
      formBuild:
        begin
          postDat := 'SUBJECT=' + URLEncode(sjis2euc(EditSubjectBox.Text))
                   + '&submit=' + URLEncode(sjis2euc('VK'))
                   + '&NAME=' + encName
                   + '&MAIL=' + encMail
                   + '&MESSAGE=' + URLEncode(sjis2euc(Memo.Text))
                   + '&DIR=' + GetJBBSShitarabaCategory(board.host)
                   + '&BBS='  + board.bbs
                   + '&TIME=' + IntToStr(UTC);
        end;
      end;
    end;
  bbsMachi, bbsJBBS:
    begin
      encName := URLEncode(EditNameBox.Text);
      encMail := URLEncode(EditMailBox.Text);
      URI := 'http://' + board.host + '/bbs/write.cgi';
      case formType of
      formWrite:
        begin
          postDat := 'submit=' + URLEncode(sjis2euc(''))
                   + '&NAME=' + encName
                   + '&MAIL=' + encMail
                   + '&MESSAGE=' + URLEncode(Memo.Text)
                   + '&BBS='  + board.bbs
                   + '&KEY='  + ChangeFileExt(thread.datName, '')
                   + '&TIME=' + IntToStr(UTC);
        end;
      formBuild:
        begin
          postDat := 'SUBJECT=' + URLEncode(EditSubjectBox.Text)
                   + '&submit=' + URLEncode(sjis2euc('VK'))
                   + '&NAME=' + encName
                   + '&MAIL=' + encMail
                   + '&MESSAGE=' + URLEncode(Memo.Text)
                   + '&BBS='  + board.bbs
                   + '&TIME=' + IntToStr(UTC);
        end;
      end;
    end;
  {bbsOther:
    begin
      encName := URLEncode(EditNameBox.Text);
      encMail := URLEncode(EditMailBox.Text);
      URI := 'http://' + board.host + '/test/bbs.cgi';
      case formType of
      formWrite:
        begin
          postDat := 'submit=' + URLEncode('')
                   + '&FROM=' + encName
                   + '&mail=' + encMail
                   + '&MESSAGE=' + URLEncode(Memo.Text)
                   + '&bbs='  + board.bbs
                   + '&key='  + ChangeFileExt(thread.datName, '')
                   + '&time=' + IntToStr(UTC);
        end;
      formBuild:
        begin
          postDat := 'subject=' + URLEncode(EditSubjectBox.Text)
                   + '&submit=' + URLEncode('VKXbh쐬')
                   + '&FROM=' + encName
                   + '&mail=' + encMail
                   + '&MESSAGE=' + URLEncode(Memo.Text)
                   + '&bbs='  + board.bbs
                   + '&time=' + IntToStr(UTC);
        end;
      end;
    end;}
  end;

  if FlagPostAgreement then
  begin
    if Config.wrtAdditionalAgreementField <> Field2chAgreement then
    begin
      Config.wrtAdditionalAgreementField := Field2chAgreement;
      Config.Modified := True;
    end;
    postDat := postDat + Config.wrtAdditionalAgreementField;
    SaveAgreement;
  end;

  URIObj := nil;
  try
    URIObj := TIdURI.Create(board.GetURIBase + '/');
    referer := URIObj.URI;
  finally
    URIObj.Free;
  end;
  cookie := 'Cookie: NAME=' + encName + '; MAIL=' + encMail;
  list := TStringList.Create;
  if (board.GetBBSType = bbs2ch) and (0 < length(Config.tstWrtCookie)) then
  begin
    {if Pos('=', Config.tstWrtCookie) < 0 then
      list.Add('Cookie: SPID=' + Config.tstWrtCookie + ';')
    else}
      cookie := cookie + '; ' + Config.tstWrtCookie;
  end;
  list.Add(cookie);
  procPost := Main.AsyncManager.Post(URI, postDat, referer, list,
                                     OnWritten, OnNotify);
  if procPost <> nil then
  begin
    ButtonWrite.Enabled := false;
    Result.Lines.Add('--------------------');
    Result.Lines.Add('ݒEEE');
    Result.Lines.Add('--------------------');
    TabSheetResult.TabVisible := true;
    PageControl.ActivePage := TabSheetResult;
  end;
  list.Free;
end;

procedure TWriteForm.OnNotify(sender: TAsyncReq; code: TAsyncNotifyCode);
begin
  case code of
  ancPRECONNECT:
    begin
      ticket2ch.On2chPreConnect(sender, code);
      sender.IdHTTP.AllowCookies := True;
    end;
  ancPRETERMINATE:
    if procPost = sender then
      Windows.Sleep(1000); (* 炢҂Ă݂eXg *)
  end;
end;

procedure TWriteForm.ProcCookie(Cookies: TIdCookies);
var
  i: Integer;
  List: TStringList;
  S: String;
begin
  List := TStringList.Create;
  try
    List.Text := ReplaceStr(Config.tstWrtCookie, ';', #13#10);
    for i := 0 to Cookies.Count -1 do
    begin
      if (Cookies[i].CookieName <> 'NAME') and (Cookies[i].CookieName <> 'MAIL')
        and (List.Values[Cookies[i].CookieName] <> Cookies[i].Value) then
      begin
        Config.Modified := True;
        List.Values[Cookies[i].CookieName] := Cookies[i].Value;
      end;
    end;
    if List.Text <> '' then
    begin
      s := ReplaceStr(List.Text, #13#10, ';');
      Config.tstWrtCookie := Copy(s, 1, Length(s) - 1);
    end else
      Config.tstWrtCookie := '';
  finally
    List.Free;
  end;
end;

function LineCount(S: String): Integer;
var
  L: TStringList;
begin
  L := TStringList.Create;
  try
    L.Text := S;
    Result := L.Count;
  finally
    L.Free;
  end;
end;

function MemoCount(Memo: TMemo): Integer;
var
  Txt: String;
  L: Integer;
begin
  Result := Memo.Lines.Count;
  Txt := Memo.Text;
  L := Length(Txt);
  if (L > 0) and (Txt[L] = #10) then
    Inc(Result);
end;

procedure SplitAgreement(const HTML: String; var PostText, Agreement: String);
var
  TagUL, TagULE: Integer;
begin
  TagUL := FindPos('<ul>', HTML, 1);
  if TagUL > 0 then
  begin
    TagULE := FindPos('</ul>', HTML, TagUL + 4);
    if TagULE > 0 then
    begin
      PostText := HTML2String(Copy(HTML, TagUL + 4, TagULE - TagUL - 5));
      Agreement := HTML2String(Copy(HTML, 1, TagUL - 1) + Copy(HTML, TagULE + 5, MaxInt));
    end;
  end;
end;

procedure GetFormFieldItems(const HTML: String; List: TStrings);
var
  Tag: TTagAttrList;
  p, e: PChar;
  inForm: Integer;
begin
  p := PChar(HTML);
  e := p + Length(HTML);

  Tag := TTagAttrList.Create;
  try
    inForm := 0;
    while p < e do
    begin
      if p^ = '<' then
      begin
        Tag.SetTagData(p, e - p);
        if Tag.Name = 'form' then
          Inc(inForm)
        else
        if Tag.Name = '/form' then
        begin
          if inForm > 0 then
            Dec(inForm);
        end else
        if (inForm > 0) and (Tag.Name = 'input') then
          List.Values[Tag.Values['name']] := Tag.Values['value'];
        Inc(p, Tag.Length);
      end else
        Inc(p);
    end;
  finally
    Tag.free;
  end;
end;

procedure TWriteForm.OnWritten(sender: TAsyncReq);
var
  responseHTML: string;

  function GetErrMsg: string;
  var
    errPos, limit: integer;
  begin
    result := '';
    if responseHTML = '' then
      exit;
    limit := FindPosIC('<head>', responseHTML, 1);
    if limit > 0 then
    begin
      errPos := FindPosIC('2ch_X:', responseHTML, 1, limit);
      if errPos > 0 then
      begin
        errPos := errPos + 6;
        limit := FindPos('-->', responseHTML, errPos, limit);
        result := trim(copy(responseHTML, errPos, limit - errPos));
      end;
    end;
  end;

  procedure SetPostCode;
  var
    codePos: integer;
  begin
    if responseHTML = '' then
      exit;
    codePos := FindPos('code value=', responseHTML, 1);
    if codePos > 0 then
    begin
      codePos := codePos + 11;
      //Ƌcode擾
      postCode := copy(responseHTML, codePos, FindPos('>', responseHTML, codePos) - codePos);
    end;
    postType := postCheck;
    Result.Lines.Add('--------------------');
    Result.Lines.Add('mFxuށvĂEEE');
    Result.Lines.Add('--------------------');
    ButtonWrite.Enabled := true;
  end;

  function GetAgreementFieldItems(const HTML: String; Items: TStringList): String;
  const
    PreparedFieldItems: array[0..7] of String = ('subject', 'FROM', 'mail', 'MESSAGE', 'bbs', 'time', 'key', 'submit');
  var
    i: Integer;
    idx: Integer;
  begin
    Items.CaseSensitive := False;
    GetFormFieldItems(HTML, Items);
    for i := Low(PreparedFieldItems) to High(PreparedFieldItems) do
    begin
      idx := Items.IndexOfName(PreparedFieldItems[i]);
      if idx >= 0 then
        Items.Delete(idx);
    end;
    Result := '';
    if Items.Count > 0 then
    begin
      for i := 0 to Items.Count - 1 do
        Result := Result + '&' + Items[i];
    end;
  end;

var
  i: integer;
  viewItem: TViewItem;
  responseText: string;
  list: TStringList;
  kakikomistr: TStringList;
  errMsg: string;
  tempTime: integer;
  Agreement, PostText: String;
  newAgreementList: TStringList;
begin
  if procPost <> sender then
    exit;
  procPost := nil;
  if Config.tstCommHeaders then
  begin
    //Log('--------------------');
    //Log(postDat);
    Log('--------------------');
    Log(sender.IdHTTP.ResponseText);
    Log('--------------------');
  end;

  tempTime := DateTimeToUnix(Str2DateTime(sender.GetDate));
  if board.timeValue > tempTime then
    board.timeValue := tempTime
  else
    Inc(board.timeValue); //Âbbs.cgi2dJLR[vɂȂȂ悤

  responseHTML := sender.GetString;
  if board.GetBBSType = bbsJBBSShitaraba then
    responseHTML := euc2sjis(responseHTML);
  responseText := HTML2String(responseHTML);

  Visible := true;
  TabSheetResult.TabVisible := true;
  PageControl.ActivePage := TabSheetResult;

  if (sender.IdHTTP.ResponseCode = 200) then
  begin

    list := TStringList.Create;
    list.Text := responseText;
    for i := 0 to list.Count -1 do
      Result.Lines.Add(list.Strings[i]);
    if (2 <= list.Count) and
       AnsiStartsStr('dqqnqI', list[0]) and
       AnsiStartsStr('ēxOCĂˁBBB', list[1]) and
       (writeRetryCount < 1) then
    begin
      list.Free;
      Inc(writeRetryCount);
      ticket2ch.Reset;
      Result.Lines.Add('--------------------');
      Result.Lines.Add('OCĎsEEE');
      Result.Lines.Add('--------------------');
      PostArticle;
      exit;
    end;

    errMsg := GetErrMsg;
    if (errMsg = 'error') then
    begin
      list.Free;
      ButtonWrite.Enabled := true;
      exit;
    end;
    if (board.GetBBSType = bbs2ch) and ((errMsg = 'cookie') or
        ((2 <= list.Count) and AnsiContainsStr(list[0], 'NbL[mFI'))) and
       (cookieRetryCount < 1) then
    begin
      list.Free;
      Inc(cookieRetryCount);
      ProcCookie(sender.IdHTTP.CookieManager.CookieCollection);
      Result.Lines.Add('');
      Result.Lines.Add('');
      SplitAgreement(responseHTML, PostText, Agreement);
      newAgreementList := TStringList.Create;
      try
        Field2chAgreement := GetAgreementFieldItems(responseHTML, newAgreementList);
        if (LineCount(PostText) <> MemoCount(Memo) + 7) or IsAgreementTextUpdated(Agreement)
          or (Field2chAgreement <> Config.wrtAdditionalAgreementField) then
        begin
          if Field2chAgreement <> Config.wrtAdditionalAgreementField then
          begin
            Result.Lines.Add('--------------------------------------');
            Result.Lines.Add('ӃtH[ɍXVAǉꂽe');
            Result.Lines.AddStrings(newAgreementList);
            Result.Lines.Add('--------------------------------------');
            Result.Lines.Add('');
          end;
          Result.Lines.Add('--------------------------------');
          Result.Lines.Add('݂ɂ͓ӂKvEEE');
          Result.Lines.Add('--------------------------------');
          PreparePostAgreement(Agreement, True);
          Result.Lines.Add('');
        end else
        begin
          Result.Lines.Add('--------------------------------');
          Result.Lines.Add('KɕύXȂEEE');
          Result.Lines.Add('--------------------------------');
          if Config.wrtAutoAgreement then
          begin
            FlagPostAgreement := True;
            FlagSaveAgreement := False;
            PostArticle;
          end else
            PreparePostAgreement(Agreement, False);
        end;
      finally
        newAgreementList.Free;
      end;
      exit;
    end;

    if (errMsg = 'check') or
       ((2 <= list.Count) and AnsiContainsStr(list[1], '݊mF')) then
    begin
      list.Free;
      SetPostCode;
      exit;
    end;

    if not (((errMsg <> '') and ((errMsg = 'true') or (errMsg = 'false'))) or
            ((errMsg =  '') and (list.Count > 0) and
                                 (AnsiContainsStr(list[0], '݂܂') or
                                  AnsiContainsStr(list[0], '݂܂'))))then
    begin
      list.Free;
      ButtonWrite.Enabled := true;
      exit;
    end;
    list.Free;
  end
  else if (sender.IdHTTP.ResponseCode = 302) then //炭Oł̐
  begin
    Result.Lines.Add('߂EEE');
    Result.Lines.Add('--------------------');
    Log('iͥjݶӥ');
  end
  else begin
    Result.Lines.Add('݂Ɏs͗l');
    Result.Lines.Add('--------------------');
    Result.Lines.Add(sender.IdHTTP.ResponseText);
    Result.Lines.Add('--------------------');
    ButtonWrite.Enabled := true;
    exit;
  end;


//ȍ~ݐ

  ProcCookie(sender.IdHTTP.CookieManager.CookieCollection);
  board.timeValue := tempTime;

  if thread <> nil then
  begin
    thread.LastWrote := DateTimeToUnix(Now);
    thread.SaveIndexData;

    //ݗۑ
    if Config.wrtRecordWriting then
    begin
      if not FileExists(Config.BasePath + 'kakikomi.txt') then
      try
        FileClose(FileCreate(Config.BasePath + 'kakikomi.txt'));
      except
      end;
      if kakikomiFile = nil then
      try
        kakikomiFile := TFileStream.Create(Config.BasePath + 'kakikomi.txt',
                                 fmOpenReadWrite or fmShareDenyWrite);
      except
      end;

      kakikomistr := TStringList.Create;
      try
        kakikomistr.Add('--------------------------------------------');
        kakikomistr.Add('Date   : ' + DateToStr(Date) + ' ' + TimeToStr(Time));
        kakikomistr.Add('Subject: ' + thread.title);
        kakikomistr.Add('URL    : ' + thread.ToURL(false));
        kakikomistr.Add('FROM   : ' + EditNameBox.Text);
        kakikomistr.Add('MAIL   : ' + EditMailBox.Text);
        kakikomistr.Add('');
        kakikomistr.AddStrings(Memo.Lines);
        kakikomistr.Add('');
        kakikomistr.Add('');

        kakikomiFile.Seek(0, soFromEnd);
        kakikomiFile.Write(PChar(kakikomistr.Text)^, length(kakikomistr.Text));
      finally
        kakikomistr.Free;
      end;
    end;

    viewItem := viewList.FindViewItem(thread);
    if viewItem <> nil then
      viewItem.NewRequest(thread, gotCHECK, -1, True, Config.oprCheckNewWRedraw);
  end;

  if errMsg = 'false' then
  begin
    Caption := 'ӂoĂ܂';
    exit;
  end;

  if Config.tstCloseAfterWriting then begin
    HideOnApplicationMinimize := False;
    Visible := False;
  end;
end;

(* 悤Ɍ鎞̏ *)
procedure TWriteForm.FormHide(Sender: TObject);
begin
  if not HideOnApplicationMinimize then
  begin
    SavedBoundsRect;
    if procPost = nil then
    begin
      board := nil;
      if assigned(thread) then
        thread.Release;
      thread := nil;
      Result.Clear;
    end;
    procGetSettingTxt := nil;
    FreeAndNil(storedSettingTxt);
    gotSettingTxt := tpsNone;
  end;
end;


(* [J[擾B *)
procedure TWriteForm.GetLocalRule;
{$IFDEF IE}
var
  URL, flag: OleVariant;
begin
  if gotRule <> tpsNone then
    exit;
  LocalRuleViewItem.thread := nil;
  LocalRuleViewItem.Base := '';
  gotRule := tpsProgress;
  URL := 'about:blank';
  flag := $0E;
  WebBrowser.Navigate2(URL, flag);
  (* ̂WebBrowserDocumentCompleteĂ΂ *)
end;
{$ELSE}
begin
  LocalRuleViewItem.thread := nil;
  LocalRuleViewItem.Base := board.GetURIBase + '/';
  TextView.HoverTime := Config.hintHoverTime;
  if gotRule <> tpsNone then
    exit;
  TextView.Clear;
  RequestToGetLocalRule;
end;
{$ENDIF}

{$IFDEF IE}

(* JLRôŃ[J[ǂ݂ɍs *)
(* hCV[PV *)
procedure TWriteForm.WebBrowserDocumentComplete(Sender: TObject;
  const pDisp: IDispatch; var URL: OleVariant);
begin
  (*  *)
  if gotRule = tpsProgress then
    RequestToGetLocalRule;
end;

{$ENDIF}

procedure TWriteForm.RequestToGetLocalRule;
var
  URI: string;
  lastModified: string;
begin
  lastModified := '';
  if storedRule = nil then
  begin
    storedRule := TLocalCopy.Create(board.GetLogDir + '\head.txt', '.idb');
    storedRule.Load;
    if 2 <= storedRule.Info.Count then
      lastModified := storedRule.Info.Strings[1];
  end;
  if not Config.netOnline then
  begin
    WriteLocalRule(storedRule.DataString);
    storedRule.Free;
    storedRule := nil;
    gotRule := tpsDone;
    LocalRuleViewItem.Base := board.GetURIBase + '/';
    exit;
  end;
  gotRule := tpsWorking;
  URI := board.GetURIBase + '/head.txt';
  procGet := AsyncManager.Get(URI, OnLocalRule, ticket2ch.On2chPreConnect,
                              lastModified);
end;


(* [J[擾nh *)
procedure TWriteForm.OnLocalRule(sender: TAsyncReq);
begin
  if procGet = sender then
  begin
    case sender.IdHTTP.ResponseCode of
    200: (* OK *)
      begin
        storedRule.Clear;
        storedRule.WriteString(sender.Content);
        storedRule.Info.Add('');
        storedRule.Info.Add(sender.GetLastModified);
        storedRule.Save;
      end;
    304: (* Not Modified *)
      begin
      end;
    else
      begin
        storedRule.Clear;
      end;
    end;
    WriteLocalRule(storedRule.DataString);
    procGet := nil;
    storedRule.Free;
    storedRule := nil;
    gotRule := tpsDone;
    LocalRuleViewItem.Base := board.GetURIBase + '/';
  end;
end;

(* [J[`敔 *)
procedure TWriteForm.WriteLocalRule(const localRule: string);
{$IFDEF IE}
var
  URL, flag: OleVariant;
begin
  (* ɗL锤 *)
  if Assigned(WebBrowser.Document) then
  begin
    OleVariant(WebBrowser.Document as IHTMLDocument2).write('<html><body>'#13#10);
    if Config.viewDefFontInfo.face <> '' then
    begin
      OleVariant(WebBrowser.Document as IHTMLDocument2)
        .write('<font face="' + Config.viewDefFontInfo.face + '">');
    end;

    OleVariant(WebBrowser.Document as IHTMLDocument2).write(localRule);
    OleVariant(WebBrowser.Document as IHTMLDocument2).write('</body></html>'#13#10);
    URL := 'JavaScript:location.reload()';
    flag := $0E;
    WebBrowser.Navigate2(URL, flag);
  end;
end;
{$ELSE}
var
  ht2v: TSimpleDat2View;
begin
  ht2v := TSimpleDat2View.Create(TextView);
  ht2v.WriteHTML(localRule);
  ht2v.Flush;
  ht2v.Free;
end;
{$ENDIF}


//SETTING.TXT擾
procedure TWriteForm.GetSettingTxt;
var
  URI: string;
  lastModified: string;
begin
  if (gotSettingTxt <> tpsNone) or not Config.netOnline then
    exit;
  lastModified := '';
  if storedSettingTxt = nil then
  begin
    storedSettingTxt := TLocalCopy.Create(board.GetLogDir + '\setting.txt', '.idb');
    storedSettingTxt.Load;
    if 2 <= storedSettingTxt.Info.Count then
      lastModified := storedSettingTxt.Info.Strings[1];
  end;
  gotSettingTxt := tpsWorking;
  URI := board.GetURIBase + '/SETTING.TXT';
  procGetSettingTxt := AsyncManager.Get(URI, OnSettingTxt, ticket2ch.On2chPreConnect,
                              lastModified);
end;

//SETTING.TXT擾nh
procedure TWriteForm.OnSettingTxt(sender: TAsyncReq);
var
  lastModified: string;
begin
  if procGetSettingTxt = sender then
  begin
    case sender.IdHTTP.ResponseCode of
      200: (* OK *)
        begin
          storedSettingTxt.Clear;
          storedSettingTxt.WriteString(StringReplace(sender.Content, #10, #13#10, [rfReplaceAll]));
          storedSettingTxt.Info.Add(board.GetURIBase + '/SETTING.TXT');
          storedSettingTxt.Info.Add(sender.GetLastModified);
          storedSettingTxt.Save;
          SettingTxt.Text := storedSettingTxt.DataString;
          BBSLineNumber   := StrToIntDef(SettingTxt.Lines.Values[BBS_LINE_NUMBER], 0);
          BBSMessageCount := StrToIntDef(SettingTxt.Lines.Values[BBS_MESSAGE_COUNT], 0);
          BBSSubjectCount := StrToIntDef(SettingTxt.Lines.Values[BBS_SUBJECT_COUNT], High(Integer));
          BBSNameCount    := StrToIntDef(SettingTxt.Lines.Values[BBS_NAME_COUNT], High(Integer));
          BBSMailCount    := StrToIntDef(SettingTxt.Lines.Values[BBS_MAIL_COUNT], High(Integer));
          MemoChange(nil);
        end;
      304: (* NotModified̎ĕۑ邱ƂōŏI`FbNXV *)
        begin
          lastModified := '';
          if storedSettingTxt.Info.Count >= 2 then
            lastModified := storedSettingTxt.Info.Strings[1];
          storedSettingTxt.Info.Clear;
          storedSettingTxt.Info.Add(board.GetURIBase + '/SETTING.TXT');
          storedSettingTxt.Info.Add(lastModified);
          storedSettingTxt.Save;
        end;
    end;
    FreeAndNil(storedSettingTxt);
    procGetSettingTxt := nil;
    gotSettingTxt := tpsDone;
  end;
end;


procedure TWriteForm.FormDestroy(Sender: TObject);
begin
  if storedRule <> nil then
    storedRule.Free;
  if storedSettingTxt <> nil then
    storedSettingTxt.Free;
  PreviewItem.Free;
  LocalRuleViewItem.Free;
  {$IFDEF IE}
  if Assigned(WebBrowser) then
    WebBrowser.OnStatusTextChange := nil;
  WebBrowser.Free;
  if Assigned(Preview) then
    Preview.OnStatusTextChange := nil;
  Preview.Free;
  {$ELSE}
  TextView.Free;
  Preview.Free;
  {$ENDIF}
  //RenXgۑ
  //if FileExists(Config.BasePath + 'name.dat') then
  //  EditNameBox.Items.SaveToFile(Config.BasePath + 'name.dat');
  if kakikomiFile <> nil then
    kakikomiFile.Free;
  //悭킩Ȃǈꉞ
  Application.UnhookMainWindow(Hook);
  LoadText.Free;
end;


//Tipsɂ܂
function TWriteForm.Hook(var Message: TMessage): Boolean;
begin
  case Message.Msg of
  CM_APPKEYDOWN:
     Result := True;  // V[gJbg𖳌ɂ
  CM_APPSYSCOMMAND:
     Result := True;  // ANZ[^𖳌ɂ
  else
     Result := False;
  end;
end;

procedure TWriteForm.MemoKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  case Key of
  Ord('A'):
    begin
      if ssCtrl in Shift then
        Memo.SelectAll;
    end;
  end;
end;

{------------------------------------------------------------------------}
{------------------------------------------------------------------------}

class function TWriteForm.Trip(const Key: string): string;
{----------------------------------
$salt = substr($key."H.", 1, 2);//<--ǂ
$salt =~ s/[^\.-z]/\./go;
$salt =~ tr/:;<=>?@[\\]^_`/ABCDEFGabcdef/;
-----------------------------------}
  function MakeSalt(const Key: string): string;
  var
    i: Integer;
  begin
    Result := Copy(Copy(Key, 2, 2) + 'H.', 1, 2);

    for i := 1 to Length(Result) do
    begin
      if ( Ord(Result[i]) < Ord('.') ) or ( Ord('z') < Ord(Result[i]) ) then
        Result[i] := '.';

      if ((Ord(':') <= Ord(Result[i])) and (Ord(Result[i]) <= Ord('@'))) then
        Result[i] := Char(Ord(Result[i]) - Ord(':') + Ord('A'))
      else if ((Ord('[') <= Ord(Result[i])) and (Ord(Result[i]) <= Ord('`'))) then
        Result[i] := Char(Ord(Result[i]) - Ord('[') + Ord('a'));
    end;
  end;
var
  Salt: string;
begin
  if Key = '' then
  begin
    Result := '#';
  end else
  begin
    Salt := MakeSalt(Key);
    Result := ' ' + Copy(crypt(Key, Salt), 4, 10);
  end;
end;

{------------------------------------------------------------------------}


function TWriteForm.Res2Dat: string;
  function HtmlPost(const S: string):string;
  begin
    Result := S;
    Result := AnsiReplaceStr(Result, '<', '&lt;');
    Result := AnsiReplaceStr(Result, '>', '&gt;');
    Result := AnsiReplaceStr(Result, #13#10, '<br>');
    Result := AnsiReplaceStr(Result, #13, '<br>');
    Result := AnsiReplaceStr(Result, #10, '<br>');
  end;
  function NameConv(const S: string):string;
  begin
    Result := HtmlPost(S);
    Result := AnsiReplaceStr(Result, '', '');
    Result := AnsiReplaceStr(Result, '', '');
    if AnsiPos('#', Result) > 0 then
    begin
      Result := Copy(Result, 1, AnsiPos('#', Result) - 1) + '</b>'
        + Trip(Copy(Result,AnsiPos('#', Result) + 1, Length(Result))) + ' <b>';
    end;
    if AnsiPos('', Result) > 0 then
    begin
      Result := Copy(Result, 1, AnsiPos('', Result) - 1) + '</b>'
        + Trip(Copy(Result,AnsiPos('', Result) + 2, Length(Result))) + ' <b>';
    end;
    if not Config.tstAuthorizedAccess then
    begin
      Result := AnsiReplaceStr(Result, '', '');
    end;
    Result := AnsiReplaceStr(Result, '"', '&quot;');
  end;
  function MailConv(const S: string):string;
  begin
    Result := HtmlPost(S);
    if AnsiPos('#', Result) > 0 then
    begin
      Result := Copy(Result, 1, AnsiPos('#', Result) - 1);
    end;
    if AnsiPos('', Result) > 0 then
    begin
      Result := Copy(Result, 1, AnsiPos('', Result) - 1);
    end;
    Result := AnsiReplaceStr(Result, '"', '&quot;');
  end;
  function MessageConv(const S: string):string;
  begin
    Result := HtmlPost(S);
    Result := AnsiReplaceStr(Result, '"', '&quot;');
  end;
var
  aName, aMail, aDate, aMessage: string;
  p1, p2: PChar;
  tmp: String; //beginner
  strList: TStringList;
  tmpdate: TDateTime;
begin
  if EditNameBox.Text <> '' then
  begin
    if board.GetBBSType = bbs2ch then
      aName := StringReplace(EditNameBox.Text, '&r', '', [rfReplaceAll])
    else
      aName := EditNameBox.Text;
  end else
    aName := SettingTxt.Lines.Values['BBS_NONAME_NAME'];

  aMail := EditMailBox.Text;

  strList := TStringList.Create;
  strList.Delimiter := '/';
  tmp := SettingTxt.Lines.Values['BBS_YMD_WEEKS'];
  if tmp <> '' then
    strList.DelimitedText := tmp
  else
    strList.DelimitedText := '//////y';
  tmpdate := Now;
  try
    aDate := FormatDateTime('yyyy"/"mm"/"dd("%s") hh":"nn":"ss', tmpdate);
    aDate := Format(aDate, [strList.Strings[DayOfWeek(tmpdate) - 1]]);
  except
    aDate := FormatDateTime('yyyy"/"mm"/"dd hh":"nn":"ss', tmpdate);
  end;
  strList.Free;

  if SameText(SettingTxt.Lines.Values['BBS_FORCE_ID'], 'checked') then
    aDate := aDate + ' ID:xxxxxxxxxx'
  else if (SettingTxt.Lines.Values['BBS_NO_ID'] = '') or
          SameText(SettingTxt.Lines.Values['ID_DISP'], 'show') then
    if Length(aMail) = 0 then
      aDate := aDate + ' ID:xxxxxxxxxx'
    else
      aDate := aDate + ' ID:???';

  aMessage := Memo.Text;

  aName := NameConv(aName);
  aMail := MailConv(aMail);
  aMessage := MessageConv(aMessage);

  if Length(aName) = 0 then
    aName := '<b></b>';

  Result := aName + '<>'
          + aMail + '<>'
          + aDate + '<>'
          + aMessage + '<>' + #10;

  //Unicodeu̏
  if SameText(SettingTxt.Lines.Values['BBS_UNICODE'], 'change') then
  begin
    p1 := PChar(Result);
    SetLength(tmp, Length(Result));
    p2 := PChar(tmp);
    while True do
    begin
      if (p1^ = '&') and ((p1 + 1)^ ='#') then
      begin
        p2^ := #$81;
        inc(p2);
        p2^ := #$48;
        inc(p2);
        inc(p1, 2);
        while p1^ in ['0'..'9'] do
          inc(p1);
        if p1^ = ';' then
          inc(p1);
      end else
      begin
        if p1^ in LeadBytes then
        begin
          p2^ := p1^;
          inc(p1);
          inc(p2);
          p2^ := p1^;
          inc(p1);
          inc(p2);
        end else
        begin
          p2^ := p1^;
          if p1^ = #10 then
            Break;
          inc(p1);
          inc(p2);
        end;
      end;
    end;
    Result := copy(tmp, 1, p2 - PChar(tmp) + 1);
  end;
end;

function ZoomToPoint(zoom: integer): Integer;
begin
  result := -12; // 9;
  {case zoom of
  0: result := -9;
  1: result := -10;
  2: result := -12;
  3: result := -14;//521 -16
  4: result := -15;//521 -24
  end;}
end;

function ZoomToExternalLeading(zoom: integer): Integer;
begin
  result := 1;
  case zoom of
  0: result := 1;
  1: result := 2;
  2: result := 2;
  3: result := 3;
  4: result := 4;
  end;
end;

{$IFDEF IE}
procedure TWriteForm.PreviewBrowserDocumentComplete(Sender: TObject;
      const pDisp: IDispatch; var URL: OleVariant);
begin
  if URL = 'about:blank' then
    WritePreview;
end;
{$ENDIF}

procedure TWriteForm.MakePreview;
{$IFDEF IE}
var
  URL: OleVariant;
  flag: OleVariant;
begin
  PreviewItem.thread := thread;
  PreviewItem.Base := '';
  URL := 'about:blank';
  flag := $0E;
  Preview.Navigate2(URL, flag);
end;
{$ELSE}
begin
  PreviewItem.thread := thread;
  PreviewItem.Base := '';
  Preview.HoverTime := Config.hintHoverTime;
  Preview.Clear;
  WritePreview;
end;
{$ENDIF}

procedure TWriteForm.WritePreview;
  function MakeDummyDat(line: Integer):string;
  const
//  dummyDat : string = '<>sage<>01/01/01 00:00<> message <>'#10;
    dummyDat : string = '<><><><>'#10;
  begin
    Result := DupeString(dummyDat, line);
  end;
const
  {$IFDEF IE}
  HeaderSkin = '<html><body bgcolor=#efefef LINK="blue" VLINK="blue" ALINK="blue" ><font face="lr oSVbN"><dl>';
  {$ELSE}
  HeaderSkin = '<html><body><font face="lr oSVbN"><dl>';
  {$ENDIF}
var
  dat: TThreadData;
  ResSkin: string;
  {$IFDEF IE}
  TempStream: TWebOutBufferStream;
  size, res: OleVariant;
  {$ELSE}
  TempStream: TDat2View;
  {$ENDIF}
  PreviewD2HTML: TDat2HTML;
begin
  {$IFDEF IE}
  TempStream := TWebOutBufferStream.Create(Preview);
  if EditMailBox.Text='' then
    ResSkin := '<dt><font color=blue><u><b><PLAINNUMBER/></b></u></font> F<font color=forestgreen><b><NAME/></b></b></font>[<MAIL/>] F<DATE/></dt><dd><MESSAGE/><br><br></dd>'#10
  else
    ResSkin := '<dt><font color=blue><u><b><PLAINNUMBER/></b></u></font> F<font color=blue><u><b><NAME/></b></u></b></font>[<MAIL/>] F<DATE/></dt><dd><MESSAGE/><br><br></dd>'#10;
  {$ELSE}
  TempStream := TDat2View.Create(Preview);
  if EditMailBox.Text='' then
    ResSkin := '<dt><SA i=1><b><PLAINNUMBER/></b><SA i=0> F<SA i=2><b><NAME/></b></b><SA i=0>[<MAIL/>] F<DATE/></dt><dd><MESSAGE/><br><br></dd>'#10
  else
    ResSkin := '<dt><SA i=1><b><PLAINNUMBER/></b><SA i=0> F<SA i=1><b><NAME/></b></b><SA i=0>[<MAIL/>] F<DATE/></dt><dd><MESSAGE/><br><br></dd>'#10;
  {$ENDIF}

  PreviewD2HTML := TDat2HTML.Create(resSkin);
  dat := TThreadData.Create;
  try
    {$IFDEF IE}
    if Preview.Document = nil then
      exit;
    size := 2; // 5;
    try
      Preview.ExecWB(OLECMDID_ZOOM , OLECMDEXECOPT_DONTPROMPTUSER, size, res);
    except
    end;
    {$ELSE}
    Preview.ExternalLeading := ZoomToExternalLeading(Config.viewZoomSize);
    Preview.SetFont(Preview.Font.Name, ZoomToPoint(Config.viewZoomSize));
    {$ENDIF}
    TempStream.WriteHTML(HeaderSkin);
    TempStream.Flush;
    if Assigned(thread) then
    begin
      dat.Add(MakeDummyDat(thread.lines));
      dat.Add(Res2Dat);
      PreviewD2HTML.ToDatOut(TempStream, dat, thread.lines + 1, 1)
    end else
    begin
      dat.Add(Res2Dat);
      PreviewD2HTML.ToDatOut(TempStream, dat, 1, 1);
    end;
    //{$IFNDEF IE}
    //Preview.Invalidate;
    //{$ENDIF}
    TempStream.Flush;
  finally
    dat.Free;
    PreviewD2HTML.Free;
    TempStream.Free;
  end;
end;

procedure TWriteForm.writeActFocusThreadExecute(Sender: TObject);
begin
  MainWnd.MenuWndThreadClick(Self);
end;

//ۑp̈ʒuԂ(kłƂ͌̃TCYԂ)
function TWriteForm.SavedBoundsRect:TRect;
begin
  Result := BoundsRect;
  if WindowState <> wsMaximized then
  begin
    if 0 < savedWidth then
      Result.Right := Result.Left + savedWidth;
    if 0 < savedHeight then
      Result.Bottom := Result.Top + savedHeight;
  end;
  Config.wrtFormTop := Result.Top;
  Config.wrtFormLeft := Result.Left;
  Config.wrtFormHeight := Result.Bottom - Result.Top;
  Config.wrtFormWidth := Result.Right - Result.Left;
end;

//AvŏɎB(Main.pasTMainWnd.OnAboutToShowQ)
procedure TWriteForm.MainWndOnHide;
begin
  if Visible and (not Config.wrtFmUseTaskBar) then
  begin
    HideOnApplicationMinimize := True;
    Hide;
  end;
end;

//AvɕKvȂ畜(Main.pasTMainWnd.OnAboutToShowQ)
procedure TWriteForm.MainWndOnShow;
begin
  if HideOnApplicationMinimize and (not Config.wrtFmUseTaskBar) then
    Self.Show;
  HideOnApplicationMinimize := False;
end;

(* AA͎x *)
procedure TWriteForm.AAListMouseUp(Sender: TObject; Button: TMouseButton;
                                   Shift: TShiftState; X, Y: Integer);
begin
  if Button = mbLeft then
  begin
    if  (AAList.ItemIndex > -1) then
    begin
      PasteAAListItem;
    end;
    AAList.Hide;
    Memo.SetFocus;
  end;
end;

procedure TWriteForm.writeActShowAAListExecute(Sender: TObject);
var
  point: TPoint;
begin
  if 0 < AAList.Count then
  begin
    GetCaretPos(point);
    AAList.Top  := TabSheetMain.Top + Memo.Top + point.Y - Memo.Font.Height;
    if (self.Height < AAList.Top + AAList.Height + 30) and
       (AAlist.Height < AAList.Top) then
      AAList.Top  := TabSheetMain.Top + Memo.Top + point.Y - AAList.Height;
    AAList.Left := PageControl.Left+ TabSheetMain.Left + Memo.Left + point.X;
    if Memo.Width < point.X + AAList.Width + 30 then
      AAList.Left := AAlist.Left - point.X + Memo.Width - AAList.Width - 30;
    AAList.ItemIndex := 0;
    AAList.Show;
    AAList.SetFocus;
  end;
end;

procedure TWriteForm.AAListKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  if (Key = VK_ESCAPE) then
  begin
    AAList.Hide;
    Memo.SetFocus;
  end else
  if (Key = VK_RETURN) then
  begin
    if (AAList.ItemIndex > -2) then
    begin
      PasteAAListItem;
    end;
    AAList.Hide;
    Memo.SetFocus;
  end;
end;

procedure TWriteForm.AAListExit(Sender: TObject);
begin
  AAList.Hide;
end;

procedure TWriteForm.PasteAAListItem;
var
  text: string;
  index: integer;
begin
  text := AAList.Items[AAList.ItemIndex];
  if StartWith('*', text, 1) then
  begin
    index := 0;
    while (CompareStr('['+ Copy(text, 2, Length(text) - 1) + ']', LoadText[index]) <> 0) do
    begin
      Inc(index);
      if LoadText.Count - 1 <= index then
        exit;
    end;
    Inc(index);
    while not (StartWith('[', LoadText[index], 1)) do
    begin
      Memo.SelText := LoadText[index] + #13#10;
      if index < LoadText.Count - 1 then
        Inc(index)
      else
        break;
    end;
  end else
    Memo.SelText := text;
end;


//݃bZ[W̕AsJEg
procedure TWriteForm.MemoChange(Sender: TObject);
var
  tmpTxt: String;
  tmpColor: TColor;
  Lines: Integer;
  MsgCnt: Integer;
begin
  if not WStatusBar.Visible then
    Exit;

  Lines := Memo.Lines.Count;
  if (Memo.Text <> '') and (Memo.Text[Length(Memo.Text)] = #10) then
    Inc(Lines);

  tmpColor := Self.Color;
  if BBSLineNumber > 0 then
    if Lines > BBSLineNumber * 2 then
      tmpColor := $007f7fff
    else if Lines > BBSLineNumber then
      tmpColor := $007fffff;
  PanelColor[1] := tmpColor;

  tmpTxt := Format('%4d',[Lines]);
  if BBSLineNumber > 0 then
    WStatusBar.Panels[1].Text := Format('Lines: %4d/%4d',[Lines, BBSLineNumber * 2])
  else
    WStatusBar.Panels[1].Text := Format('Lines: %4d/ s',[Lines]);

  MsgCnt := MessageCount(Memo.Text);

  if (BBSMessageCount > 0) and (MsgCnt > BBSMessageCount) then
    PanelColor[0] := $007f7fff
  else
    PanelColor[0] := clBtnFace;

  tmpTxt := Format('%4d',[Length(Memo.Text)]);
  if BBSMessageCount > 0 then
    WStatusBar.Panels[0].Text := Format('Bytes: %6d/%6d',[MsgCnt, BBSMessageCount])
  else
    WStatusBar.Panels[0].Text := Format('Bytes: %6d/  s',[MsgCnt]);
end;

type TDummyControl = class(TControl); //܂Ȃ
procedure TWriteForm.EditBoxChange(Sender: TObject);
begin
  if (Sender = EditSubjectBox) and (MessageCount(EditSubjectBox.Text) > BBSSubjectCount) then
    EditSubjectBox.Color := $00dfdfff
  else
  if (Sender = EditNameBox) and (MessageCount(EditNameBox.Text) > BBSNameCount) then
    EditNameBox.Color := $00dfdfff
  else
  if (Sender = EditMailBox) and (MessageCount(EditMailBox.Text) > BBSMailCount) then
    EditMailBox.Color := $00dfdfff
  else
    TDummyControl(Sender).Color := clWindow;
end;

procedure TWriteForm.WStatusBarDrawPanel(StatusBar: TStatusBar;
  Panel: TStatusPanel; const Rect: TRect);
  function RealHeight(Font: TFont): Integer;
  var
    tm: TEXTMETRIC;
  begin
    if Font.Height >= 0 then
      result := Abs(Font.Height)
    else
    begin
      GetTextMetrics(StatusBar.Canvas.Handle, tm);
      result := Abs(Font.Height) + tm.tmInternalLeading;
    end;
  end;
var
  i: Integer;
  X, Y: Integer;
begin
  StatusBar.Canvas.Brush.Color := WStatusBar.Color;
  for i := Low(PanelColor) to High(PanelColor) do
  begin
    if Panel = StatusBar.Panels[i] then
    begin
      StatusBar.Canvas.Brush.Color := PanelColor[i];
      Break;
    end;
  end;
  X := Rect.Left + 4;
  Y := (Rect.Top + Rect.Bottom - RealHeight(StatusBar.Canvas.Font)) div 2 + 1;
  StatusBar.Canvas.TextRect(Rect, X, Y, Panel.Text);
end;

function TWriteForm.IsShortCut(var Message: TWMKey): Boolean;
begin
  if AAList.Visible and AAList.Focused then
    result := false
  else
    result := inherited IsShortCut(Message);
end;

procedure TWriteForm.PreparePostAgreement(const Text: String; ShowPrev: Boolean);
begin
  ButtonWrite.Enabled := True;
  ButtonWrite.Font.Color := clRed;
  ButtonWrite.Caption := 'ӂ(&W)';
  FlagPostAgreement := True;
  FlagSaveAgreement := True;
  AgreementText := Text;
  if ShowPrev then
  begin
    MemoPrevAgreement.Text := PreviousAgreement;
    ButtonChangePrevVisiblity.Visible := True;
    PrevVisible := True;
  end;
  ButtonWrite.SetFocus;
end;

procedure TWriteForm.CancelAgreement;
begin
  ButtonWrite.Caption := '(&W)';
  ButtonWrite.Font.Color := Font.Color;
  FlagPostAgreement := False;
  AgreementText := '';
  ButtonChangePrevVisiblity.Visible := False;
  PrevVisible := False;
end;

procedure TWriteForm.SaveAgreement;
var
  AgreementFile: TPSStream;
begin
  if FlagSaveAgreement then
  begin
    AgreementFile := TPSStream.Create(AgreementText);
    try
      AgreementFile.SaveToFile(Config.BasePath + AGREEMENT_FILENAME);
    except
      on e: Exception do
        Log('݋K̕ۑɎs... (' + e.Message + ')');
    end;
    AgreementFile.Free;
  end;
  FlagSaveAgreement := False;
end;

function TWriteForm.IsAgreementTextUpdated(Text: String): Boolean;
var
  AgreementFile: TPSStream;
begin
  AgreementFile := TPSStream.Create('');
  try
    try
      AgreementFile.LoadFromFile(Config.BasePath + AGREEMENT_FILENAME);
      PreviousAgreement := AgreementFile.DataString;
    except
      PreviousAgreement := '';
    end;
  finally
    AgreementFile.Free;
  end;
  Result :=(Text <> PreviousAgreement);
end;

function TWriteForm.GetPrevVisible: Boolean;
begin
  Result := MemoPrevAgreement.Visible;
end;

procedure TWriteForm.SetPrevVisible(Value: Boolean);
const
  ChangePrevVisiblityCaption: array[False..True] of String = ('r\', 'r\');
begin
  MemoPrevAgreement.Visible := Value;
  SplitterPrevAgreement.Top := MemoPrevAgreement.Height;
  SplitterPrevAgreement.Visible := Value;
  ButtonChangePrevVisiblity.Caption := ChangePrevVisiblityCaption[Value];
end;

procedure TWriteForm.ButtonChangePrevVisiblityClick(Sender: TObject);
begin
  PrevVisible := not PrevVisible;
end;

end.
